package extensions;
import java.awt.Desktop;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import java.io.BufferedWriter;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.net.Socket;
import java.net.URL;
import java.util.Calendar;
import java.util.Collections;
import java.util.HashSet;
import java.util.TreeSet;
import java.util.Iterator;
import java.util.TreeMap;
import java.util.Map;
import java.util.ArrayList;
import java.util.Date;
import java.util.Arrays;
import java.util.Set;
import java.util.Random;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;
import java.util.zip.GZIPInputStream;
import java.util.zip.InflaterInputStream;
import java.text.SimpleDateFormat;
import java.util.concurrent.ConcurrentHashMap;
import dareka.Main;
import dareka.common.Config;
import dareka.common.CloseUtil;
import dareka.common.FileUtil;
import dareka.common.Logger;
import dareka.common.DiskFreeSpace;
import dareka.extensions.Extension;
import dareka.processor.HttpHeader;
import dareka.processor.HttpRequestHeader;
import dareka.processor.HttpResponseHeader;
import dareka.processor.Resource;
import dareka.processor.URLResource;
import dareka.processor.StringResource;
import dareka.processor.TransferListener;
import dareka.processor.Processor;
import dareka.processor.impl.Cache;
import dareka.processor.impl.MovieIdSorter;
//---------------------------------------------------------------------------------------------
public class nlApiUtilExtension implements Extension, Processor, Runnable {
	private final Pattern SUPPORTED_PATTERN =Pattern.compile("^http://www\\.nicovideo\\.jp/cache/ids(?:\\?)?(.+)?$");
	private final String[] SUPPORTED_METHODS = new String[] { "GET", "POST" };
	private final String NLTITLE = "nlApiUtilExtension";
	private final String NLTITLE2 = "nlApiUtilEx";
	private final String NLTITLE3 = "nauEx";
	private final String VERSION = "rev16g";
	// Extension interface
	public Object queryInterface(Extension.Type type) {
		if (type == Extension.Type.Extension1)
			return (Extension) this;
		if (type == Extension.Type.Processor1)
			return (Processor) this;
		return null;
	}
	//	exntensioño[WԂB
	public String getVersionString() {
		loadFlag();
		return NLTITLE+" "+VERSION;
	}
	// HTTP̃\bh
	public String[] getSupportedMethods() {
		return SUPPORTED_METHODS;
	}
	//urlpattern
	public Pattern getSupportedURLAsPattern() {
		return SUPPORTED_PATTERN;
	}
	public String getSupportedURLAsString() {
		return null;
	}
	public nlApiUtilExtension(){}
	//---------------------------------------------------------------------------------------------
	//*************************************************************************************************
	//Extension
	//*************************************************************************************************
	//---------------------------------------------------------------------------------------------
	private final File ConfigFileNI = new File("./local/nlApiUtilExNGID.txt");
	private final File ConfigFileNT = new File("./local/nlApiUtilExNGTITLE.txt");
	private final File ConfigFileFa = new File("./local/nlApiUtilExFaMylist.txt");
	private final File ConfigFileInfi = new File("./local/nlApiUtilExInfiMylist.txt");
	private final File ConfigFileAMR = new File("./local/nlApiUtilExAutoMoveRule.xml");
	private final File ConfigFileCSS = new File("./local/nlApiUtilEx.css");
//	private final File ConfigFileFJ = new File("./local/fetched.json");
	private final File ConfigFileProp = new File("./config.properties");
	private final File FetcherFile = new File("./extensions/nlMovieFetcher.class");
	private final File FILEAMISWF = new File("./local/amline/amline.swf");
	private final File FILEAMIXML = new File("./local/amline/amline_data.xml");
	private final File FILEAMISET = new File("./local/amline/amline_settings.xml");
	private final Random rand = new Random();
	private long lastModifiedCofigProp = ConfigFileProp.lastModified();
	private long lastModifiedCofigNI = 0;//ConfigFileNI.lastModified();
	private long lastModifiedCofigNT = 0;//ConfigFileNT.lastModified();
	private long lastModifiedCofigNF = 0;//ConfigFileNT.lastModified();
	private long lastModifiedCofigFa = 0;//ConfigFileFa.lastModified();
	private long lastModifiedCofigInfi = 0;//ConfigFileInfi.lastModified();
	private long lastModifiedCofigCss = 0;//ConfigFileCSS.lastModified();
//	private long lastModifiedCofigFJ = 0;//ConfigFileFJ.lastModified();
	//---------------------------------------------------------------------------------------------
	private HashSet<Pattern> NGIDLIST = new HashSet<Pattern>();
	private HashSet<Pattern> NGTITLELIST = new HashSet<Pattern>();
	//---------------------------------------------------------------------------------------------
	private ArrayList<String> FAMYLISTLIST = new ArrayList<String>();
	private ArrayList<String> INFIMYLISTLIST = new ArrayList<String>();
	private ArrayList<String> FETCHLIST = new ArrayList<String>();
	private ArrayList<String> FETCHINGLIST = new ArrayList<String>();
	//---------------------------------------------------------------------------------------------
	private ArrayList<String> FetchingAddList = new ArrayList<String>();
//	private Integer cacheSmNum = 0;
//	private Integer cacheSmLowNum = 0;
//	private Integer cacheSmTmpNum = 0;
//	private Integer fetchNum = 0;
	//---------------------------------------------------------------------------------------------
	private HashSet<Pattern> FALIST_MY_PAT = new HashSet<Pattern>();
	private HashSet<Pattern> INFILIST_SM_PAT = new HashSet<Pattern>();
	private HashSet<Pattern> DEFMYLIST_PAT = new HashSet<Pattern>();
	//---------------------------------------------------------------------------------------------
	private ConcurrentHashMap<String,String> FLV_GDATA = new ConcurrentHashMap<String,String>();
	private ConcurrentHashMap<String,String> COMMENT_N_GDATA = new ConcurrentHashMap<String,String>();
	private ConcurrentHashMap<String,String> COMMENT_T_GDATA = new ConcurrentHashMap<String,String>();
	private ConcurrentHashMap<String,String> AMI_GDATA = new ConcurrentHashMap<String,String>();
	private ConcurrentHashMap<String,String> LiveCount = new ConcurrentHashMap<String,String>();
	//---------------------------------------------------------------------------------------------
	private boolean ConfigFlagFlv = Config.getBoolean("nlApiUtilExFlv", false);
	private boolean ConfigFlagInfo = Config.getBoolean("nlApiUtilExInfo", false);
	private boolean ConfigFlagComN = Config.getBoolean("nlApiUtilExComN", false);
	private boolean ConfigFlagComT = Config.getBoolean("nlApiUtilExComT", false);
	private boolean ConfigFlagComD = Config.getBoolean("nlApiUtilExComD", false);
	private boolean ConfigFlagComP = Config.getBoolean("nlApiUtilExComP", false);
	private boolean ConfigFlagComF = Config.getBoolean("nlApiUtilExComF", false);
	private boolean ConfigFlagListSort = Config.getBoolean("nlApiUtilExListSort", false);
	private boolean ConfigFlagThumb = Config.getBoolean("nlApiUtilExThumb", false);
	private boolean ConfigFlagFaMylist = Config.getBoolean("nlApiUtilExFaMyList", false);
	private boolean ConfigFlagInfiMylist = Config.getBoolean("nlApiUtilExInfiMyList", false);
	private boolean ConfigFlagFooLink = Config.getBoolean("nlApiUtilExFooterLink", false);
	private boolean ConfigFlagSimple = Config.getBoolean("nlApiUtilExSimple", false);
	private boolean ConfigFlagOwnerName = Config.getBoolean("nlApiUtilExOwnerName", false);
	private boolean ConfigFlagThread1 = Config.getBoolean("nlApiUtilExThread1", false);
	private boolean ConfigFlagDelCheck = Config.getBoolean("nlApiUtilExDelCheck", false);
	private int     ConfigFlagCacheIcon = Config.getInteger("nlApiUtilExCacheIcon", 1);
	private String  ConfigFlagStartPage = Config.getString("nlApiUtilExStartPage", "list");
	private String  ConfigFlagSeigaImageSize = Config.getString("nlApiUtilExSeigaImageSize", "Small");
	private boolean ConfigFlagNumCheck = Config.getBoolean("nlApiUtilExNumCheck", false);
	private boolean ConfigFlagImageLength = Config.getBoolean("nlApiUtilExImageLength", false);
	private boolean ConfigFlagGDataCache = Config.getBoolean("nlApiUtilExGDataCache", true);
	private boolean ConfigFlagHtml = true;
	private boolean ConfigFlagFetcher = FetcherFile.exists();
	private boolean ConfigFlagAmi = FILEAMISWF.exists();
	private boolean ConfigFlagCss = ConfigFileCSS.exists();
	private String  ConfigFlagSmLinks = Config.getString("nlApiUtilExSmLinks", "");
	private final String  ConfigFlagSmLinksString = "watch,relation,open,add_infi,rm_infi,add_defmy,fetch,cacheRm,fetchRm";
	private String[] ConfigFlagSmLinksArray = new String[10];
	//---------------------------------------------------------------------------------------------
	//maken
	private boolean ConfigFlagMakeLog = Config.getBoolean("nlApiUtilExMakeLog", false);
	//filen
	private boolean ConfigFlagMakeLog2 = Config.getBoolean("nlApiUtilExMakeLog2", false);
	//MEMOLY (FLV N_T_COM)n
	private boolean ConfigFlagMakeLog3 = Config.getBoolean("nlApiUtilExMakeLog3", false);
	//debug
	private boolean ConfigFlagisDebug = Config.getBoolean("nlApiUtilExisDebugis", false);
	private Long STTIME = 0l;
	//Oʗp
	private static Integer logcount = 0;
	private static StringBuffer logBuffer = new StringBuffer();
	//ThreadOʗp
	private static Integer thlogcount = 0;
	private static StringBuffer thlogBuffer = new StringBuffer();
	//---------------------------------------------------------------------------------------------
	private static final String URL_API_FLV					= "http://flapi.nicovideo.jp/api/getflv/";
	private static final String URL_API_INFO				= "http://ext.nicovideo.jp/api/getthumbinfo/";
	private static final String URL_API_POSTKEY				= "http://www.nicovideo.jp/api/getpostkey/?yugi=&";
	private static final String URL_API_OWNERDEL			= "http://www.smilevideo.jp/allegation/allegation/";
	private static final String URL_API_RELATION			= "http://flapi.nicovideo.jp/api/getrelation";
	private static final String URL_API_GROUPMYLIST			= "http://www.nicovideo.jp/api/mylistgroup/list";
	private static final String URL_API_MYLIST				= "http://www.nicovideo.jp/api/mylist/list";
	private static final String URL_API_DEFMYLIST			= "http://www.nicovideo.jp/api/deflist/list";
	private static final String URL_API_LIVE_FLV			= "http://live.nicovideo.jp/api/getflv?v=";
	private static final String URL_API_LIVE_ALERTINFO		= "http://live.nicovideo.jp/api/getalertinfo";
	private static final String URL_API_LIVE_STREAMINFO		= "http://live.nicovideo.jp/api/getstreaminfo/";
	private static final String URL_API_LIVE_INFO			= "http://live.nicovideo.jp/api/getplayerstatus?v=";//watch.
	private static final String URL_API_LIVE_NG				= "http://watch.live.nicovideo.jp/api/configurengword?video=";
	private static final String URL_API_SEIGA_IMG			= "http://lohas.nicoseiga.jp/img/";
	private static final String URL_API_SEIGA_SOURCE		= "http://seiga.nicovideo.jp/image/source";
	private static final String URL_API_SEIGA_LIST			= "http://seiga.nicovideo.jp/api/theme/data";
	private static final String URL_API_SEIGA_INFO			= "http://seiga.nicovideo.jp/api/theme/info";
	private static final String URL_API_CONFIG_FILTER		= "http://www.nicovideo.jp/api/configurengword?mode=get&video=";
	private static final String URL_NICONICOTOP		= "http://www.nicovideo.jp/";
	private static final String URL_WATCH			= "http://www.nicovideo.jp/watch/";
	private static final String URL_MYHISTORY		= "http://www.nicovideo.jp/history";
	private static final String URL_OPENLIST		= "http://www.nicovideo.jp/openlist/";
	private static final String URL_MYLIST			= "http://www.nicovideo.jp/mylist/";
	private static final String URL_MYVIDEO			= "http://www.nicovideo.jp/myvideo/";
	private static final String URL_USER 			= "http://www.nicovideo.jp/user/";
	private static final String URL_RANKING			= "http://www.nicovideo.jp/ranking";
	private static final String URL_LIVE			= "http://live.nicovideo.jp/";
	private static final String URL_LIVE_MY			= "http://live.nicovideo.jp/my";
	private static final String URL_LIVE_RECENT		= "http://live.nicovideo.jp/recent";
	private static final String URL_LIVE_WATCH		= "http://live.nicovideo.jp/watch/";
	private static final String URL_COMYU			= "http://com.nicovideo.jp/community/";
	private static final String URL_SEIGA			= "http://seiga.nicovideo.jp/";
	private static final String URL_THUMB			= "http://ext.nicovideo.jp/thumb/";
	private static final String URL_THUMB_MYLIST	= "http://ext.nicovideo.jp/thumb_mylist/";
	private static final String URL_EXST_CACHE		= "http://www.nicovideo.jp/cache/";
	private static final String URL_EXST_LOCAL		= "http://www.nicovideo.jp/local/";
	private static final String URL_EXST_IDS		= "http://www.nicovideo.jp/cache/ids";
	private static final String URL_EXST_FETCH_ALL	= "http://www.nicovideo.jp/cache/fetch";
	private static final String URL_RANKING_ENT			= "http://www.nicovideo.jp/ranking/fav/daily/g_ent";
	private static final String URL_RANKING_LIFE		= "http://www.nicovideo.jp/ranking/fav/daily/g_life";
	private static final String URL_RANKING_POLITICS	= "http://www.nicovideo.jp/ranking/fav/daily/g_politics";
	private static final String URL_RANKING_TRY			= "http://www.nicovideo.jp/ranking/fav/daily/g_try";
	private static final String URL_RANKING_CULTURE		= "http://www.nicovideo.jp/ranking/fav/daily/g_culture";
	private static final String URL_RANKING_POPULAR		= "http://www.nicovideo.jp/ranking/fav/daily/g_popular";
	//---------------------------------------------------------------------------------------------
	private int CaIcWidth=0;
	private int CaIcHeight=0;
	//---------------------------------------------------------------------------------------------
	private void loginfo1(String mes)	{ Logger.info(NLTITLE3 + ": " + mes);logwindow(NLTITLE3 + ": " + mes);}
	private void loginfo2(String mes)	{ Logger.info(mes);logwindow(mes);}
	private void logdebug(String mes)	{ if(ConfigFlagisDebug) Logger.info(NLTITLE3 + ":[debug] " + mes);}
	private void loginfo1(Integer mes)	{ loginfo1(mes+"");}
	private void loginfo2(Integer mes)	{ loginfo2(mes+"");}
	private void logdebug(Integer mes)	{ logdebug(mes+"");}
	private void logwindow(String mes)	{logwindow2(mes);/*₷邽߂ɂ܂΂*/}
	private void logthwindow(String mes){logthwindow2(mes);/*₷邽߂ɂ܂΂*/}
	//---------------------------------------------------------------------------------------------
	private final String HTMLHEADER1 = ""+
			"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n"+
			"<html lang=\"ja\"><head>\n"+
			"<META http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n"+
			"<META http-equiv=\"Content-Script-Type\" content=\"text/javascript\">\n"+
			"<META http-equiv=\"Content-Style-Type\" content=\"text/css\">\n"+
			"<link rel=\"stylesheet\" type=\"text/css\" href=\"../local/nlApiUtilEx.css\">\n";
	private final String HTMLHEADER2 = "</head><body>\n";
	private final String HTMLHEADERJS = ""+
			"<script type=\"text/javascript\" src=\"../local/sortable.js\"></script>\n"+
			"<script type=\"text/javascript\" src=\"../local/nlMovieFetcher.js\"></script>\n"+
			"<script type=\"text/javascript\" src=\"../local/nlApiUtilExAdd.js\"></script>\n"+
			"<script type=\"text/javascript\" src=\"../local/nlThumbInfoRewriter.js\"></script>\n"+
			"<script type=\"text/javascript\" src=\"http://res.nimg.jp/js/lib/prototype.js\"></script>\n";
	//---------------------------------------------------------------------------------------------
	private final String HTMLHEADERPLUS = "";
	private final String HTMLFOOTER = "</body>\n</html>\n";
	//---------------------------------------------------------------------------------------------
	private String ACBROWSER = "";
	private String LOGINUSERSESSION = null;
	//---------------------------------------------------------------------------------------------
	private final Pattern CACHETEMPLIST_JSON_PATTERN = Pattern.compile("^\"([a-z]{2}\\d+(?:low)?)\":\\[\"([^\"]*)\",\\s+(\\d+),\\s+(\\d+),\\s+(false|true),\\s+(\\d+)\\],?$");
	private final Pattern CACHELOWLIST_JSON_PATTERN = Pattern.compile("^\"([a-z]{2}\\d+low)\":\\[\"([^\"]*)\",\\s+\"([^\"]*)\",\\s+(\\d+),\\s+(\\d+)\\],?$");
	private final Pattern CACHELIST_JSON_PATTERN =  Pattern.compile("^\"([a-z]{2}\\d+)\":\\[\"([^\"]*)\",\\s+\"([^\"]*)\",\\s+(\\d+),\\s+(\\d+)\\],?$");
	private final Pattern PAGE_PATTERN =Pattern.compile("([^&]+)(?:&)?(.+)?");
	private final Pattern H_OPTION_PATTERN = Pattern.compile("^(list|lowlist|famy|infimy|fetche|rank|open|rela|myv)");
	private final Pattern INFI_DELNOT_PAT = Pattern.compile("^(.<>[^<]+<>[^<]+<>)(?:\\[DEL\\])?([^<]+)(<>.+)$");
	private final Pattern FETCHING_JSON_PATTERN = Pattern.compile("^([a-z]{2}(\\d+)):\\s(.+)");
	private final Pattern FETCH_JSON_PATTERN = Pattern.compile("^\"([a-z]{2}(\\d+)(?:low)?)\":\\s*\"(.+)\",?$");
	private final int GZIP_BUF_SIZE = 1024*10;
	private Boolean DEFONECHECK=false;
	//---------------------------------------------------------------------------------------------
	//Xbhn
	private volatile Thread thread = null;
	private HttpRequestHeader threq = null;
	private Integer thtype = 0;
	private static Boolean thflag1 = false;
	private static Boolean thflag2 = false;
	private String thcolor ="#000000";
	private static HashSet<Pattern> COLIST_PAT = new HashSet<Pattern>();
	private static ArrayList<Pattern> LVLIST_PAT = new ArrayList<Pattern>();
	//---------------------------------------------------------------------------------------------
	public nlApiUtilExtension(HttpRequestHeader requestHeader,Integer type,String color) {
		this.threq = requestHeader;
		this.thtype = type;
		this.thcolor = color;
	}
	private void initialize(HttpRequestHeader requestHeader) throws IOException {
		loadAllConfig();
		loadConfigFile();
		initBrowser(requestHeader);
		initNicoHistory(requestHeader);
		initGlobalData();
//		initCacheData();
		initDefMyList(requestHeader);
		initThreadCheck(requestHeader);
	}
	private void initThreadCheck(HttpRequestHeader requestHeader){
		if(ConfigFlagThread1 && !thflag1){
			thflag1 = true;
			nlApiUtilExtension nlAue1 = new nlApiUtilExtension(requestHeader,1,"#AAAAFF");
			nlAue1.thread = new Thread(nlAue1);
			nlAue1.thread.start();
		}
	}
	private void initBrowser(HttpRequestHeader requestHeader){
		ACBROWSER="s";
		Pattern browser1pattern = Pattern.compile("Firefox\\S+");
		Pattern browser2pattern = Pattern.compile("MSIE[^;]+");
		Pattern browser3pattern = Pattern.compile("Chrome\\S+");
		Pattern browser4pattern = Pattern.compile("Safari\\S+");
		Pattern browser5pattern = Pattern.compile("Lunascape\\s[0-9.]+");
		Pattern browser6pattern = Pattern.compile("Opera\\S+");
		Matcher m = null;
		String useragent = requestHeader.getMessageHeader("User-Agent");
		if(useragent != null){
			m = browser5pattern.matcher(useragent);//Lune
			if(m.find()){ACBROWSER=m.group();return;}
			m = browser1pattern.matcher(useragent);//fox
			if(m.find()){ACBROWSER=m.group();return;}
			m = browser2pattern.matcher(useragent);//IE
			if(m.find()){ACBROWSER=m.group();return;}
			m = browser3pattern.matcher(useragent);//chome
			if(m.find()){ACBROWSER=m.group();return;}
			m = browser4pattern.matcher(useragent);//safari
			if(m.find()){ACBROWSER=m.group();return;}
			m = browser6pattern.matcher(useragent);//opera
			if(m.find()){ACBROWSER=m.group();return;}
		}
	}
	private void initNicoHistory(HttpRequestHeader requestHeader){
		Pattern his = Pattern.compile("user_session=[^;\\s]+");
		Matcher m = his.matcher(requestHeader.toString());
		if(m.find()){
			LOGINUSERSESSION = m.group();
			return;
		}
		LOGINUSERSESSION = null;
	}
/*	private void initCacheData(){
		cacheSmNum=0;
		cacheSmLowNum=0;
		cacheSmTmpNum=0;
		Map<String, File> caches = Cache.getId2File();
		if (caches.size() != 0) {
			String[] idList = MovieIdSorter.sort(caches, true);
			cacheSmNum=idList.length;
			for (String id: idList){
				if(id.endsWith("low"))
					cacheSmLowNum+=1;
			}
		}else{
			cacheSmNum=0;
			cacheSmLowNum=0;
		}
		caches=null;
		for (String line : Cache.getTempListAsJson(false).split("\n")) {
			Matcher m = CACHETEMPLIST_JSON_PATTERN.matcher(line);
			if (m.matches()) {
				cacheSmTmpNum+=1;
			}
		}
	}
*/
	private void initGlobalData(){
		if(FLV_GDATA.size()>20){FLV_GDATA.clear();
			if(ConfigFlagMakeLog3)loginfo1("FLV Clear...");
		}if(COMMENT_N_GDATA.size()>20){COMMENT_N_GDATA.clear();
			if(ConfigFlagMakeLog3)loginfo1("N_COM Clear...");
		}if(COMMENT_T_GDATA.size()>20){COMMENT_T_GDATA.clear();
			if(ConfigFlagMakeLog3)loginfo1("T_COM Clear...");
		}
	}
	private void initDefMyList(HttpRequestHeader requestHeader) throws IOException {
		if(DEFONECHECK)return;
		if(DEFMYLIST_PAT.size()<1){
			getMyDefMyList(requestHeader);
			DEFONECHECK=true;
		}
	}
	private void loadFlag(){
		ConfigFlagThumb = Config.getBoolean("nlApiUtilExThumb", false);
		ConfigFlagFlv = Config.getBoolean("nlApiUtilExFlv", false);
		ConfigFlagInfo = Config.getBoolean("nlApiUtilExInfo", false);
		ConfigFlagComN = Config.getBoolean("nlApiUtilExComN", false);
		ConfigFlagComT = Config.getBoolean("nlApiUtilExComT", false);
		ConfigFlagComD = Config.getBoolean("nlApiUtilExComD", false);
		ConfigFlagComP = Config.getBoolean("nlApiUtilExComP", false);
		ConfigFlagComF = Config.getBoolean("nlApiUtilExComF", false);
		ConfigFlagListSort = Config.getBoolean("nlApiUtilExListSort", false);
		ConfigFlagMakeLog = Config.getBoolean("nlApiUtilExMakeLog", false);
		ConfigFlagMakeLog2 = Config.getBoolean("nlApiUtilExMakeLog2", false);
		ConfigFlagMakeLog3 = Config.getBoolean("nlApiUtilExMakeLog3", false);
		ConfigFlagFaMylist = Config.getBoolean("nlApiUtilExFaMyList", false);
		ConfigFlagInfiMylist = Config.getBoolean("nlApiUtilExInfiMyList", false);
		ConfigFlagFooLink = Config.getBoolean("nlApiUtilExFooterLink", false);
		ConfigFlagCacheIcon = Config.getInteger("nlApiUtilExCacheIcon", 1);
		ConfigFlagSimple = Config.getBoolean("nlApiUtilExSimple", false);
		ConfigFlagOwnerName = Config.getBoolean("nlApiUtilExOwnerName", false);
		ConfigFlagThread1 = Config.getBoolean("nlApiUtilExThread1", false);
		ConfigFlagisDebug = Config.getBoolean("nlApiUtilExisDebugis", false);
		ConfigFlagDelCheck = Config.getBoolean("nlApiUtilExDelCheck", false);
		ConfigFlagStartPage = Config.getString("nlApiUtilExStartPage", "list");
		ConfigFlagSeigaImageSize = Config.getString("nlApiUtilExSeigaImageSize", "Small");
		ConfigFlagNumCheck = Config.getBoolean("nlApiUtilExNumCheck", false);
		ConfigFlagImageLength = Config.getBoolean("nlApiUtilExImageLength", false);
		ConfigFlagGDataCache = Config.getBoolean("nlApiUtilExGDataCache", true);
		ConfigFlagSmLinks = Config.getString("nlApiUtilExSmLinks", "");
		ConfigFlagFetcher = FetcherFile.exists();
		ConfigFlagAmi=FILEAMISWF.exists();
		ConfigFlagCss = ConfigFileCSS.exists();
		if(ConfigFlagCacheIcon==1){
			CaIcWidth=59;CaIcHeight=15;
		}else if(ConfigFlagCacheIcon==2){
			CaIcWidth=76;CaIcHeight=20;
		}else if(ConfigFlagCacheIcon==3){
			CaIcWidth=94;CaIcHeight=24;
		}else if(ConfigFlagCacheIcon==4){
			CaIcWidth=112;CaIcHeight=28;
		}else if(ConfigFlagCacheIcon==5){
			CaIcWidth=130;CaIcHeight=33;
		}else{
			CaIcWidth=59;CaIcHeight=15;
		}
		if(ConfigFlagSmLinks==null || ConfigFlagSmLinks==""){
			ConfigFlagSmLinks=ConfigFlagSmLinksString;
		}
		ConfigFlagSmLinksArray = ConfigFlagSmLinks.split(",");
		if(ConfigFlagMakeLog2)loginfo1("ReLoad./Flag.");
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private void requestOption(String option){
		if(option.indexOf('a') != -1){ConfigFlagFlv = true;
		}else{if(!Config.getBoolean("nlApiUtilExFlv", false)) ConfigFlagFlv = false;}
		if(option.indexOf('b') != -1){ConfigFlagInfo = true;
		}else{if(!Config.getBoolean("nlApiUtilExInfo", false)) ConfigFlagInfo = false;}
		if(option.indexOf('c') != -1){ConfigFlagComN = true;
		}else{if(!Config.getBoolean("nlApiUtilExComN", false)) ConfigFlagComN = false;}
		if(option.indexOf('d') != -1){ConfigFlagComT = true;
		}else{if(!Config.getBoolean("nlApiUtilExComT", false)) ConfigFlagComT = false;}
		if(option.indexOf('e') != -1){ConfigFlagComP = true;
		}else{if(!Config.getBoolean("nlApiUtilExComP", false)) ConfigFlagComP = false;}
		if(option.indexOf('f') != -1){ConfigFlagNumCheck=true;
		}else{if(Config.getBoolean("nlApiUtilExNumCheck", false)) ConfigFlagNumCheck=false;}
		if(option.indexOf('g') != -1){ConfigFlagComF=true;
		}else{ConfigFlagComF=false;}
		if(option.indexOf('t') != -1){ConfigFlagComD = true;
		}else{if(!Config.getBoolean("nlApiUtilExComD", false)) ConfigFlagComD = false;}
		if(option.indexOf('h') != -1){ConfigFlagHtml = false;
		}else{ConfigFlagHtml = true;}
		if(option.indexOf('s') != -1){ConfigFlagSimple = true;
		}else if(option.indexOf('n') != -1){ConfigFlagSimple = false;
		}else{
			ConfigFlagSimple = Config.getBoolean("nlApiUtilExSimple", false);
		}
	}
	private StringResource setResponseText(String text) {
		return setResponseText(text, "text/plain");
	}
	private StringResource setResponseText(String sb,String type) {
		StringResource r = new StringResource(sb);
		sb = null;
		r.setResponseHeader(HttpHeader.CONTENT_TYPE, type);
		r.addNoCacheResponseHeaders();
		return r;
	}
	private StringResource setResponseText(byte[] sb,String type) {
		StringResource r = new StringResource(sb);
		sb = null;
		r.setResponseHeader(HttpHeader.CONTENT_TYPE, type);
		r.addNoCacheResponseHeaders();
		return r;
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser) throws IOException {
		if(!ConfigFlagCss)return setResponseText("No CSS File.");
		STTIME = System.currentTimeMillis();
		initialize(requestHeader);
		Matcher acm = SUPPORTED_PATTERN.matcher(requestHeader.getURI());
		String pagetype="nullp";
		requestOption("");
		if (acm.matches()) {
			if(acm.group(1) == null){
				pagetype=noneType();
			}else{
				Matcher page_m = PAGE_PATTERN.matcher(acm.group(1));
				if(page_m.matches()){
					pagetype=page_m.group(1);
					if(page_m.group(2) != null){
						requestOption(page_m.group(2));
					}else{
					}
				}else{
					pagetype=noneType();
				}
			}
		}
		StringResource r = new StringResource("");
		try{
			r = tRequest(requestHeader,pagetype);
		} catch (OutOfMemoryError e) {
			r = makeOutOfMemory(requestHeader);
		} catch (Exception e) {
			r = makeError(requestHeader,e+"");
		}
		return r;
	}
	private String noneType(){
		String type="list";
		if(ConfigFlagStartPage.startsWith("list")){type="list";
		}else if(ConfigFlagStartPage.startsWith("famylist")){type="famylist";
		}else if(ConfigFlagStartPage.startsWith("infimylist")){type="infimylist";
		}else if(ConfigFlagStartPage.startsWith("livelist")){type="livelist";
		}else if(ConfigFlagStartPage.startsWith("mypage")){type="mypage";
		}else{type="list";}
		return type;
	}
	private ConcurrentHashMap<String,ConcurrentHashMap<String,String>> testME(){
		ConcurrentHashMap<String,ConcurrentHashMap<String,String>> getMap = new ConcurrentHashMap<String,ConcurrentHashMap<String,String>>();
		ConcurrentHashMap<String, String> nmap = new ConcurrentHashMap<String, String>();
		nmap.put("len","444");
		nmap.put("v","9");
		getMap.put("sm9",nmap);
		nmap.put("len","544");
		nmap.put("v","95");
		getMap.put("sm10",nmap);
		StringBuilder sb = new StringBuilder();
		for (Map.Entry<String,ConcurrentHashMap<String, String>> e : getMap.entrySet()) {
			sb.append("key=");
			sb.append(e.getKey());
			sb.append("&val=");
			sb.append("[");
			for (Map.Entry<String,String> f : e.getValue().entrySet()) {
				sb.append("key=");
				sb.append(f.getKey());
				sb.append("&val=");
				sb.append(f.getValue());
			}
			sb.append("]");
		}
		loginfo2(new String(sb));
		return getMap;
	}
	private StringResource tRequest(HttpRequestHeader requestHeader,String type)  throws IOException {
		Matcher acm = H_OPTION_PATTERN.matcher(type);if(acm.find())ConfigFlagHtml = true;
		StringResource r = new StringResource("");
//		testME();
		//---------------------------------------------------------------------------------------------
		//list
		//---------------------------------------------------------------------------------------------
		if (type.startsWith("mymylist")) {				r = makeMyMyList(requestHeader);
		}else if (type.startsWith("mypage")) {			r = makeMyPage(requestHeader);
		}else if (type.startsWith("list")) {			r = makeList(requestHeader);
		}else if (type.startsWith("templist")) {		r = makeTempList(requestHeader);
		}else if (type.startsWith("lowlist")) {			r = makeLowList(requestHeader);
		}else if (type.startsWith("famylist")){			r = makeFaMyList(requestHeader);
		}else if (type.startsWith("infimylist")){		r = makeInfiMyList(requestHeader);
		}else if (type.startsWith("rankinglist")){		r = makeRankingList(requestHeader);
		}else if (type.startsWith("getgraphAPIXMLSET")){r = makeXMLSETGraph();
		}else if (type.startsWith("cachejson")){		r = makeCacheJson(requestHeader);
		}else if (type.startsWith("rankingtopAPI")){	r = makeApiRankingTop(requestHeader);
		}else if (type.startsWith("rankingtop")){		r = makeRankingTop(requestHeader);
		//---------------------------------------------------------------------------------------------
		//list܂
		//DATA
		//---------------------------------------------------------------------------------------------
		}else if (type.startsWith("data=")){			r = makeData(requestHeader,type.substring(5));
		}else if (type.startsWith("watch=")){			r = makeWatch(requestHeader,type.substring(6));
		}else if (type.startsWith("mylist=")){			r = makeMylist(requestHeader,type.substring(7));
		}else if (type.startsWith("mylist2=")){			r = makeMylist2(requestHeader,type.substring(8));
		}else if (type.startsWith("openmylist=")){		r = makeOpenMylist(requestHeader,type.substring(11));
		}else if (type.startsWith("ranking=")){			r = makeRanking(requestHeader,type.substring(10));
		}else if (type.startsWith("relation=")){		r = makeRelation(requestHeader,type.substring(9));
		}else if (type.startsWith("myvideo=")){			r = makeMyvideo(requestHeader,type.substring(8));
		}else if (type.startsWith("getgraph=")){		r = makeGraph(requestHeader,type.substring(9));
		//---------------------------------------------------------------------------------------------
		//DATA܂
		//API
		//---------------------------------------------------------------------------------------------
		}else if (type.startsWith("dataAPI=")){			r = makeApiData(requestHeader,type.substring(8));
		}else if (type.startsWith("mylistAPI=")){		r = makeApiMylist(requestHeader,type.substring(10));
		}else if (type.startsWith("openmylistAPI=")){	r = makeApiOpenMylist(requestHeader,type.substring(14));
		}else if (type.startsWith("liveAPI=")){			r = makeApiLivelist(requestHeader,type.substring(8));
		}else if (type.startsWith("rankingAPI=")){		r = makeApiRanking(requestHeader,type.substring(11));
		}else if (type.startsWith("relationAPI=")){		r = makeApiRelation(requestHeader,type.substring(12));
		}else if (type.startsWith("myvideoAPI=")){		r = makeApiMyvideo(requestHeader,type.substring(11));
		}else if (type.startsWith("getgraphAPI=")){		r = makeApiGraph(requestHeader,type.substring(12));
		}else if (type.startsWith("getgraphAPIXML=")){	r = makeXMLGraph(requestHeader,type.substring(15));
		//---------------------------------------------------------------------------------------------
		//API܂
		//ǉAPI
		//---------------------------------------------------------------------------------------------
		}else if (type.startsWith("addfa=")){			r = saveConfigFileFa(requestHeader,type.substring(6));
		}else if (type.startsWith("addinfi=")){			r = saveConfigFileInfi(requestHeader,type.substring(8));
		}else if (type.startsWith("removefa=")){		r = removeConfigFileFa(type.substring(9));
		}else if (type.startsWith("removeinfi=")){		r = removeConfigFileInfi(type.substring(11));
		}else if (type.startsWith("getthinfo=")){		r = getthinfo(requestHeader,type.substring(10));
		//---------------------------------------------------------------------------------------------
		//ǉAPI܂
		//Fetchn
		//---------------------------------------------------------------------------------------------
		}else if (type.startsWith("fetchedlist")){		r = makeFetchedList(requestHeader);
		}else if (type.startsWith("fetchinglist")){		r = makeFetchingList(requestHeader);
		}else if (type.startsWith("fetchall=")){		r = makeFetchAll(requestHeader,type.substring(9));
		//---------------------------------------------------------------------------------------------
		//Fetchn܂
		//
		//---------------------------------------------------------------------------------------------
		}else if (type.startsWith("livelist")){			r = makeLiveList(requestHeader);
		}else if (type.startsWith("livecommon")){		r = makeLiveCommon(requestHeader);
		}else if (type.startsWith("livetry")){			r = makeLiveTry(requestHeader);
		}else if (type.startsWith("livegame")){			r = makeLiveGame(requestHeader);
		}else if (type.startsWith("livereq")){			r = makeLiveReq(requestHeader);
		}else if (type.startsWith("liveface")){			r = makeLiveFace(requestHeader);
		}else if (type.startsWith("livetotu")){			r = makeLiveTotu(requestHeader);
		}else if (type.startsWith("liver18")){			r = makeLiveR18(requestHeader);
		}else if (type.startsWith("livedata=")){		r = makeLiveData(requestHeader,type.substring(9));
		//---------------------------------------------------------------------------------------------
		//܂
		//test@\
		//---------------------------------------------------------------------------------------------
		}else if (type.startsWith("testsearch=")){		r = makeSearch(requestHeader,type.substring(11));
		}else if (type.startsWith("testtagsearch=")){	r = makeSearch(requestHeader,type.substring(14));
		//---------------------------------------------------------------------------------------------
		//test@\܂
		//É悱
		//---------------------------------------------------------------------------------------------
		}else if(type.startsWith("seigalist")){			r = makeSeigaList(requestHeader);
		}else if(type.startsWith("seigabbs=")){			r = makeSeigaBbs(requestHeader,type.substring(9));
		//---------------------------------------------------------------------------------------------
		//É悱܂
		//Rgep
		//---------------------------------------------------------------------------------------------
		}else if(type.startsWith("post=")){				r = makePost(requestHeader,type.substring(5));
		}else if(type.startsWith("smpost=")){			r = makePostDataSm(requestHeader,type.substring(7));
		}else if(type.startsWith("lvpost=")){			r = makePostDataLv(requestHeader,type.substring(7));
		//---------------------------------------------------------------------------------------------
		//Rgep܂
		//fobNp
		//---------------------------------------------------------------------------------------------
//		}else if (type.startsWith("makeoom")){			r = makeOutOfMemory(requestHeader);
		}else if (type.startsWith("logta")){			r = makeThreadLog(requestHeader);
		}else if (type.startsWith("logt")){				r = makeLogText(requestHeader);
		}else if (type.startsWith("logh")){				r = makeLogHtml(requestHeader);
		}else if (type.startsWith("newfa=")){			r = makeNewFaList(requestHeader,type.substring(6));
		}else if (type.startsWith("openDirectory=")){	r = makeOpen(requestHeader,type.substring(14),false);
		}else if (type.startsWith("openBrowser=")){		r = makeOpen(requestHeader,type.substring(12),true);
		//---------------------------------------------------------------------------------------------
		//fobNp܂
		//---------------------------------------------------------------------------------------------
		}else{
			ConfigFlagHtml = true;
			loginfo1("PageTypeError...");
			r = makeList(requestHeader);
		}
		//Op
		if (!type.startsWith("log"))logwindow(type + " @" + (System.currentTimeMillis() - STTIME) + "msec.");
		return r;
	}
	private StringResource make(HttpRequestHeader requestHeader,String id) throws IOException {
		return setResponseText("make.test@"+id);
	}
	private StringResource makeData(HttpRequestHeader requestHeader,String videoid) throws IOException {
		videoid=videoid.replaceAll("low","");
		String videoid2=videoid.replaceAll("^[a-z]+","");
		StringBuffer sb = new StringBuffer();
		String commentString="";
		String title = "";
		String username=null;
		String username2=null;
		ConcurrentHashMap<String, String> mapInfo = getInfoData(requestHeader, videoid);
		//------------------------
		//n܂ĂIDɑΏ
		//+R~jeB̏ꍇ̂
		//------------------------
		Boolean commf=false;
		Boolean numStart=false;
		Pattern comid = Pattern.compile("^\\d");
		Pattern comid_sm1 = Pattern.compile("so.addVariable\\([\"\']videoId[\"\'],\\s*[\"\']([^\"\']+)[\"\']\\);");
		Pattern comid_sm2 = Pattern.compile("so.addVariable\\([\"\']wv_id[\"\'],\\s*[\"\']([^\"\']+)[\"\']\\);");
		Pattern comid_sm3 = Pattern.compile("id:\\s+[\"\']([^\"\']+)[\"\'],");
		Pattern comid_sm4 = Pattern.compile("/tag_edit/([^\"\']+)[\"\']");
		Matcher comm = comid.matcher(videoid);
		String comcheck="nullp";
		if(mapInfo.containsKey("code")) comcheck=mapInfo.get("code");
		if(comm.find() && comcheck.startsWith("COMMUNITY")){
			if(ConfigFlagNumCheck){
				String str = getHttpRespons(requestHeader,URL_WATCH+videoid,false);
				comm = comid_sm1.matcher(str);
				if(comm.find()){videoid=comm.group(1);commf=true;}
				if(!commf){comm = comid_sm2.matcher(str);if(comm.find()){videoid=comm.group(1);commf=true;}}
				if(!commf){comm = comid_sm3.matcher(str);if(comm.find()){videoid=comm.group(1);commf=true;}}
				if(!commf){comm = comid_sm4.matcher(str);if(comm.find()){videoid=comm.group(1);commf=true;}}
				mapInfo = getInfoData(requestHeader, videoid);
				str =null;
			}else{
				numStart=true;
			}
		}
		//------------------------
		//n܂ĂIDɑΏ܂
		//------------------------
		ConcurrentHashMap<String, String> mapFlv  = new ConcurrentHashMap<String, String>();
		ConcurrentHashMap<String, String> mapPost  = new ConcurrentHashMap<String, String>();
		String post_key="";
		if (mapInfo.containsKey("title")){
			title = mapInfo.get("title");
		}else if(mapInfo.containsKey("description")){
			title = mapInfo.get("description");
		}else{
			title=null;
		}
		if(ConfigFlagFlv || ConfigFlagComN || ConfigFlagComT || ConfigFlagComP){
			if(!title.startsWith("not") && !title.startsWith("communi")){
				mapFlv  = getFlvData(requestHeader,videoid);
				if(ConfigFlagComN || ConfigFlagComP){
					commentString=getApiDataCommentN(requestHeader,mapFlv,videoid);
					if(ConfigFlagComP){
						mapPost = getPostUrl(mapFlv,commentString);
						post_key = getHttpRespons(requestHeader,mapPost.get("posturl"),false);
						mapPost.put("postkey",post_key);
					}
				}
			}
		}
		sb.append(htmlHearderString(videoid+"_"+title));
		sb.append("<div id=\"all\">\n\n");
		sb.append("<div class=\"all_all\">\n");
		if(ConfigFlagHtml)
		sb.append("<h2 class=\"all_title\">Data</h2>\n");
		sb.append("<div class=\"all_body\">\n");
		//
		if(commf || numStart){
			sb.append("<div align=\"center\">\n");
			if(commf){
				sb.append("<font color=\"red\">ϊς݂łB</font><a href=\"./ids?data="+videoid+"&b\">[L]</a><br>");
			}else if(numStart){
				sb.append("<font color=\"red\">ϊŎ擾ł\܂B</font>ڂ́<a href=\"./ids?data="+videoid+"&bf\"></a><br>");
			}
			sb.append("</div>\n");
		}
		//
		sb.append("<div>\n");
		if(ConfigFlagHtml){
			sb.append("<a href=\"./ids?data="+videoid+"&amp;a\">FLV Data</a> / \n");
			sb.append("<a href=\"./ids?data="+videoid+"&amp;b\">INFO Data</a> / \n");
			sb.append("<a href=\"./ids?data="+videoid+"&amp;cd\">Comment Data</a> / \n");
			sb.append("<a href=\"./ids?data="+videoid+"&amp;bg\">Filter Data</a> / \n");
			sb.append("<a href=\"./ids?data="+videoid+"&amp;abcdg\">All Data</a> / \n");
			sb.append("<a href=\"./"+videoid+".xml\">Save Xml (N)</a> / \n");
			sb.append("<a href=\"./_"+videoid+".xml\">Save Xml (T)</a> / \n");
			if(ConfigFlagAmi)sb.append("<a href=\"./ids?getgraph="+videoid+"\">Graph Data</a> / \n");
			sb.append("<br>\n");
			sb.append(htmlSmLinks(videoid,999+"",1+"",false,true));
			sb.append("<br>\n");
		}
		sb.append("</div>\n");
		if(title==null){
			if(ConfigFlagHtml)sb.append("No Data<br>\n");
		}else{
			if(ConfigFlagHtml){
				sb.append(title+"\n");
				if(ConfigFlagOwnerName)
					username=getOwnerName(requestHeader,videoid);
					if(mapInfo.containsKey("user_id")){
						username2=getOwnerName2(requestHeader,mapInfo.get("user_id"));
					}
				if(username!=null){
					sb.append(" /OwnerName1 : "+username+"\n");
				}
				if(username2!=null){
					sb.append(" /OwnerName2 : "+username2+"\n");
				}
				if(!title.startsWith("not") && !title.startsWith("communi"))
					sb.append("<br>\n");
			}
			if(ConfigFlagThumb){
				sb.append("<iframe width=\"900\" height=\"200\" src=\""+URL_THUMB+videoid+"\" "+
					"scrolling=\"no\" frameborder=\"0\"></iframe>\n<br>\n");
			}
			if(ConfigFlagHtml && !title.startsWith("not") && !title.startsWith("communi")){
				sb.append("<table align=\"left\">");
				sb.append("<tr><td>\n");
				sb.append(htmlImgString(mapInfo.get("thumbnail_url"),videoid,mapInfo.get("length"),1,1,true));
				sb.append("</td></tr>\n");
				sb.append("</table>\n");
			}
			if(ConfigFlagFlv && !title.startsWith("not") && !title.startsWith("communi")){
				sb.append(htmlFlvTable(mapFlv,videoid)+"<br>\n");
			}
			if(ConfigFlagComP && !title.startsWith("not") && !title.startsWith("communi")){
				sb.append(htmlPostTable(mapPost,mapFlv)+"<br>\n");
			}
			if(ConfigFlagInfo){
				sb.append(htmlInfoTable(mapInfo,videoid)+"<br>\n");
			}
			if(ConfigFlagHtml && !ConfigFlagFlv && !ConfigFlagInfo && !ConfigFlagComP)
				sb.append("<br clear=\"all\">\n");
		}
		if(ConfigFlagComN){
			if(!title.startsWith("not") && !title.startsWith("communi")){
				ArrayList<String> commentStringSplit=getApiDataCommentNSplit(commentString);
				sb.append(htmlNCommentString(commentStringSplit)+"<br>\n");
				commentStringSplit=null;
			}else{
				sb.append(title+"<br>\n");
			}
		}
		if(ConfigFlagComT){
			if(!title.startsWith("not") && !title.startsWith("communi")){
				ArrayList<String> commentStringTSplit=getApiDataCommentTSplit(getApiDataCommentT(requestHeader,mapFlv,videoid));
				sb.append(htmlTCommentString(commentStringTSplit)+"<br>\n");
				commentStringTSplit=null;
			}else{
				sb.append(title+"<br>\n");
			}
		}
		if(ConfigFlagComF){
			if(!title.startsWith("not") && !title.startsWith("communi")){
				ArrayList<String> configFilter = getApiDataConfigFilter(requestHeader,videoid);
				sb.append(htmlFilterString(configFilter)+"<br>\n");
				configFilter=null;
			}else{
				sb.append(title+"<br>\n");
			}
		}
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader,false));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeRelation(HttpRequestHeader requestHeader,String videoid) throws IOException {
		StringBuffer sb = new StringBuffer();
		ArrayList<String> myRelationListArray = getRelationXML(requestHeader,1,videoid);
		if(myRelationListArray != null){
			ArrayList<String> myRelationListArray2 = getRelationXML(requestHeader,2,videoid);
			if(myRelationListArray2 != null){
				myRelationListArray.addAll(myRelationListArray2);
				myRelationListArray2=null;
				ArrayList<String> myRelationListArray3 = getRelationXML(requestHeader,3,videoid);
				if(myRelationListArray3 != null){
					myRelationListArray.addAll(myRelationListArray3);
					myRelationListArray3=null;
					ArrayList<String> myRelationListArray4 = getRelationXML(requestHeader,4,videoid);
					if(myRelationListArray4 != null){
						myRelationListArray.addAll(myRelationListArray4);
						myRelationListArray4=null;
					}
				}
			}
		}
		String data="";
		String[] linedata = new String[22];
		String watchurl="";
		SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		Date date1 = new Date();
		int len=0;
		int count=0;
		long unixt=0;
		String unixtime="";
		String length="";
		String smdata="";
		sb.append(htmlHearderString("RelationList"));
		sb.append("<div id=\"left\">\n\n");
		if(myRelationListArray!=null && myRelationListArray.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">RelationList/Size-"+myRelationListArray.size()+"/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_API_RELATION+"?page=1&sort=p&order=d&video="+videoid+"\">Relation Page</a><br>\n");
			for (int i = 0 ; i < myRelationListArray.size() ; i++){
				data = myRelationListArray.get(i);
				linedata = data.split("<>");
				watchurl=linedata[1];
				count =parStringInteger(linedata[0]);
				len =parStringInteger(linedata[7]);
				if(len/60<10){length="0";}else{length="";}
				length+=len/60+":";
				if(len%60<10)length+="0";
				length+=len%60+"";
				unixt=parStringLong(linedata[8]);
				date1 = new Date(unixt*1000);
				unixtime = sdf1.format(date1);
				smdata="Đ:"+linedata[4]+" Rg:"+linedata[5]+" }CX:"+linedata[6]+"  ";
				if(ConfigFlagSimple){
					sb.append(htmlSimpleString(watchurl,linedata[2],i,linedata[3],unixtime,smdata,length,"none"));
				}else{
					sb.append(htmlDefaultString(watchurl,linedata[2],i,linedata[3],unixtime,smdata,length,"none"));
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">RelationList/Size-0/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeOutOfMemory(HttpRequestHeader requestHeader){
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("OutOfMemoryError...."));
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">OutOfMemoryError</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		sb.append("OutOfMemoryError...<br>\n");
		sb.append("Java̋NIvV -Xmn120m -Xmx480m čċNĂB<br>\n");
		sb.append("Ăꍇ͒l傫Ă݂ĂB<br>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeError(HttpRequestHeader requestHeader,String mes){
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("Error...."));
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">Error</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		sb.append("Error...<br>\n");
		sb.append(mes+"<br>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeMylist(HttpRequestHeader requestHeader,String mylistid) throws IOException {
		String arraycon = "";
		int myint=0;
		try{
			myint=Integer.parseInt(mylistid);
		} catch (NumberFormatException e) {
			return setResponseText("Eroor!\n");
		}
		StringBuffer sb = new StringBuffer();
		String[] linedata = new String[11];
		String data = "";
		String memo = "";
		String desc = "";
		String watchurl="";
		String watchurl2="";
		String linkdata="";
		ArrayList<String> myListListArray = getMylistRss(requestHeader,mylistid);
		linkdata=htmlFaAddString(mylistid,"004")+" / ";
		linkdata+=htmlFaRemoveString(mylistid,"005");
		if(myListListArray.size() >0){
			String title=myListListArray.get(0).replaceAll("^[^<]+<>|<>","");
			String myowner=myListListArray.get(2).replaceAll("^[^<]+<>|<>","");
			String mydesc=htmlRegexpString(myListListArray.get(1).replaceAll("^[^<]+<>|<>",""));
			sb.append(htmlHearderString(mylistid+"_"+title));
			sb.append("<div id=\"left\">\n\n");
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">MyList/Size-"+(myListListArray.size()-3)+" / "+linkdata+"</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\"../mylist/"+mylistid+"\">MyList Page</a><br>\n");
			sb.append(title+" / "+myowner+" <br>\n");
			sb.append("<small>"+mydesc+"</small>\n");
			for (int i = 3 ; i < myListListArray.size() ; i++){
				data = myListListArray.get(i);
				data=data.replaceAll("<>null<>","<>nullnull<>");
				linedata = data.split("<>");
				watchurl = linedata[2];
				watchurl2 = watchurl.replaceAll(URL_WATCH+"(.+)","$1");
				desc = linedata[6];
				desc=htmlRegexpString(desc);
				memo = linedata[4];
				memo=htmlRegexpString(memo);
				memo="memo:"+memo+"<br>";
				String vmm="";
				try{
					vmm = "Đ:"+linedata[9]+" Rg:"+linedata[10]+" }CXg:"+linedata[11]+" ";
				}catch(ArrayIndexOutOfBoundsException e){}
				if(memo.startsWith("memo: nullnull")) memo ="";
				if(ConfigFlagSimple){
					sb.append(htmlSimpleMyListString(watchurl2,linedata[5],(i-1),linedata[1],linedata[8],vmm+" ",linedata[7],memo,desc));
				}else{
					sb.append(htmlDefaultString(watchurl2,linedata[5],(i-1),linedata[1],linedata[8]," ",linedata[7],memo+desc));
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append(htmlHearderString(mylistid));
			sb.append("<div id=\"left\">\n\n");
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">MyList/Size-0/NoLink</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\"../mylist/"+mylistid+"\">MyList Page</a><br>\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append(htmlFooterString(requestHeader));
		myListListArray=null;
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeMylist2(HttpRequestHeader requestHeader,String mylistid) throws IOException {
		Integer myid=0;
		try{
			myid=Integer.parseInt(mylistid);
		} catch (NumberFormatException e) {
			return setResponseText("Eroor!\n");
		}
		StringBuffer sb = new StringBuffer();
		String smid  = "";
		String str   = "";
		String imgid = "";
		String desc  = "";
		String memo  = "";
		ConcurrentHashMap<String, String> myMap = getMyListMap(requestHeader,mylistid);
		ConcurrentHashMap<String, String> dataMap = null;/*{*/
		Pattern mappat = Pattern.compile("^.*?([a-z0-9]+)=(.+?)((?:,\\s+|\\}).*)$");
		String linkdata = htmlFaAddString(mylistid,"001")+" / "+htmlFaRemoveString(mylistid,"002");
		if(myMap!= null && myMap.size()>0){
			String title   = myMap.get("title");
			String myowner = myMap.get("creator");
			String mydesc = "";
			if(myMap.get("desc")==null){mydesc = null;
			}else{mydesc = htmlRegexpString(myMap.get("desc"));}
			sb.append(htmlHearderString(mylistid+"_"));
			sb.append("<div id=\"left\">\n\n");
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">MyList/Size-"+myMap.size()+" / "+linkdata+"</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\"../mylist/"+mylistid+"\">MyList Page</a><br>\n");
			sb.append(title+" / "+myowner+" <br>\n");
			if(mydesc != null)sb.append("<small>"+mydesc+"</small>\n");
			for (Map.Entry<String,String> e : myMap.entrySet()) {
				smid = e.getKey();
				if(smid.startsWith("title") || smid.startsWith("creator") || smid.startsWith("desc")){
					continue;
				}
				str = e.getValue();
				dataMap = new ConcurrentHashMap<String, String>();
				while(true){
					Matcher data_m = mappat.matcher(str);
					if (data_m.matches()) {
						dataMap.put(data_m.group(1),data_m.group(2));
						str = data_m.group(3);
					}else{break;}
				}
				imgid="http://tn-skr"+(rand.nextInt(4)+1)+".smilevideo.jp/smile?i="+smid.replaceFirst("[a-z]+","");
				desc = htmlRegexpString(dataMap.get("desc"));
				memo = htmlRegexpString(dataMap.get("memo"));
				if(memo != null){
					memo ="memo:" + memo +"<br>";
				}else{
					memo="";
				}
				if(ConfigFlagSimple){
					sb.append(htmlSimpleMyListString(smid,imgid,parStringInt(dataMap.get("count")),dataMap.get("title"),dataMap.get("data")," ",dataMap.get("len"),memo,desc));
				}else{
					sb.append(htmlDefaultString(smid,imgid,parStringInt(dataMap.get("count")),dataMap.get("title"),dataMap.get("data")," ",dataMap.get("len"),memo+desc));
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append(htmlHearderString(mylistid));
			sb.append("<div id=\"left\">\n\n");
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">MyList/Size-0/NoLink</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\"../mylist/"+mylistid+"\">MyList Page</a><br>\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeRankingList(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("RankingList"));
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">RankingList/</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		String rDay[] = {"hourly","daily","weekly","monthly","total"};
		String rType[] = {"view","res","mylist","fav"};
		String rKat[] = {"all"};
		sb.append("<a href=\""+URL_RANKING+"\">Ranking</a> / \n");
		sb.append("<a href=\"./ids?rankingtop\">RankingTop</a><br>\n");
/*		sb.append("<table border=1 cellpadding=5 cellspacing=0 style=\"margin-top:2px;\">\n");
		sb.append("<tr><th><strong>all</strong></th><th></th><th></th><th>T</th><th></th><th>v</th></tr>\n");
		for (int j = 0 ; j < rType.length ; j++){
			sb.append("<tr>\n<th>"+rType[j]+"</th>\n");
			for (int i = 0 ; i < rDay.length ; i++){
				sb.append("<td>");
				sb.append("<a href=\"./ids?ranking="+rType[j]+"/"+rDay[i]+"/"+rKat[0]+"\">"+rType[j]+"/"+rDay[i]+"/"+rKat[0]+"</a><br>");
				sb.append("</td>\n");
			}
			sb.append("</tr>");
		}
		sb.append("</table>\n<br>\n");
*/
		sb.append(makeRankingTableList("exp"));
		sb.append("<div id=\"exp\"> </div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeRanking(HttpRequestHeader requestHeader,String url) throws IOException {
		StringBuffer sb = new StringBuffer();
		String arraycon="";
		String watchurl="";
		String watchurl2="";
		String smdata="";
		String desc="";
		String[] linedata = new String[3];
		ArrayList<String> rankingListArray = getRankingRss(requestHeader,url);
		try{
			sb.append(htmlHearderString(rankingListArray.get(0)));
		}catch(IndexOutOfBoundsException e){
			rankingListArray=null;
			sb.append(htmlHearderString(""));
		}
		sb.append("<div id=\"left\">\n\n");
		if(rankingListArray != null){// || url == ""){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">RankingList/Size-"+(rankingListArray.size()-1)+"/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\"../ranking/"+url+"\">"+rankingListArray.get(0)+"</a> / \n");
			sb.append("<hr>");
			//sb.append(makeRankingTableList("exp"));
			//sb.append("<div id=\"exp\"></div>\n");
			for (int i = 1 ; i < rankingListArray.size() ; i++){
				arraycon = rankingListArray.get(i);
				linedata = arraycon.split("<>");
				watchurl = linedata[2];
				watchurl2 = watchurl.replaceAll(URL_WATCH+"(.+)","$1");
				desc = linedata[5];
				desc=htmlRegexpString(desc);
				smdata=linedata[10]+":"+linedata[11]+" "+linedata[12]+":"+linedata[13]+" "+linedata[14]+":"+linedata[15]+"  ";
				if(ConfigFlagSimple){
					sb.append(htmlSimpleString(watchurl2,linedata[4],i,linedata[1],linedata[8],smdata,linedata[7],desc));
				}else{
					sb.append(htmlDefaultString(watchurl2,linedata[4],i,linedata[1],linedata[8],smdata,linedata[7],desc));
				}
			}
			sb.append("<div id=\"exp2\"></div><br>\n");
			sb.append(makeRankingTableList("exp2"));
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">RankingList/Size-0/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\"../ranking/"+url+"\">Ranking Page</a><br>\n");
			//sb.append(makeRankingTableList("exp"));
			//sb.append("<div id=\"exp\"></div>\n");
			sb.append("<br>");
			sb.append("No Data<br>\n");
			sb.append("<br><div id=\"exp2\"></div>\n");
			sb.append(makeRankingTableList("exp2"));
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeRankingTop(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		String arraycon="";
		String watchurl="";
		String watchurl2="";
		String watchurl3="";
		String smdata="";
		String desc="";
		String[] linedata = new String[3];
		ArrayList<String> rankingListArray = getRankingTopRss(requestHeader);
		sb.append(htmlHearderString("RankingTop"));
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">RankingTop/Size-"+rankingListArray.size()+"/</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		sb.append("<a href=\""+URL_RANKING+"\">Ranking</a> / \n");
		sb.append("<a href=\"./ids?rankinglist\">RankingList</a><br>\n");
		if(rankingListArray != null){// || url == ""){
			if(false){
				if(ConfigFlagSimple){
					for (int i = 0 ; i < rankingListArray.size() ; i++){
						arraycon = rankingListArray.get(i);
						linedata = arraycon.split("<>");
						watchurl = linedata[2];
						watchurl2 = watchurl.replaceAll(URL_WATCH+"(.+)","$1");
						desc = linedata[5];
						desc=htmlRegexpString(desc);
						smdata=linedata[10]+":"+linedata[11]+" "+linedata[12]+":"+linedata[13]+" "+linedata[14]+":"+linedata[15]+"  ";
						//if(ConfigFlagSimple){
							sb.append(htmlSimpleString(watchurl2,linedata[4],i,linedata[1],linedata[8],smdata,linedata[7],desc));
						//}else{
						//	sb.append(htmlDefaultString(watchurl2,linedata[4],i,linedata[1],linedata[8],smdata,linedata[7],desc));
						//}
					}
				}
			}
			String[] rts = new String[3];
			String[] rtt = new String[3];
			sb.append("<table border=\"1\" cellspacing=\"0\" cellpadding=\"0\">");
			String sfs10="<span style=\"font-size:10pt;text-align:center;\">";
			String pfs9="<p style=\"font-size:9pt;text-align:center;margin:0; padding:0;\">";
			String sfe="</span>";
			String pfe="</p>";
			sb.append("<tr>\n<th><br></th>\n");
			sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_ENT+"\">G^EyEX|</a>"+sfe+"</th>\n");
			sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_LIFE+"\">{E</a>"+sfe+"</th>\n");
			sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_POLITICS+"\"></a>"+sfe+"</th>\n");
			sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_TRY+"\">Ă݂</a>"+sfe+"</th>\n");
			sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_CULTURE+"\">AjEQ[</a>"+sfe+"</th>\n");
			sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_POPULAR+"\">a</a>"+sfe+"</th>\n");
			sb.append("</tr>\n");
			for (int i = 0 ; i < rankingListArray.size()/6 ; i++){
				sb.append("<tr><td><div style=\"width:30px; overflow:hidden;text-align:center;\">"+sfs10+(i+1)+sfe+"</div></td>\n");
				for (int j = 0 ; j < 6 ; j++){
					rts=rankingListArray.get(j*20+i).split("<>");
					watchurl = rts[2];
					watchurl2 = watchurl.replaceAll("http://[\\s\\S]+watch/(.+)","$1");
					watchurl3 = watchurl2.replaceAll("low","");
					rtt=rts[1].split("F",2);
					sb.append("<td valign=\"top\"><div style=\"width:113px; overflow:hidden;\">\n");
					sb.append(htmlImgString(rts[4],watchurl2,rts[7],87,87,false)+"\n");
					sb.append(pfs9+htmlAlinkClassPlus(watchurl2,rtt[1])+"<br>");
					sb.append(htmlFetchString(watchurl3,3+""));
					sb.append(pfe+"</div></td>\n");
				}
				sb.append("</tr>\n");
			}
			sb.append("</table>\n");
			sb.append("<hr><div id=\"exp\"> </div><br>\n");
			sb.append(makeRankingTableList("exp"));
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeMyvideo(HttpRequestHeader requestHeader,String videoid) throws IOException {
		StringBuffer sb = new StringBuffer();
		String[] linedata = new String[11];
		String data = "";
		String desc = "";
		String watchurl="";
		String watchurl2="";
		ArrayList<String> myvideoListArray = getMyvideoRss(requestHeader,videoid);
		sb.append(htmlHearderString("MyVideoList"));
		sb.append("<div id=\"left\">\n\n");
		if(myvideoListArray!=null && myvideoListArray.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">MyVideoList/Size-"+myvideoListArray.size()+"/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_NICONICOTOP+"user/"+videoid+"/video\">MyVideo Page</a><br>\n");
			for (int i = 0 ; i < myvideoListArray.size() ; i++){
				data = myvideoListArray.get(i);
				linedata = data.split("<>");
				watchurl = linedata[2];
				watchurl2 = watchurl.replaceAll(URL_WATCH+"(.+)","$1");
				desc = linedata[5];
				desc=htmlRegexpString(desc);
				if(ConfigFlagSimple){
					sb.append(htmlSimpleString(watchurl2,linedata[4],i,linedata[1],linedata[7]," ",linedata[6],desc));
				}else{
					sb.append(htmlDefaultString(watchurl2,linedata[4],i,linedata[1],linedata[7]," ",linedata[6],desc));
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">MyVideoList/Size-0/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		myvideoListArray=null;
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeOpenMylist(HttpRequestHeader requestHeader,String videoid) throws IOException {
		StringBuffer sb = new StringBuffer();
		ArrayList<String> openMyList = getOpenMylist(requestHeader,videoid,1);
		if(openMyList!=null&& openMyList.size()>0){
			ArrayList<String> openMyList2 = getOpenMylist(requestHeader,videoid,2);
			if(openMyList2!=null&& openMyList2.size()>0){
				openMyList.addAll(openMyList2);
				openMyList2=null;
				ArrayList<String> openMyList3 = getOpenMylist(requestHeader,videoid,3);
				if(openMyList3!=null&& openMyList3.size()>0){
					openMyList.addAll(openMyList3);
					openMyList3=null;
					ArrayList<String> openMyList4 = getOpenMylist(requestHeader,videoid,4);
					if(openMyList4!=null&& openMyList4.size()>0){
						openMyList.addAll(openMyList4);
						openMyList4=null;
						ArrayList<String> openMyList5 = getOpenMylist(requestHeader,videoid,5);
						if(openMyList5!=null&& openMyList5.size()>0){
							openMyList.addAll(openMyList5);
							openMyList5=null;
						}
					}
				}
			}
		}
		String line="";
		String linedata[]= new String[5];
		int num=0;
		sb.append(htmlHearderString("OpenMyListList"));
		sb.append("<div id=\"left\">\n\n");
		if(openMyList.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">OpenMyList/Size-"+openMyList.size()+"/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_OPENLIST+videoid+"?page=1&sort=c&order=d\">OpenMyList Page</a><br>\n");
			sb.append("<table width=\"100%\" class=\"sortable\" id=\"list\">\n");
			sb.append("<tr><th>num</th><th>MyListId</th><th>Title</th><th class=\"unsortable\">data</th></tr>\n");
			for (int i = 0 ; i <openMyList.size() ; i++){
				line = openMyList.get(i);
				linedata=line.split("<>");
				num =parStringInteger(linedata[0]);
				sb.append("<tr><td>");
				if(num<10)sb.append("0");
				sb.append(num+"</td><td class=\"table_num\">");
				sb.append(htmlTabeSort(linedata[1]));
				sb.append("<a href=\"./ids?mylist="+linedata[1]+"\">"+linedata[1]+"</a></td>");
				sb.append("<td class=\"table_title\">"+linedata[2]+"</td>");
				sb.append("<td>");
				sb.append(htmlFaAddString(linedata[1],num+"")+" / ");
				sb.append(htmlFaRemoveString(linedata[1],num+""));
				sb.append("</td>");
				sb.append("</tr>\n");
			}
			sb.append("</table>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">OpenMyList/Size-0/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_OPENLIST+videoid+"?page=1&sort=c&order=d\">OpenMyList Page</a><br>\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		openMyList=null;
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeSearch(HttpRequestHeader requestHeader,String word) throws IOException {
		return setResponseText("NONE...");
	}
	private StringResource makeFetchingList(HttpRequestHeader requestHeader) throws IOException {
		if(!ConfigFlagFetcher){
			return setResponseText("No FetcherFlag...");
		}else{
			getFetchingJSON(requestHeader,false);
		}
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("FetchingList"));
		sb.append("<div id=\"left\">\n\n");
		String data="";
		String[] linedata = new String[3];
		String smid="";
		String imgid="";
		if(FETCHINGLIST.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">FetchingList/Size-"+FETCHINGLIST.size()+"/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\"fetch?status=all\">Fetching Page</a><br>\n");
			for (int i = 0 ; i <FETCHINGLIST.size() ; i++){
				data = FETCHINGLIST.get(i);
				linedata = data.split("<>");
				smid=linedata[2];
				imgid="http://tn-skr"+(rand.nextInt(4)+1)+".smilevideo.jp/smile?i="+linedata[1];
				if(ConfigFlagSimple){
					sb.append(htmlSimpleFetchString(smid,imgid,i,linedata[3]));
				}else{
					sb.append(htmlDefaultString(smid,imgid,i,linedata[3],"","","","none"));
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">FetchingList/Size-0/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\"fetch?status=all\">Fetching Page</a><br>\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeFetchAll(HttpRequestHeader requestHeader,String videoids) throws IOException {
		if(!ConfigFlagFetcher)return setResponseText("No FetcherFlag...");
		StringBuffer sb = new StringBuffer();
		String[] linedata = new String[3];
		String[] spid = new String[3];
		String data="";
		String smid="";
		String imgid="";
		String respons="";
		int count=0;
		spid=videoids.split("\\+");
		sb.append(htmlHearderString("FetchAllList"));
		sb.append("<div id=\"left\">\n\n");
		if(videoids.length() > 2){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">FetchAllList/Size-"+spid.length+"/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			for (String videoid : spid) {
				count+=1;
				imgid=videoid.replaceAll("^[a-z]+","");
				imgid="http://tn-skr"+(rand.nextInt(4)+1)+".smilevideo.jp/smile?i="+imgid;
				respons=getFetch(requestHeader,videoid);
				sb.append(htmlSimpleFetchString(videoid,imgid,count,respons));
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">FetchAllList/Size-0/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeFetchedList(HttpRequestHeader requestHeader) throws IOException {
		if(!ConfigFlagFetcher){
			return setResponseText("No FetcherFlag...");
		}else{
			getFetchJSON(requestHeader,false);
		}
		StringBuffer sb = new StringBuffer();
		String data="";
		String[] linedata = new String[3];
		String smid="";
		String imgid="";
		String smlink="";
		sb.append(htmlHearderString("FetchedList"));
		sb.append("<div id=\"left\">\n\n");
		if(FETCHLIST.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">FetchedList/Size-"+FETCHLIST.size()+"/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\"fetch?list\">FetchedAPI</a> / \n");
			sb.append("<a href=\"../local/fetched.html\">Fetched LocalPage</a><br>\n");
			if(!ConfigFlagSimple){
				sb.append("<table width=\"100%\" class=\"sortable\" id=\"list\">\n");
				sb.append("<tr><th width=\"65px\" class=\"unsortable\">img</th><th>ID</th><th>ID2</th><th>title</th></tr>\n");
			}
			for (int i = FETCHLIST.size()-1 ; i >=0 ; i--){
				data = FETCHLIST.get(i);
				linedata = data.split("<>");
				smid=linedata[2];
				imgid="http://tn-skr"+(rand.nextInt(4)+1)+".smilevideo.jp/smile?i="+linedata[1];
				if(ConfigFlagSimple){
					sb.append(htmlSimpleFetchedString(smid,imgid,i,linedata[3],"","","none"));
				}else{
					smlink=htmlSmLinks(smid,i+"",1+"",true);
					sb.append("<tr>");
					sb.append("<td>"+htmlImgString(imgid,smid,"",2,2,false)+"</td>");//time_null
					sb.append("<td>"+smid+"</td>");
					sb.append("<td class=\"table_num\">");
					sb.append(htmlTabeSort(smid));
					sb.append(smid.substring(2)+"</td>");
					sb.append("<td class=\"table_title\">"+htmlAlinkClassPlus(smid,linedata[3])+" / ");
					sb.append(smlink+"</td>");
					sb.append("</tr>\n");
				}
			}
			if(!ConfigFlagSimple)
				sb.append("</table>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">FetchedList/Size-0/</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\"fetch?list\">FetchedAPI</a> / \n");
			sb.append("<a href=\"../local/fetched.html\">Fetched LocalPage</a><br>\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeInfiMyList(HttpRequestHeader requestHeader) throws IOException {
		if(!ConfigFlagInfiMylist)return setResponseText("No InfiFlag...");
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		String data="";
		String linedata[] = new String[1];
		String desc="";
		String watchurl="";
		String smdata="";
		String smlink="";
		int count=0;
		bout.write(htmlHearderString("InfityMyList").getBytes("UTF-8"));
		bout.write("<div id=\"left\">\n\n".getBytes("UTF-8"));
		if(INFIMYLISTLIST.size()>0){
			bout.write("<div class=\"left_all\">\n".getBytes("UTF-8"));
			bout.write(("<h2 class=\"left_title\">InfityMyList/Size-"+INFIMYLISTLIST.size()+"/</h2>\n").getBytes("UTF-8"));
			bout.write("<div class=\"left_body\">\n".getBytes("UTF-8"));
			bout.write("<div class=\"left_text\">\n\n".getBytes("UTF-8"));
			bout.write(("<a href=\"../local/"+ConfigFileInfi.getName()+"\">InfityMyList Txt Page</a> / <br>\n").getBytes("UTF-8"));
			for (int i = INFIMYLISTLIST.size()-1 ; i >= 0 ; i--){
				count+=1;
				if(count>=2000) break;
				data = INFIMYLISTLIST.get(i);
				linedata = data.split("<>");
				desc = linedata[10];
				desc=htmlRegexpString(desc);
				watchurl = linedata[2];
				smdata="Đ:"+linedata[6]+" R:"+linedata[7]+" }CX:"+linedata[8]+"  ";
				smlink="link";
				if(ConfigFlagSimple){
					bout.write(htmlSimpleString(watchurl,linedata[4],i,linedata[3],linedata[5],smdata,linedata[9],desc).getBytes("UTF-8"));
				}else{
					bout.write((htmlDefaultString(watchurl,linedata[4],i,linedata[3],linedata[5],smdata,linedata[9],desc)+"\n\n").getBytes("UTF-8"));
				}
			}
			bout.write("</div>\n".getBytes("UTF-8"));
			bout.write("</div>\n".getBytes("UTF-8"));
			bout.write("</div>\n".getBytes("UTF-8"));
		}else{
			bout.write("No Data<br>\n".getBytes("UTF-8"));
		}
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write(htmlFooterString(requestHeader).getBytes("UTF-8"));
		return setResponseText(bout.toByteArray(), "text/html");
	}
	private StringResource makeFaMyList(HttpRequestHeader requestHeader) throws IOException {
		if(!ConfigFlagFaMylist)return setResponseText("No FaFlag...");
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		String data="";
		String linedata[] = new String[5];
		bout.write(htmlHearderString("FavoriteMyList").getBytes("UTF-8"));
		bout.write("<div id=\"left\">\n\n".getBytes("UTF-8"));
		if(FAMYLISTLIST.size()>0){
			bout.write("<div class=\"left_all\">\n".getBytes("UTF-8"));
			bout.write(("<h2 class=\"left_title\">FavoriteMyList/Size-"+FAMYLISTLIST.size()+"/</h2>\n").getBytes("UTF-8"));
			bout.write("<div class=\"left_body\">\n".getBytes("UTF-8"));
			bout.write("<div class=\"left_text\">\n\n".getBytes("UTF-8"));
			bout.write(("<a href=\"../local/"+ConfigFileFa.getName()+"\">FavoriteMyList Txt Page</a> / <br>\n").getBytes("UTF-8"));
			bout.write("<table width=\"100%\" class=\"sortable\" id=\"list\">\n".getBytes("UTF-8"));
			bout.write("<tr><th>MyListId</th><th>Title</th><th>Memo</th><th>Del</th></tr>\n".getBytes("UTF-8"));
			for (int i = FAMYLISTLIST.size()-1 ; i >= 0  ; i--){
				data = FAMYLISTLIST.get(i);
				linedata = data.split("<>");
				bout.write("<td class=\"table_num\">".getBytes("UTF-8"));
				bout.write(htmlTabeSort(linedata[1]).getBytes("UTF-8"));
				bout.write(("<a href=\"./ids?mylist="+linedata[1]+"\">"+linedata[1]+"</a>").getBytes("UTF-8"));
				bout.write("</td>".getBytes("UTF-8"));
				bout.write(("<td class=\"table_title\">"+linedata[2]+"</td>").getBytes("UTF-8"));
				bout.write(("<td class=\"table_title\">"+linedata[3]+"</td>").getBytes("UTF-8"));
				bout.write("<td>".getBytes("UTF-8"));
				bout.write(htmlFaRemoveString(linedata[1],i+"").getBytes("UTF-8"));
				bout.write("</td>".getBytes("UTF-8"));
				bout.write("</tr>\n".getBytes("UTF-8"));
			}
			bout.write("</table>\n".getBytes("UTF-8"));
			bout.write("</div>\n".getBytes("UTF-8"));
			bout.write("</div>\n".getBytes("UTF-8"));
			bout.write("</div>\n".getBytes("UTF-8"));
		}else{
			bout.write("No Data<br>\n".getBytes("UTF-8"));
		}
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write(htmlFooterString(requestHeader).getBytes("UTF-8"));
		return setResponseText(bout.toByteArray(), "text/html");
	}
	private StringResource makeTempList(HttpRequestHeader requestHeader) throws IOException {
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		bout.write(htmlHearderString("TempCacheList").getBytes("UTF-8"));
		bout.write("<div id=\"left\">\n\n".getBytes("UTF-8"));
		bout.write("<div class=\"left_all\">\n".getBytes("UTF-8"));
		bout.write(("<h2 class=\"left_title\">TempList/</h2>\n").getBytes("UTF-8"));
		bout.write("<div class=\"left_body\">\n".getBytes("UTF-8"));
		bout.write("<div class=\"left_text\">\n\n".getBytes("UTF-8"));
		bout.write("<a href=\"./ajax\">TempList</a><br>\n".getBytes("UTF-8"));
		if(!ConfigFlagSimple){
			bout.write("<table width=\"100%\" class=\"sortable\" id=\"list\">\n".getBytes("UTF-8"));
			bout.write("<tr><th width=\"65px\" class=\"unsortable\">img</th><th>ID</th><th>ID2</th><th>title</th></tr>\n".getBytes("UTF-8"));
		}
		int count=1;
		String imgid="";
		String smlink="";
		String CacheRatio="";
		String vid="";
		String sid="";
		String iid="";
		for (String line : Cache.getTempListAsJson().split("\n")) {
			Matcher m = CACHETEMPLIST_JSON_PATTERN.matcher(line);
			if (m.matches()) {
				CacheRatio="";
				vid=m.group(1);
				sid=vid.replaceAll("low","");
				iid=sid.substring(2);
				imgid="http://tn-skr"+(rand.nextInt(4)+1)+".smilevideo.jp/smile?i="+iid;
				long nows = parStringLong(m.group(3));
				long maxs = parStringLong(m.group(4));
				if(m.group(5).startsWith("true")){
					try{
						double sizeratio = (((double) nows / (double)maxs));
						if(maxs <= 1)sizeratio=0f;
						CacheRatio="<font color=\"red\">DLFlag=true / "+String.format("%.4f",sizeratio*100)+"% / "+
						"NowSize-"+String.format("%,d",nows/1024)+"KByte"+" / TotalSize-"+String.format("%,d",maxs/1024)+"KByte</font>";
					} catch (ArithmeticException e) {
						CacheRatio="DLFlag=false /  0.0000% /"+String.format("%,d",nows/1024)+" Byts / TotalSize-"+String.format("%,d",maxs/1024)+"KByte";
					}
				}else{
					CacheRatio="DLFlag=false / 0.0000% / NowSize-"+String.format("%,d",nows/1024)+"KByte / TotalSize-"+String.format("%,d",maxs/1024)+"KByte";
				}
				if(ConfigFlagSimple){
					bout.write(htmlSimpleTmpString(vid,imgid,count,m.group(2),"","",CacheRatio).getBytes("UTF-8"));
				}else{
					smlink=htmlSmLinks(sid,count+"",1+"",false);
					bout.write("<tr>".getBytes("UTF-8"));
					bout.write(("<td>"+htmlImgString(imgid,sid,"",2,2,false)+"</td>").getBytes("UTF-8"));//time_null
					bout.write(("<td>"+vid+"</td>").getBytes("UTF-8"));
					bout.write("<td class=\"table_num\">".getBytes("UTF-8"));
					bout.write(htmlTabeSort(m.group(1)).getBytes("UTF-8"));
					bout.write((iid+"</td>").getBytes("UTF-8"));
					bout.write(("<td class=\"table_title\">"+htmlAlinkClassPlus(sid,m.group(2))+"<br>"+CacheRatio+"<br>").getBytes("UTF-8"));
					bout.write((smlink+"</td>").getBytes("UTF-8"));
					bout.write("</tr>\n".getBytes("UTF-8"));
				}
				count+=1;
			}
		}
		if(count==1){
			if(ConfigFlagSimple){
				bout.write("No Data\n".getBytes("UTF-8"));
			}else{
				bout.write("<tr><td colspan=\"5\" align=\"center\">No Data</td></tr>\n".getBytes("UTF-8"));
			}
		}
		if(!ConfigFlagSimple){
			bout.write("</table>\n".getBytes("UTF-8"));
		}
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write(htmlFooterString(requestHeader).getBytes("UTF-8"));
		return setResponseText(bout.toByteArray(), "text/html");
	}
	private StringResource makeLowList(HttpRequestHeader requestHeader) throws IOException {
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		bout.write(htmlHearderString("LowCacheList").getBytes("UTF-8"));
		bout.write("<div id=\"left\">\n\n".getBytes("UTF-8"));
		Map<String, File> caches = Cache.getId2File();
		if (caches.size() != 0) {
			String[] idList = MovieIdSorter.sort(caches, true);
			String smid="";
			String title = "";
			String imgid="";
			String fn="";
			String smlink="";
			int count=0;
			bout.write("<div class=\"left_all\">\n".getBytes("UTF-8"));
			bout.write(("<h2 class=\"left_title\">LowList</h2>\n").getBytes("UTF-8"));
			bout.write("<div class=\"left_body\">\n".getBytes("UTF-8"));
			bout.write("<div class=\"left_text\">\n\n".getBytes("UTF-8"));
			bout.write("<a href=\"./ids\">CacheList</a><br>\n".getBytes("UTF-8"));
			if(!ConfigFlagSimple){
				bout.write("<table width=\"100%\" class=\"sortable\" id=\"list\">\n".getBytes("UTF-8"));
				bout.write("<tr><th width=\"65px\" class=\"unsortable\">img</th><th>ID</th><th>ID2</th><th>title</th></tr>\n".getBytes("UTF-8"));
			}
			for (String id: idList){
				File cFile = caches.get(id);
				fn = cFile.getName();
				title = "";
				if (fn.length() > id.length()+5)title = fn.substring(id.length()+1, fn.length()-4);
				if(id.endsWith("low")){
					count+=1;
					smid =id;
					id =id.replaceAll("low","");
					imgid =id.replaceAll("^[a-z]+","http://tn-skr"+(rand.nextInt(4)+1)+".smilevideo.jp/smile?i=");
					if(ConfigFlagSimple){
						bout.write(htmlSimpleString(id,imgid,count-1,title,"","","","none").getBytes("UTF-8"));
					}else{
						smlink=htmlSmLinks(id,count+"",1+"",false);
						bout.write("<tr>".getBytes("UTF-8"));
						bout.write(("<td>"+htmlImgString(imgid,id,"",2,2,false)+"</td>").getBytes("UTF-8"));//time_null
						bout.write(("<td>"+smid+"</td>").getBytes("UTF-8"));
						bout.write("<td class=\"table_num\">".getBytes("UTF-8"));
						bout.write(htmlTabeSort(id).getBytes("UTF-8"));
						bout.write((id.substring(2)+"</td>").getBytes("UTF-8"));
						bout.write(("<td class=\"table_title\">"+htmlAlinkClassPlus(id,title)+"<br>").getBytes("UTF-8"));
						bout.write((smlink+"</td>").getBytes("UTF-8"));
						bout.write("</tr>\n".getBytes("UTF-8"));
					}
				}
			}
			if(count == 0){
				bout.write("No Data<br>\n".getBytes("UTF-8"));
			}
			if(!ConfigFlagSimple){
				bout.write("</table>\n".getBytes("UTF-8"));
			}
			bout.write("</div>\n".getBytes("UTF-8"));
			bout.write("</div>\n".getBytes("UTF-8"));
			bout.write("</div>\n".getBytes("UTF-8"));
		}else{
			bout.write("No Data<br>\n".getBytes("UTF-8"));
		}
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write(htmlFooterString(requestHeader).getBytes("UTF-8"));
		caches=null;
		return setResponseText(bout.toByteArray(), "text/html");
	}
	private StringResource makeMyMyList(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("MyMyList"));
		ArrayList<String> myMylistList = getMyMyListList(requestHeader);
		ArrayList<String> myDefMylist = getMyDefMyList(requestHeader);
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">My MyList</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		sb.append("<a href=\"../my\">My Page</a> / \n");
		sb.append("<br>\n");
		String line="";
		String linedata[] = new String[3];
		String imgid="";
		if(myDefMylist!=null && myDefMylist.size()>0){
			sb.append("<hr>Ƃ肠}CXg / "+myDefMylist.size()+"<br>");
			for (int i = 0 ; i < myDefMylist.size() ; i++){
				line = myDefMylist.get(i);
				linedata = line.split("<>");
				sb.append("<a href=\"./ids?data="+linedata[4]+"&b\">"+linedata[4]+"</a> / "+convUnescape(linedata[5])+"<br>\n");
				sb.append("----"+convUnixtime(linedata[7],0)+" e ("+convUnixtime(linedata[18],0)+" o^) / \n");
//				sb.append("----"+convUnescape(linedata[3]).replaceAll("(\\\\n)+","")+"<br>\n");
				sb.append("Đ:"+linedata[9]+" Rg:"+linedata[10]+" }CXg:"+linedata[11]+" / "+parStringInteger(linedata[13])/60+":"+parStringInteger(linedata[13])%60+"<br>\n");
			}
		}
		if(myMylistList!=null && myMylistList.size()>0){
			sb.append("<hr>}CXg / "+myMylistList.size()+"<br>");
			for (int i = 0 ; i < myMylistList.size() ; i++){
				line = myMylistList.get(i);
				linedata = line.split("<>");
				sb.append("id:<a href=\"./ids?mylist="+linedata[1]+"\">"+linedata[1]+"</a> / name:"+convUnescape(linedata[2])+"<br>\n");
//				sb.append("----"+convUnescape(linedata[3]).replaceAll("(\\\\n)+","")+"<br>"+convUnixtime(linedata[4],0)+"/"+convUnixtime(linedata[5],0)+"<br>\n");
				ArrayList<String> list = getMyMyList(requestHeader,linedata[1]);
				if(list!=null && list.size()>0){
					for (int j = 0 ; j < list.size() ; j++){
						line = list.get(j);
						linedata = line.split("<>");
						sb.append("----<a href=\"./ids?data="+linedata[4]+"&b\">"+linedata[4]+"</a> / "+convUnescape(linedata[5])+"<br>\n");
						sb.append("--------"+convUnixtime(linedata[7],0)+" e ("+convUnixtime(linedata[18],0)+" o^) / \n");
//						sb.append("--------"+convUnescape(linedata[3]).replaceAll("(\\\\n)+","")+"<br>\n");
						sb.append("Đ:"+linedata[9]+" Rg:"+linedata[10]+" }CXg:"+linedata[11]+" / "+parStringInteger(linedata[13])/60+":"+parStringInteger(linedata[13])%60+"<br>\n");
					}
				}
			}
		}
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeMyPage(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("MyPage"));
		ArrayList<String> myhistory = getMyHistory(requestHeader);
		ArrayList<String> myCommunity = getCommunity(requestHeader);
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">My Page</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		sb.append("<a href=\"../my\">My Page</a> / \n");
		sb.append("<a href=\"../history\">Histry Page</a> / \n");
		sb.append("<a href=\""+URL_COMYU+"\">Community Page</a> / \n");
		sb.append("<a href=\""+URL_LIVE_MY+"\">My Live Top</a><br>\n");
//		sb.append("<br>\n");
		String line="";
		String linedata[] = new String[3];
		String imgid="";
		sb.append(htmlNowLiveTable(requestHeader));
		sb.append(htmlGateLiveTable(requestHeader));
		if(myCommunity!=null && myCommunity.size()>0){
			sb.append("<hr>\nQR~jeB / "+myCommunity.size()+"<br>");
			sb.append("<table width=\"100%\" class=\"sortable\" id=\"list\">\n");
			sb.append("<tr><th class=\"unsortable\">Community</th><th class=\"unsortable\">Community</th></tr>\n");
			for (int i = 0 ; i < myCommunity.size() ; i++){
				line = myCommunity.get(i);
				linedata = line.split("<>");
				if(i%2 == 0){sb.append("<tr>\n");}
				sb.append("<td><a href=\""+URL_COMYU+linedata[1]+"\">"+linedata[2]+"</a>/"+linedata[1]+"</td>\n");
				if(i%2 == 1){sb.append("</tr>");}
			}
			if(myCommunity.size()%2 != 0){sb.append("<td><br></td></tr>");}
			sb.append("</table>\n");
		}
		if(myhistory!=null && myhistory.size()>0){
			sb.append("<hr>\nς / "+myhistory.size()+"<br>");
//			sb.append("<td><a href=\"http://www.nicovideo.jp/history?c=clear\">폜@mFȂ</a></td>\n");
			if(!ConfigFlagSimple){
				sb.append("<table width=\"100%\" class=\"sortable\" id=\"list\">\n");
				sb.append("<tr><th width=\"65px\" class=\"unsortable\">img</th><th>ID</th><th>ID2</th><th>title</th></tr>\n");
			}
			String smlink="";
			String smid="";
			for (int i = 0 ; i < myhistory.size() ; i++){
				line = myhistory.get(i);
				linedata = line.split("<>");
				smid=linedata[1];
				imgid="http://tn-skr"+(rand.nextInt(4)+1)+".smilevideo.jp/smile?i="+linedata[1].substring(2);
				if(ConfigFlagSimple){
					sb.append(htmlSimpleString(smid,imgid,i,linedata[2],"","","","none"));
				}else{
					smlink=htmlSmLinks(smid,i+"",2+"",false);
					sb.append("<tr>");
					sb.append("<td>"+htmlImgString(imgid,smid,"",2,2,false)+"</td>");//time_null
					sb.append("<td>"+smid+"</td>");
					sb.append("<td class=\"table_num\">");
					sb.append(htmlTabeSort(smid));
					sb.append(smid.substring(2)+"</td>");
					sb.append("<td class=\"table_title\">"+htmlAlinkClassPlus(smid,linedata[2])+"<br>");
					sb.append(smlink+"</td>");
					sb.append("</tr>\n");
				}
			}
			if(!ConfigFlagSimple)
				sb.append("</table>\n");
		}else{
			sb.append("<hr>\nς / 0<br>");
			sb.append("NoData<br>");
		}
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeList(HttpRequestHeader requestHeader) throws IOException {
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		bout.write(htmlHearderString("CacheList").getBytes("UTF-8"));
		bout.write("<div id=\"left\">\n\n".getBytes("UTF-8"));
		Map<String, File> caches = Cache.getId2File();
		if (caches.size() != 0) {
			String[] idList = MovieIdSorter.sort(caches, true);
			String smid="";
			String imgid="";
			String title = "";
			String fn="";
			String sflag=" class=\"unsortable\"";
			int count=0;
			File cFile=null;
			bout.write("<div class=\"left_all\">\n".getBytes("UTF-8"));
			bout.write(("<h2 class=\"left_title\">CacheList/Size-"+idList.length+"/</h2>\n").getBytes("UTF-8"));
			bout.write("<div class=\"left_body\">\n".getBytes("UTF-8"));
			bout.write("<div class=\"left_text\">\n\n".getBytes("UTF-8"));
			bout.write("<a href=\"./ids?lowlist\">LowCacheList</a> / \n".getBytes("UTF-8"));
			bout.write("<a href=\"./ids?templist\">TmpCacheList</a> / \n".getBytes("UTF-8"));
			if(ConfigFlagListSort)sflag = "";
			bout.write("<table width=\"100%\" class=\"sortable\" id=\"list\">\n".getBytes("UTF-8"));
			String delth="<th class=\"unsortable\">Del</th>";
			String xmlth="<th class=\"unsortable\">xml</th>";
			bout.write(("<tr><th class=\"unsortable\">Img</th><th class=\"unsortable\">data</th>"+
//					"<th"+sflag+">watch</th>"+
					"<th"+sflag+">id</th>"+
					"<th"+sflag+">title</th>"+
					"<th class=\"unsortable\">Del</th></tr>\n").getBytes("UTF-8"));
			for (String id: idList){
				cFile = caches.get(id);
				fn = cFile.getName();
				if (fn.length() > id.length()+5)
					title = fn.substring(id.length()+1, fn.length()-4);
				if(matchPattern(NGIDLIST,id) || matchPattern(NGTITLELIST,title)){
				}else{
					count+=1;
					smid=id.replaceAll("low","");
					imgid=smid.replaceAll("\\D","");
					bout.write("<tr>".getBytes("UTF-8"));
					bout.write(("<td><div class=\"java\" id=\""+imgid+"\"><a href=\"javascript:void(0)\" onclick=\"openImg('"+imgid+"')\">img</a></div></td>").getBytes("UTF-8"));
					bout.write(("<td><a href=\"./ids?data="+smid+"&amp;b\">Data</a></td>").getBytes("UTF-8"));
					bout.write(("<td><a href=\"../watch/"+id+"\">"+id+"</a></td>").getBytes("UTF-8"));
					bout.write(("<td>"+title+"</td>").getBytes("UTF-8"));
					bout.write(("<td>"+htmlNlRemoveString(smid,count+"")+"</td>").getBytes("UTF-8"));
					bout.write("</tr>\n".getBytes("UTF-8"));
				}
			}
			if(count == 0){
				bout.write("<tr><td colspan=\"5\" align=\"center\">No Data</td></tr>\n".getBytes("UTF-8"));
			}
			bout.write("</table>\n".getBytes("UTF-8"));
			bout.write("</div>\n".getBytes("UTF-8"));
			bout.write("</div>\n".getBytes("UTF-8"));
			bout.write("</div>\n".getBytes("UTF-8"));
		}
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write(htmlFooterString(requestHeader).getBytes("UTF-8"));
		caches=null;
		return setResponseText(bout.toByteArray(), "text/html");
	}
	private StringResource makeGraph(HttpRequestHeader requestHeader,String videoid) throws IOException {
		if(!ConfigFlagAmi) return setResponseText("NG");
		String title="";
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString());
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">Graph</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		ConcurrentHashMap<String, String> mapInfo = getInfoData(requestHeader, videoid);
		if (mapInfo.containsKey("title")){
			title = mapInfo.get("title");
		}else if(mapInfo.containsKey("description")){
			title = mapInfo.get("description");
		}else{
			title=null;
		}
		ConcurrentHashMap<String,Integer> vpc = new ConcurrentHashMap<String,Integer>();
		if(title.startsWith("not")){
			return setResponseText("NotFound...");
		}else if(title.startsWith("del")){
			return setResponseText("Deleted...");
		}else if(title.startsWith("com")){
			return setResponseText("Com...");
		}else{
			vpc = setAmiVposData(requestHeader,videoid);
			if(vpc==null){
				return setResponseText("Error...");
			}
		}
		String lenvpos="5:00";
		if(mapInfo.containsKey("length")){
			lenvpos=mapInfo.get("length");
		}
		String lenlist[] = lenvpos.split(":");
		int v1=0;int v2=0;
		int lvp=1000;
		v1=parStringInteger(lenlist[0]);
		v2=parStringInteger(lenlist[1]);
		lvp=v1*60+v2;
		//---------------------------------------------------------------------------------------------
		setAmiGData(vpc,lvp);
		//---------------------------------------------------------------------------------------------
		saveAmiXML(lvp);
		//---------------------------------------------------------------------------------------------
		sb.append(videoid+" / "+lenvpos+"<br>\n");
		sb.append("<script type=\"text/javascript\" src=\"../local/amline/swfobject.js\"></script>\n");
		sb.append("<div id=\"flashcontent\">\n<strong>You need to upgrade your Flash Player</strong>\n</div>\n");
		sb.append("<script type=\"text/javascript\">\n");
		sb.append("var so = new SWFObject(\"../local/amline/amline.swf\", \"amline\", \"600\", \"150\", \"8\", \"#FFFFFF\");\n");
		sb.append("so.addVariable(\"path\", \"../local/amline/\");\n");
		sb.append("so.addVariable(\"settings_file\", encodeURIComponent(\"../local/amline/amline_settings.xml\"));\n");
		sb.append("so.addVariable(\"data_file\", encodeURIComponent(\"../local/amline/amline_data.xml\"));\n");
		sb.append("so.write(\"flashcontent\");\n");
		sb.append("</script>\n");
		//---------------------------------------------------------------------------------------------
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeWatch(HttpRequestHeader requestHeader,String videoid) throws IOException {
		return setResponseText("DELEAT @"+NLTITLE);
/*		videoid =videoid.replaceAll("low","");
		String extension = ".";//cache2.getPostfix();
		StringBuffer sb = new StringBuffer();
		Cache cache = new Cache(videoid);
		Cache cache2 = new Cache(videoid+"low");
		if (!cache.exists() && !cache2.exists()) {
			return setResponseText("NG");
		}
		if(cache.exists()){
			extension = cache.getPostfix();
		}else{
			extension = cache2.getPostfix();
		}
		String title="";
		ConcurrentHashMap<String, String> mapInfo = getInfoData(requestHeader, videoid);
		if (mapInfo.containsKey("title")){
			title = mapInfo.get("title");
		}else if(mapInfo.containsKey("description")){
			title = mapInfo.get("description");
		}else{
			title=null;
		}
		sb.append(htmlHearderString(videoid+extension+"_"+title));
		sb.append("<script type=\"text/javascript\"><!--\n");
		sb.append("function reaspect(r) {\n");
		sb.append("flvp = $('flvplayer');\n");
		sb.append("flvp_container = $('flvplayer_container');\n");
		sb.append("var obj = \"nico.videowindow.video_mc\";\n");
		sb.append("varw= flvp.TGetProperty(obj, 8);\n");
		sb.append("var h = flvp.TGetProperty(obj, 9);\n");
		sb.append("var y = flvp.TGetProperty(obj, 1);\n");
		sb.append("flvp.TSetProperty(obj, 9,w* r);\n");
		sb.append("flvp.TSetProperty(obj, 1, parseFloat(y) + (h -w* r) / 2);}\n");
		sb.append("function resize(p) {\n");
		sb.append("var swf=$('flvplayer');\n");
		sb.append("var swfc=$('flvplayer_container');\n");
		sb.append("swf.TSetProperty(\"_root\",2,p);\n");
		sb.append("swf.TSetProperty(\"_root\",3,p);\n");
		sb.append("swf.style.width=swfc.style.width=952*p/100+\"px\";\n");
		sb.append("swf.style.height=swfc.style.height=540*p/100+\"px\";}\n");
		sb.append("--></script>\n");
		sb.append("<div id=\"all\">\n\n");
		sb.append("<div class=\"all_all\">\n");
		sb.append("<h2 class=\"all_title\">Watch</h2>\n");
		sb.append("<div class=\"all_body\">\n");
		if(ConfigFlagHtml){
			sb.append("<a href=\"../watch/"+videoid+"\">watch Page</a> / \n");
			sb.append(htmlAlinkClassPlus(videoid,"Data Page")+" / \n");
			sb.append(htmlRelationString(videoid)+" / ");
			sb.append(htmlOpenString(videoid)+" / ");
			sb.append(htmlNlRemoveString(videoid,999+"")+" / ");
			sb.append("<br>\n");
		}
		String desc = mapInfo.get("description");
		desc=htmlRegexpString(desc);
		String es = URLEncoder.encode(title,"utf-8");
		String time = mapInfo.get("first_retrieve");
		String vc = mapInfo.get("view_counter");
		String cc = mapInfo.get("comment_num");
		String mc = mapInfo.get("mylist_counter");
		String len = mapInfo.get("length");
		time =time.replaceAll("^(\\d+)-(\\d+)-(\\d+)","$1N$2$3 ");
		time =time.replaceAll("\\+09:00|T","");
		sb.append("<div id=\"PAGEHEADER\"></div>\n");
		sb.append("<div id=\"PAGEBODY\">\n");
		sb.append("<div id=\"WATCHHEADER\">\n");
		sb.append("<div align=\"right\" style=\"float:right;padding:1px;margin:50px 180px 0px 0px;border:1px #555;display:block;\">");
		sb.append(htmlImgString(mapInfo.get("thumbnail_url"),videoid,mapInfo.get("length"),1,1,false)+"\n");
		sb.append("</div>\n");
		sb.append("e:"+time+" ");
		sb.append("Đ:"+vc+" R:"+cc+" }CXg:"+mc);
		sb.append("<h3>"+title+"</h3>\n");
		sb.append("<p style=\"width:650px;height:70px;overflow-y:auto;border-style:solid;padding:7px;border: medium solid #ccc;\">\n");
		sb.append(desc);
		sb.append("</p>\n");
		sb.append("</div>\n");
		sb.append("<table><tr><td><b>SIZE:<b></td><td><button onclick=\"resize(0)\">BGM</button>\n");
		sb.append("<button onclick=\"resize(25)\">x0.25</button>\n");
		sb.append("<button onclick=\"resize(50)\">x0.5</button>\n");
		sb.append("<button onclick=\"resize(75)\">x0.75</button>\n");
		sb.append("<button onclick=\"resize(100)\">x1.0</button>\n");
		sb.append("<button onclick=\"resize(125)\">x1.25</button>\n");
		sb.append("<button onclick=\"resize(150)\">x1.5</button>\n");
		sb.append("<button onclick=\"resize(175)\">x1.75</button>\n");
		sb.append("<button onclick=\"resize(200)\">x2.0</button>\n");
		sb.append("<button onclick=\"resize(300)\">x3.0</button>\n");
		sb.append("<button onclick=\"resize(350)\">x3.5</button>\n");
		sb.append("<button onclick=\"resize(400)\">x4.0</button>\n");
		sb.append("</td></tr></table>\n");
		sb.append("<div id=\"flvplayer_container\" style=\"\"></div>\n");
		sb.append("<script type=\"text/javascript\" src=\"http://res.nicovideo.jp/js/watch.js?3\"></script>\n");
		sb.append("<script type=\"text/javascript\" src=\"http://res.nicovideo.jp/js/swfobject.js?4\"></script>\n");
		sb.append("<script type=\"text/javascript\"><!--\n");
		sb.append("var so = new SWFObject(\"http://www.nicovideo.jp/swf/new/nicoplayer.swf?ts=1253266244\", \"flvplayer\", \"952\", \"512\", 9, \"#FFFFFF\");\n");
		sb.append("so.addVariable(\"v\",  \""+videoid+"\");\n");
		sb.append("so.addVariable(\"videoId\", \""+videoid+"\");\n");
		sb.append("so.addVariable(\"deleted\", \"0\");\n");
		sb.append("so.addVariable(\"movie_type\", \"" + extension.replace(".", "") +"\");\n");
		sb.append("so.addVariable(\"thumbImage\", \""+mapInfo.get("thumbnail_url")+"\");\n");
		sb.append("so.addVariable(\"wv_title\", \""+es+"\");\n");
		sb.append("so.addVariable(\"thumbTitle\", \""+es+"\");\n");
		sb.append("so.addVariable(\"thumbDescription\", \""+NLTITLE+"\");\n");
		sb.append("so.addVariable(\"has_owner_thread\", \"1\");\n");
		sb.append("so.addVariable(\"button_threshold\", \"0\");\n");
		sb.append("so.addVariable(\"player_version_xml\", \"1253705998\");\n");
		sb.append("so.addParam(\"allowScriptAccess\", \"always\");\n");
		sb.append("so.addParam(\"allowFullScreen\", \"true\");\n");
		sb.append("so.write(\"flvplayer_container\");\n");
		sb.append("--></script>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("<div id=\"WATCHFOOTER\"></div>\n<div id=\"PAGEFOOTER\"><br></div>\n");
		sb.append("</div>\n");
		sb.append("<script type=\"text/javascript\" src=\""+URL_EXST_LOCAL+"keySeek.js\"></script>\n");
		sb.append("<script type=\"text/javascript\" src=\""+URL_EXST_LOCAL+"keyController.js\"></script>\n");
		sb.append(htmlFooterString(requestHeader,false));
		StringResource r = new StringResource(new String(sb));
		sb = null;
		r.setResponseHeader("Content-Type", "text/html");
		return r;
*/
	}
	private StringResource makeCacheJson(HttpRequestHeader requestHeader) throws IOException {
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		bout.write(htmlHearderString("CacheJson").getBytes("UTF-8"));
		bout.write("<div id=\"left\">\n\n".getBytes("UTF-8"));
		bout.write("<div class=\"left_all\">\n".getBytes("UTF-8"));
		bout.write("<h2 class=\"left_title\">CacheJson</h2>\n".getBytes("UTF-8"));
		bout.write("<div class=\"left_body\">\n".getBytes("UTF-8"));
		bout.write("<div class=\"left_text\">\n\n".getBytes("UTF-8"));
		bout.write("<a href=\"./ajax\">TempList</a><br>\n".getBytes("UTF-8"));
		//---------------------------------------------------------------------------------------------
		int linecount =1;
		for (String line : Cache.getDirListAsJson(false).split(",")) {
			if(linecount > 1){
				line = line.replaceAll("\"|\\[|\\]","");
				bout.write((line+"<br>\n").getBytes("UTF-8"));
			}
			linecount +=1;
		}
		bout.write("<br>\n".getBytes("UTF-8"));
		SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		for (String line : Cache.getTempListAsJson(false).split("\n")) {
			Matcher m = CACHETEMPLIST_JSON_PATTERN.matcher(line);
			if (m.matches()) {
				if(m.group(5).startsWith("true"))bout.write("<font color=\"red\">".getBytes("UTF-8"));
				bout.write((m.group(1)+"/"+m.group(2)+"/"+String.format("%,d",parStringLong(m.group(3))/1024)+"KByte/"+String.format("%,d",parStringLong(m.group(4))/1024)+"KByte/"+m.group(5)+"/<!--"+sdf1.format(new Date(parStringLong(m.group(6))*1000))+"--><br>\n").getBytes("UTF-8"));
				if(m.group(5).startsWith("true"))bout.write("</font>".getBytes("UTF-8"));
			}
		}
		bout.write("<br>\n".getBytes("UTF-8"));
		for (String line : Cache.getCacheListAsJson(false).split("\n")) {
			Matcher m = CACHELOWLIST_JSON_PATTERN.matcher(line);
			if (m.matches()) {
				bout.write((m.group(1)+"/"+m.group(2)+"/"+m.group(3)+"/"+String.format("%,d",parStringLong(m.group(4))/1024)+"KByte<!--/"+sdf1.format(new Date(parStringLong(m.group(5))*1000))+"--><br>\n").getBytes("UTF-8"));
			}
		}
		bout.write("<br>\n".getBytes("UTF-8"));
		for (String line : Cache.getCacheListAsJson(false).split("\n")) {
			Matcher m = CACHELIST_JSON_PATTERN.matcher(line);
			if (m.matches()) {
				bout.write((m.group(1)+"/"+m.group(2)+"/"+m.group(3)+"/"+String.format("%,d",parStringLong(m.group(4))/1024)+"KByte<!--/"+sdf1.format(new Date(parStringLong(m.group(5))*1000))+"--><br>\n").getBytes("UTF-8"));
			}
		}
		bout.write("<br>\n".getBytes("UTF-8"));
		//---------------------------------------------------------------------------------------------
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write("</div>\n".getBytes("UTF-8"));
		bout.write(htmlFooterString(requestHeader).getBytes("UTF-8"));
		StringResource r = new StringResource(bout.toByteArray());
		bout = null;
		r.setResponseHeader("Content-Type", "text/html");
		return r;
	}
	private StringResource makeSeigaList(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("SeigaList...."));
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">SeigaList</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		sb.append("<a href=\""+URL_SEIGA+"\">É</a><br>\n");
		sb.append(htmlNowSeigaTable(requestHeader));
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeSeigaBbs(HttpRequestHeader requestHeader,String sgid) throws IOException {
		String sgid2 = sgid.replaceAll("[a-z]","");
		StringBuffer sb = new StringBuffer();
		ArrayList<String> aList= getSeigaBbsName(requestHeader,sgid2);
		sb.append(htmlHearderString(sgid+"_"+aList.get(0)));
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">SeigaBbs</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		sb.append("<a href=\""+URL_SEIGA+"bbs/"+sgid+"\">bbs</a> / \n");
		sb.append("<a href=\""+URL_API_SEIGA_LIST+"?theme_id="+sgid2+"\">SeigaApi1</a> / \n");
		sb.append("<a href=\""+URL_API_SEIGA_INFO+"?id="+sgid2+"\">SeigaApi2</a><br>\n");
		//sb.append("쐬 : "+aList.get(2)+" / XV : "+aList.get(3)+"<br>");
		sb.append(aList.get(0)+" / mes : "+aList.get(1)+"<br>");
		sb.append(htmlSeigaBbsList(requestHeader,sgid2));
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeLiveList(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("LiveList"));
		String[] linedata= new String[10];
		String ldata="";
		ArrayList<String> liveArray1 = getLiveRss(requestHeader,"common",1);
		ArrayList<String> liveArray2 = getLiveRss(requestHeader,"try",1);
		ArrayList<String> liveArray3 = getLiveRss(requestHeader,"live",1);
		ArrayList<String> liveArray4 = getLiveRss(requestHeader,"req",1);
		ArrayList<String> liveArray5 = getLiveRss(requestHeader,"face",1);
		ArrayList<String> liveArray6 = getLiveRss(requestHeader,"totu",1);
		ArrayList<String> liveArray7 = getLiveRss(requestHeader,"r18",1);
		int totallive=0;
		totallive+=parStringInteger(LiveCount.get("common"));
		totallive+=parStringInteger(LiveCount.get("try"));
		totallive+=parStringInteger(LiveCount.get("live"));
		totallive+=parStringInteger(LiveCount.get("req"));
		totallive+=parStringInteger(LiveCount.get("face"));
		totallive+=parStringInteger(LiveCount.get("totu"));
		totallive+=parStringInteger(LiveCount.get("r18"));
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">LiveList/Top6/@"+totallive+"</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		sb.append("<a href=\""+URL_LIVE+"\">Live Top</a> / \n");
		sb.append("<a href=\""+URL_LIVE_MY+"\">My Live Top</a><br>\n");
		//---------------------------------------------------------------------------------------------
		sb.append(htmlNowLiveTable(requestHeader));
		sb.append(htmlGateLiveTable(requestHeader));
		//---------------------------------------------------------------------------------------------
		int livesize=6;
		//---------------------------------------------------------------------------------------------
		sb.append("<table width=\"100%\"><tr>\n");
		sb.append("<th align=\"center\"><a href=\"./ids?livecommon\"></a> / "+LiveCount.get("common")+"</th>\n");
		sb.append("<th align=\"center\"><a href=\"./ids?livetry\">Ă݂</a> / "+LiveCount.get("try")+"</th>\n");
		sb.append("</tr><tr><td>\n");
		if(liveArray1 != null && liveArray1.size()>0){
			for (int i = 0 ; i <livesize ; i++){
				ldata = liveArray1.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlLiveDataString(linedata[2])+htmlAlink(linedata[2],linedata[1])+"/"+linedata[12]+"<br>\n");
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
		}
		sb.append("</td><td>\n");
		if(liveArray2 != null && liveArray2.size()>0){
			for (int i = 0 ; i <livesize ; i++){
				ldata = liveArray2.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlLiveDataString(linedata[2])+htmlAlink(linedata[2],linedata[1])+"/"+linedata[12]+"<br>\n");
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
		}
		sb.append("</td></tr><tr>\n");
		sb.append("<th align=\"center\"><a href=\"./ids?livegame\">Q[</a> / "+LiveCount.get("live")+"</th>\n");
		sb.append("<th align=\"center\"><a href=\"./ids?livereq\">ЉENGXg</a> / "+LiveCount.get("req")+"</th>\n");
		sb.append("</th></tr><tr><td>\n");
		if(liveArray4 != null && liveArray4.size()>0){
			for (int i = 0 ; i <livesize ; i++){
				ldata = liveArray3.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlLiveDataString(linedata[2])+htmlAlink(linedata[2],linedata[1])+"/"+linedata[12]+"<br>\n");
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
		}
		sb.append("</td><td>\n");
		if(liveArray4 != null && liveArray4.size()>0){
			for (int i = 0 ; i <livesize ; i++){
				ldata = liveArray4.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlLiveDataString(linedata[2])+htmlAlink(linedata[2],linedata[1])+"/"+linedata[12]+"<br>\n");
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
		}
		sb.append("</td></tr><tr>\n");
		sb.append("<th align=\"center\"><a href=\"./ids?liveface\">o</a> / "+LiveCount.get("face")+"</th>\n");
		sb.append("<th align=\"center\"><a href=\"./ids?livetotu\">ʑ҂</a> / "+LiveCount.get("totu")+"</th>\n");
		sb.append("</th></tr><tr><td>\n");
		if(liveArray5 != null && liveArray5.size()>0){
			for (int i = 0 ; i <livesize ; i++){
				ldata = liveArray5.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlLiveDataString(linedata[2])+htmlAlink(linedata[2],linedata[1])+"/"+linedata[12]+"<br>\n");
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
		}
		sb.append("</td><td>\n");
		if(liveArray6 != null && liveArray6.size()>0){
			for (int i = 0 ; i <livesize ; i++){
				ldata = liveArray6.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlLiveDataString(linedata[2])+htmlAlink(linedata[2],linedata[1])+"/"+linedata[12]+"<br>\n");
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
		}
		sb.append("</td></tr><tr>\n");
		sb.append("<th align=\"center\"><a href=\"./ids?liver18\">R18</a> / "+LiveCount.get("r18")+"</th>\n");
		sb.append("<th align=\"center\"><br></th>\n");
		sb.append("</th></tr><tr><td>\n");
		if(liveArray7 != null && liveArray7.size()>0){
			for (int i = 0 ; i <livesize ; i++){
				ldata = liveArray7.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlLiveDataString(linedata[2])+htmlAlink(linedata[2],linedata[1])+"/"+linedata[12]+"<br>\n");
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
		}
		sb.append("</td><td>\n");
		sb.append("<br>");
/*
		if(liveArray6 != null && liveArray6.size()>0){
			for (int i = 0 ; i <livesize ; i++){
				ldata = liveArray6.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlLiveDataString(linedata[2])+htmlAlink(linedata[2],linedata[1])+"/"+linedata[12]+"<br>\n");
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
		}
*/
		sb.append("</td></tr></table>\n");
		//---------------------------------------------------------------------------------------------
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		liveArray1=null;liveArray2=null;liveArray3=null;
		liveArray4=null;liveArray5=null;liveArray6=null;
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeLiveData(HttpRequestHeader requestHeader,String videoid) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("LiveData"));
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">LiveData</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		sb.append(videoid+"<br>\n");
		ConcurrentHashMap<String, String> liveInfoDataMap= getLiveAPIInfoData(requestHeader,videoid);
		if(liveInfoDataMap==null){
			sb.append("Live Closed<br>\n");
		}else{
			sb.append("<img src=\"http://icon.nimg.jp/"+liveInfoDataMap.get("provider_type")+"/s/"+liveInfoDataMap.get("default_community")+".jpg\">\n");
			ConcurrentHashMap<String, String> liveFlvDataMap= getLiveAPIFlvData(requestHeader,videoid);
			sb.append(htmlLiveFlvTable(liveFlvDataMap)+"<br>\n");
			sb.append(htmlLiveInfoTable(liveInfoDataMap)+"<br>\n");
			sb.append(getApiLiveDataComment(requestHeader,liveInfoDataMap.get("addr"),liveInfoDataMap.get("port"),liveInfoDataMap.get("thread")));
//			sb.append(getApiLiveDataComment(requestHeader,"msgurl","8080","12345"));
//			ArrayList<String> liveNgMap= getLiveNgAPIData(requestHeader,videoid);
//			sb.append(htmlLiveNgTable(liveNgMap,videoid)+"<br>\n");
			sb.append(URL_API_LIVE_STREAMINFO+videoid+"<br>\n");
			sb.append(getHttpRespons(requestHeader,URL_API_LIVE_STREAMINFO+videoid,false)+"<br>\n");
		}
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeLiveCommon(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("LiveCommon"));
		sb.append("<div id=\"left\">\n\n");
		String[] linedata= new String[10];
		String ldata="";
		ArrayList<String> liveArray = getLiveList(requestHeader,"common");
		if(liveArray.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveCommon/Size-"+liveArray.size()+"/Total-"+LiveCount.get("common")+"</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_LIVE_RECENT+"?tab=common\">LiveCommon Page</a><br>\n");
			for (int i = 0 ; i <liveArray.size() ; i++){
				ldata = liveArray.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlSimpleLiveString(linedata[0],linedata[2],linedata[1],linedata[5],linedata[3],linedata[4],linedata[6],linedata[7],linedata[12],"Đ:"+linedata[8]+" R:"+linedata[9]));
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveCommon</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		liveArray=null;
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeLiveTry(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("LiveTry"));
		sb.append("<div id=\"left\">\n\n");
		String[] linedata= new String[10];
		String ldata="";
		ArrayList<String> liveArray = getLiveList(requestHeader,"try");
		if(liveArray.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveTry/Size-"+liveArray.size()+"/Total-"+LiveCount.get("try")+"</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_LIVE_RECENT+"?tab=try\">LiveTry Page</a><br>\n");
			for (int i = 0 ; i <liveArray.size() ; i++){
				ldata = liveArray.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlSimpleLiveString(linedata[0],linedata[2],linedata[1],linedata[5],linedata[3],linedata[4],linedata[6],linedata[7],linedata[12],"Đ:"+linedata[8]+" R:"+linedata[9]));
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveTry</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		liveArray=null;
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeLiveGame(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("LiveGame"));
		sb.append("<div id=\"left\">\n\n");
		String[] linedata= new String[10];
		String ldata="";
		ArrayList<String> liveArray = getLiveList(requestHeader,"live");
		if(liveArray.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveGame/Size-"+liveArray.size()+"/Total-"+LiveCount.get("live")+"</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_LIVE_RECENT+"?tab=live\">LiveGame Page</a><br>\n");
			for (int i = 0 ; i <liveArray.size() ; i++){
				ldata = liveArray.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlSimpleLiveString(linedata[0],linedata[2],linedata[1],linedata[5],linedata[3],linedata[4],linedata[6],linedata[7],linedata[12],"Đ:"+linedata[8]+" R:"+linedata[9]));
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveGame</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		liveArray=null;
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeLiveReq(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("LiveReq"));
		sb.append("<div id=\"left\">\n\n");
		String[] linedata= new String[10];
		String ldata="";
		ArrayList<String> liveArray = getLiveList(requestHeader,"req");
		if(liveArray.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveReq/Size-"+liveArray.size()+"/Total-"+LiveCount.get("req")+"</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_LIVE_RECENT+"?tab=req\">LiveReq Page</a><br>\n");
			for (int i = 0 ; i <liveArray.size() ; i++){
				ldata = liveArray.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlSimpleLiveString(linedata[0],linedata[2],linedata[1],linedata[5],linedata[3],linedata[4],linedata[6],linedata[7],linedata[12],"Đ:"+linedata[8]+" R:"+linedata[9]));
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveReq</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		liveArray=null;
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeLiveFace(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("LiveFace"));
		sb.append("<div id=\"left\">\n\n");
		String[] linedata= new String[10];
		String ldata="";
		ArrayList<String> liveArray = getLiveList(requestHeader,"face");
		if(liveArray.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveFace/Size-"+liveArray.size()+"/Total-"+LiveCount.get("face")+"</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_LIVE_RECENT+"?tab=face\">LiveFace Page</a><br>\n");
			for (int i = 0 ; i <liveArray.size() ; i++){
				ldata = liveArray.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlSimpleLiveString(linedata[0],linedata[2],linedata[1],linedata[5],linedata[3],linedata[4],linedata[6],linedata[7],linedata[12],"Đ:"+linedata[8]+" R:"+linedata[9]));
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveFace</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		liveArray=null;
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeLiveTotu(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("LiveTotu"));
		sb.append("<div id=\"left\">\n\n");
		String[] linedata= new String[10];
		String ldata="";
		ArrayList<String> liveArray = getLiveList(requestHeader,"totu");
		if(liveArray.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveTotu/Size-"+liveArray.size()+"/Total-"+LiveCount.get("r18")+"</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_LIVE_RECENT+"?tab=totu\">LiveTotu Page</a><br>\n");
			for (int i = 0 ; i <liveArray.size() ; i++){
				ldata = liveArray.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlSimpleLiveString(linedata[0],linedata[2],linedata[1],linedata[5],linedata[3],linedata[4],linedata[6],linedata[7],linedata[12],"Đ:"+linedata[8]+" R:"+linedata[9]));
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveTotu</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		liveArray=null;
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makeLiveR18(HttpRequestHeader requestHeader) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("LiveR18"));
		sb.append("<div id=\"left\">\n\n");
		String[] linedata= new String[10];
		String ldata="";
		ArrayList<String> liveArray = getLiveList(requestHeader,"r18");
		if(liveArray.size()>0){
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveR18/Size-"+liveArray.size()+"/Total-"+LiveCount.get("r18")+"</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("<a href=\""+URL_LIVE_RECENT+"?tab=r18\">LiveR18 Page</a><br>\n");
			for (int i = 0 ; i <liveArray.size() ; i++){
				ldata = liveArray.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(htmlSimpleLiveString(linedata[0],linedata[2],linedata[1],linedata[5],linedata[3],linedata[4],linedata[6],linedata[7],linedata[12],"Đ:"+linedata[8]+" R:"+linedata[9]));
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}else{
			sb.append("<div class=\"left_all\">\n");
			sb.append("<h2 class=\"left_title\">LiveR18</h2>\n");
			sb.append("<div class=\"left_body\">\n");
			sb.append("<div class=\"left_text\">\n\n");
			sb.append("No Data<br>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		liveArray=null;
		return setResponseText(new String(sb), "text/html");
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private StringResource makeNewFaList(HttpRequestHeader requestHeader,String _num) throws IOException {
		Integer num = parStringInteger(_num);
		if(num>25)num=25;
		String fadata="";
		int count=1;
		String[] linedata = new String[2];
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("FaNewList"));
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">FaNewList</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		ArrayList<String> newList=null;
		for (int i = FAMYLISTLIST.size()-1 ; i >=  FAMYLISTLIST.size()-num ; i--){
			if(i<0)break;
			fadata = FAMYLISTLIST.get(i);
			linedata = fadata.split("<>");
			newList = getMylistRss(requestHeader,linedata[1]);
			try{
				sb.append(newList.get(0).replaceAll("\\d?<>","")+" / "+newList.get(2).replaceAll("\\d?<>",""));
				sb.append(" / <a href=\""+URL_EXST_IDS+"?mylist="+linedata[1]+"\">"+linedata[1]+"</a><br>\n");
				try{sb.append(htmlNewMyList(newList.get(3),count));}catch(IndexOutOfBoundsException e){}count++;
				try{sb.append(htmlNewMyList(newList.get(4),count));}catch(IndexOutOfBoundsException e){}count++;
			}catch(IndexOutOfBoundsException e){
				num+=1;/*ȂɂG[oꍇA\Ȃŕ\𑝂₷*/
			}
			sb.append("<hr>\n");
		}
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringResource makePost(HttpRequestHeader requestHeader,String id) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append(htmlHearderString("PostData...."));
		sb.append("<div id=\"left\">\n\n");
		sb.append("<div class=\"left_all\">\n");
		sb.append("<h2 class=\"left_title\">PostData</h2>\n");
		sb.append("<div class=\"left_body\">\n");
		sb.append("<div class=\"left_text\">\n\n");
		if(id.startsWith("lv")){
			sb.append(makePostLv(requestHeader,id)+"<br>\n");
		}else if(id.startsWith("jk")){
			sb.append("none type... @"+id+"<br>\n");
		}else{
			sb.append(makePostSm(requestHeader,id)+"<br>\n");
		}
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append(htmlFooterString(requestHeader));
		return setResponseText(new String(sb), "text/html");
	}
	private StringBuffer makePostSm(HttpRequestHeader requestHeader,String id) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append("smid @"+id+"<hr>\n");
		return sb;
	}
	private StringBuffer makePostLv(HttpRequestHeader requestHeader,String id) throws IOException {
		StringBuffer sb = new StringBuffer();
		sb.append("lvid @"+id+"<hr>\n");
		return sb;
	}
	private StringResource makePostDataSm(HttpRequestHeader requestHeader,String id) throws IOException {
		return setResponseText("makedatasm@"+id);
	}
	private StringResource makePostDataLv(HttpRequestHeader requestHeader,String id) throws IOException {
		if(id.startsWith("lv")) return setResponseText("id Error@"+id);
		return setResponseText("makedatalv@"+id);
	}
	private StringResource makeLogText(HttpRequestHeader requestHeader) throws IOException {
		return setResponseText(new String(logBuffer).replaceAll("<[^>]+>",""));
	}
	private StringResource makeLogHtml(HttpRequestHeader requestHeader) throws IOException {
		String css = "<style type=\"text/css\"><!--body{line-height:1.0;margin:10px;}--></style>\n";
		StringBuffer sb = new StringBuffer();
		String FS = System.getProperty("file.separator");
		sb.append(HTMLHEADER1+css+"<title>LogHtml / "+NLTITLE2+"@"+ACBROWSER+"</title>\n</head><body>\n");
		sb.append("Extensions Version => "+NLTITLE+" "+VERSION+"<br>\n");
		sb.append("BROWSER => "+ACBROWSER+"<br>\n");
		sb.append("//---------------<br>\n");
		sb.append("Version => "+Main.getVersion()+"<br>\n");
		sb.append("java.version => "+System.getProperty("java.version")+"<br>\n");
		sb.append("OS => "+System.getProperty("os.name")+" "+System.getProperty("os.version")+"<br>\n");
		sb.append("System => "+System.getProperty("user.dir")+FS+System.getProperty("java.class.path")+"<br>\n");
		sb.append("System Folder => "+System.getProperty("user.dir")+"<br>\n");
		if (System.getProperty("cacheFolder").equals("cache"))
			sb.append("Cache Folder => "+System.getProperty("user.dir")+FS+System.getProperty("cacheFolder")+"<br>\n");
		else
			sb.append("Cache Folder => "+System.getProperty("cacheFolder")+"<br>\n");
/*		sb.append("port=" + Integer.getInteger("listenPort")+"<br>\n");
		sb.append("proxy host => " + System.getProperty("proxyHost")+"<br>\n");
		sb.append("proxy port => " + Integer.getInteger("proxyPort")+"<br>\n");
		sb.append("allowFrom => " + System.getProperty("allowFrom", "local")+"<br>\n");
		sb.append("niconicoMode => " + Boolean.getBoolean("niconicoMode")+"<br>\n");
		sb.append("speedLimit => " + System.getProperty("speedLimit")+"<br>\n");
		sb.append("title => " + Boolean.getBoolean("title")+"<br>\n");
		sb.append("scriptOn => " + Config.getInteger("scriptOn", 0)+"<br>\n");
		sb.append("scriptTarget => " + Config.getString("scriptTarget", "no_uri_to_replace")+"<br>\n");
		sb.append("scriptText => " + Config.getString("scriptText", "")+"<br>\n");
		sb.append("flvWrapper => "+System.getProperty("flvWrapper", "false")+"<br>\n");
		sb.append("LocalFlv => "+Boolean.getBoolean("localFlv")+"<br>\n");
		sb.append("resumeDownload => "+Boolean.getBoolean("resumeDownload")+"<br>\n");
		sb.append("touchCache => "+Boolean.getBoolean("touchCache")+"<br>\n");
		sb.append("continueDownload => "+Boolean.getBoolean("continueDownload")+"<br>\n");
		sb.append("storeFilter => "+Boolean.getBoolean("storeFilter")+"<br>\n");
		sb.append("cacheAllocateFirst => "+Boolean.getBoolean("cacheAllocateFirst")+"<br>\n");
		sb.append("cacheThumbnail => "+Boolean.getBoolean("cacheThumbnail")+"<br>\n");
		sb.append("thcacheMode => "+System.getProperty("thcacheMode")+"<br>\n");
		sb.append("swfConvert => "+Boolean.getBoolean("swfConvert")+"<br>\n");
		sb.append("debug mode => "+Boolean.getBoolean("dareka.debug")+"<br>\n");
		sb.append("java.class.path => "+System.getProperty("java.class.path")+"<br>\n");
		String LS = System.getProperty("line.separator");
		sb.append("line.separator => "+LS+"<br>\n");
		sb.append("user.name => "+System.getProperty("user.name")+"<br>\n");
		sb.append("user.home => "+System.getProperty("user.home")+"<br>\n");
		sb.append("java.home => "+System.getProperty("java.home")+"<br>\n");
		sb.append("java.io.tmpdir => "+System.getProperty("java.io.tmpdir")+"<br>\n");
		sb.append("java.compiler => "+System.getProperty("java.compiler")+"<br>\n");
*/
		sb.append("path.separator => "+System.getProperty("path.separator")+"<br>\n");
		sb.append("file.separator => "+FS+"<br>\n");
		Long ntime1 = System.nanoTime()/1000/1000/1000;
		Long ntime2 = ntime1/3600;
		Long ntime3 = ntime1 - ntime2*3600;
		String time = (ntime2%24<10 ? "0":"")+ntime2%24;
		String min = (ntime3/60<10 ? "0":"")+ntime3/60;
		String sec = (ntime3%60<10 ? "0":"")+ntime3%60;
		sb.append("nanoTime => "+ntime2/24+""+time+""+min+""+sec+"b ("+ntime1+"sec)<br>\n");
		sb.append(htmlMemoryView(false,false));
		sb.append(htmlCacheView(false,false));
		sb.append("//---------------<br>\n");
		return setResponseText(new String(sb)+new String(logBuffer).replaceAll("\n","<br>\n")+"</body></html>", "text/html");
	}
	private StringResource makeThreadLog(HttpRequestHeader requestHeader) throws IOException {
		if(thlogBuffer.length()<10) return setResponseText("No Data");
		String css = "<style type=\"text/css\"><!--body{line-height:1.0;margin:10px;}--></style>\n";
		String meta ="<META http-equiv=\"refresh\" content=\"10\">\n";
		StringBuffer sb = new StringBuffer();
		sb.append(HTMLHEADER1+meta+css+"<title>ThreadLogHtml / "+NLTITLE2+"@"+ACBROWSER+"</title>\n</head><body>\n");
		return setResponseText(new String(sb)+new String(thlogBuffer)+"</body></html>", "text/html");
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private StringResource makeApiData(HttpRequestHeader requestHeader,String videoid) throws IOException {
		videoid=videoid.replaceAll("low","");
		StringBuffer sb = new StringBuffer();
		String commentString="";
		String title = "";
		ConcurrentHashMap<String, String> mapInfo = getInfoData(requestHeader, videoid);
		ConcurrentHashMap<String, String> mapFlv  = new ConcurrentHashMap<String, String>();
		ConcurrentHashMap<String, String> mapPost = new ConcurrentHashMap<String, String>();
		String post_key="";
		if (mapInfo.containsKey("title")){
			title = mapInfo.get("title");
		}else if(mapInfo.containsKey("description")){
			title = mapInfo.get("description");
		}else{
			title=null;
		}
		if(ConfigFlagFlv || ConfigFlagComN ||ConfigFlagComT || ConfigFlagComP){
			if(!title.startsWith("not")){
				mapFlv  = getFlvData(requestHeader,videoid);
				if(ConfigFlagComN || ConfigFlagComP){
					commentString=getApiDataCommentN(requestHeader,mapFlv,videoid);
					if(ConfigFlagComP){
						mapPost = getPostUrl(mapFlv,commentString);
						post_key = getHttpRespons(requestHeader,mapPost.get("posturl"),false);
					}
				}
			}
		}
		if(ConfigFlagFlv && !title.startsWith("not"))
		if (mapFlv == null){
			sb.append("{data=null}");
		}else{
			sb.append(mapFlv.toString());
		}
		sb.append("\n");
		if(ConfigFlagInfo)
			sb.append(mapInfo.toString());
		sb.append("\n");
		if(ConfigFlagComP){
			sb.append("{post_url="+mapPost.get("posturl")+", "+
					  "post_Ticket="+mapPost.get("ticket")+", "+
					  "post_lastres="+mapPost.get("lastres")+", "+
					  "post_block_no="+mapPost.get("blockno")+", "+
					  "post_key="+post_key+"");
			if(!ConfigFlagFlv){
			sb.append(", ");
			sb.append("MsServer="+mapFlv.get("ms")+ ", "+
					  "UserId="+mapFlv.get("user_id")+ ", "+
					  "Thread="+mapFlv.get("thread_id")+ "");
			}
			sb.append("}");
		}
		sb.append("\n");
		if(ConfigFlagComN && !title.startsWith("not")){
			ArrayList<String> commentStringSplit=getApiDataCommentNSplit(commentString);
			sb.append(commentStringSplit.toString());
			commentStringSplit=null;
		}
		sb.append("\n");
		if(ConfigFlagComT && !title.startsWith("not"))
			sb.append(getApiDataCommentTSplit(getApiDataCommentT(requestHeader,mapFlv,videoid)).toString());
		sb.append("\n");
		return new StringResource(new String(sb));
	}
	private StringResource makeApiRelation(HttpRequestHeader requestHeader,String videoid) throws IOException {
		StringBuffer sb = new StringBuffer();
		ArrayList<String> myRelationListArray = getRelationXML(requestHeader,1,videoid);
		if(myRelationListArray != null){
			ArrayList<String> myRelationListArray2 = getRelationXML(requestHeader,2,videoid);
			if(myRelationListArray2 != null){
				myRelationListArray.addAll(myRelationListArray2);
				myRelationListArray2=null;
				ArrayList<String> myRelationListArray3 = getRelationXML(requestHeader,3,videoid);
				if(myRelationListArray3 != null){
					myRelationListArray.addAll(myRelationListArray3);
					myRelationListArray3=null;
					ArrayList<String> myRelationListArray4 = getRelationXML(requestHeader,4,videoid);
					if(myRelationListArray4 != null){
						myRelationListArray.addAll(myRelationListArray4);
						myRelationListArray4=null;
					}
				}
			}
		}
		if(ConfigFlagHtml){
			sb.append("RelationID -> "+videoid+" / ");
			sb.append("RelationSize -> "+myRelationListArray.size()+"\n");
		}
		String data="";
		if(myRelationListArray != null){
			for (int i = 0 ; i < myRelationListArray.size() ; i++){
				data = myRelationListArray.get(i);
				sb.append(data+"\n");
			}
		}else{
			sb.append("No Data\n");
		}
		sb.append("\n");
		myRelationListArray=null;
		return new StringResource(new String(sb));
	}
	private StringResource makeApiMylist(HttpRequestHeader requestHeader,String mylistid) throws IOException {
		String arraycon = "";
		int myint=0;
		try{
			myint=Integer.parseInt(mylistid);
		} catch (NumberFormatException e) {
			return setResponseText("Eroor!\n");
		}
		ArrayList<String> myListListArray = getMylistRss(requestHeader,mylistid);
		if(myListListArray == null){
			return setResponseText("No Data\n");
		}
		StringBuffer sb = new StringBuffer();
		if(ConfigFlagHtml){
			sb.append("MyListID -> "+mylistid+" / ");
			sb.append("MyListSize -> "+myListListArray.size()+"\n");
		}
		for (int i = 0 ; i < myListListArray.size() ; i++){
			arraycon = myListListArray.get(i);
			sb.append(arraycon+"\n");
		}
		myListListArray=null;
		return new StringResource(new String(sb));
	}
	private StringResource makeApiRanking(HttpRequestHeader requestHeader,String url) throws IOException {
		ArrayList<String> rankingListArray = getRankingRss(requestHeader,url);
		try{
			String str=rankingListArray.get(0);
		}catch(IndexOutOfBoundsException e){
			rankingListArray=null;
		}
		if(rankingListArray == null) return setResponseText("No Data");
		StringBuffer sb = new StringBuffer();
		for (int i = 0 ; i < rankingListArray.size() ; i++){
			sb.append(rankingListArray.get(i)+"\n");
		}
		rankingListArray=null;
		return new StringResource(new String(sb));
	}
	private StringResource makeApiRankingTop(HttpRequestHeader requestHeader) throws IOException {
		ArrayList<String> rankingListArray = getRankingTopRss(requestHeader);
		if(rankingListArray == null) return setResponseText("No Data");
		StringBuffer sb = new StringBuffer();
		for (int i = 0 ; i < rankingListArray.size() ; i++){
			sb.append(rankingListArray.get(i)+"\n");
		}
		rankingListArray=null;
		return new StringResource(new String(sb));
	}
	private StringResource makeApiMyvideo(HttpRequestHeader requestHeader,String videoid) throws IOException {
		StringBuffer sb = new StringBuffer();
		ArrayList<String> myvideoListArray = getMyvideoRss(requestHeader,videoid);
		String data="";
		if(ConfigFlagHtml)sb.append("MyVideoSize -&gt; "+myvideoListArray.size()+"\n");
		for (int i = 0 ; i < myvideoListArray.size() ; i++){
			data = myvideoListArray.get(i);
			sb.append(data+"\n");
		}
		sb.append("\n");
		myvideoListArray=null;
		return new StringResource(new String(sb));
	}
	private StringResource makeApiOpenMylist(HttpRequestHeader requestHeader,String videoid) throws IOException {
		StringBuffer sb = new StringBuffer();
		ArrayList<String> openMyList = getOpenMylist(requestHeader,videoid,1);
		if(openMyList!=null&& openMyList.size()>0){
			ArrayList<String> openMyList2 = getOpenMylist(requestHeader,videoid,2);
			if(openMyList2!=null&& openMyList2.size()>0){
				openMyList.addAll(openMyList2);
				openMyList2=null;
				ArrayList<String> openMyList3 = getOpenMylist(requestHeader,videoid,3);
				if(openMyList3!=null&& openMyList3.size()>0){
					openMyList.addAll(openMyList3);
					openMyList3=null;
					ArrayList<String> openMyList4 = getOpenMylist(requestHeader,videoid,4);
					if(openMyList4!=null&& openMyList4.size()>0){
						openMyList.addAll(openMyList4);
						openMyList4=null;
						ArrayList<String> openMyList5 = getOpenMylist(requestHeader,videoid,5);
						if(openMyList5!=null&& openMyList5.size()>0){
							openMyList.addAll(openMyList5);
							openMyList5=null;
						}
					}
				}
			}
		}
		if(ConfigFlagHtml){
			sb.append("OpenMyListID-> "+videoid+" / ");
			sb.append("OpenMyListSize-> "+openMyList.size()+"\n");
		}
		String line="";
		if(openMyList!=null && openMyList.size()>0){
			for (int i = 0 ; i <openMyList.size() ; i++){
				line = openMyList.get(i);
				sb.append(line+"\n");
			}
		}
		openMyList=null;
		return new StringResource(new String(sb));
	}
	private StringResource makeApiLivelist(HttpRequestHeader requestHeader,String tab) throws IOException {
		StringBuffer sb = new StringBuffer();
		String ldata="";
		ArrayList<String> liveArray = getLiveList(requestHeader,tab);
		if(ConfigFlagHtml){
			sb.append("LiveTab-> "+tab+" / ");
		}
		for (int i = 0 ; i <liveArray.size() ; i++){
			ldata = liveArray.get(i);
			sb.append(ldata+"\n");
		}
		liveArray=null;
		return new StringResource(new String(sb));
	}
	private StringResource makeApiGraph(HttpRequestHeader requestHeader,String videoid) throws IOException {
		if(!ConfigFlagAmi) return setResponseText("NG");
		String title="";
		ConcurrentHashMap<String, String> mapInfo = getInfoData(requestHeader, videoid);
		if (mapInfo.containsKey("title")){
			title = mapInfo.get("title");
		}else if(mapInfo.containsKey("description")){
			title = mapInfo.get("description");
		}else{
			title=null;
		}
		ConcurrentHashMap<String,Integer> vpc = new ConcurrentHashMap<String,Integer>();
		if(title.startsWith("not")){
			return setResponseText("NG");
		}else if(title.startsWith("del")){
			return setResponseText("NG");
		}else if(title.startsWith("com")){
			return setResponseText("NG");
		}else{
			vpc = setAmiVposData(requestHeader,videoid);
			if(vpc==null){
				return setResponseText("NG");
			}
		}
		String lenvpos="5:00";
		if(mapInfo.containsKey("length")){
			lenvpos=mapInfo.get("length");
		}
		String lenlist[] = lenvpos.split(":");
		int v1=0;int v2=0;
		int lvp=1000;
		v1=parStringInteger(lenlist[0]);
		v2=parStringInteger(lenlist[1]);
		lvp=v1*60+v2;
		//---------------------------------------------------------------------------------------------
		setAmiGData(vpc,lvp);
		//---------------------------------------------------------------------------------------------
		saveAmiXML(lvp);
		//---------------------------------------------------------------------------------------------
		return setResponseText("OK");
	}
	private StringResource makeXMLGraph(HttpRequestHeader requestHeader,String videoid) throws IOException {
		if(!ConfigFlagAmi) return setResponseText("NG");
		String title="";
		ConcurrentHashMap<String, String> mapInfo = getInfoData(requestHeader, videoid);
		if (mapInfo.containsKey("title")){
			title = mapInfo.get("title");
		}else if(mapInfo.containsKey("description")){
			title = mapInfo.get("description");
		}else{
			title=null;
		}
		ConcurrentHashMap<String,Integer> vpc = new ConcurrentHashMap<String,Integer>();
		if(title.startsWith("not")){
			return setResponseText("NotFound...");
		}else if(title.startsWith("del")){
			return setResponseText("Deleted...");
		}else if(title.startsWith("com")){
			return setResponseText("Com...");
		}else{
			vpc = setAmiVposData(requestHeader,videoid);
			if(vpc==null){
				return setResponseText("Error...");
			}
		}
		String lenvpos="5:00";
		if(mapInfo.containsKey("length")){
			lenvpos=mapInfo.get("length");
		}
		String lenlist[] = lenvpos.split(":");
		int v1=0;int v2=0;
		int lvp=1000;
		v1=parStringInteger(lenlist[0]);
		v2=parStringInteger(lenlist[1]);
		lvp=v1*60+v2;
		//---------------------------------------------------------------------------------------------
		setAmiGData(vpc,lvp);
		//---------------------------------------------------------------------------------------------
		return setResponseText(saveAmiXMLString(lvp),"text/xml");
	}
	private StringResource makeXMLSETGraph(){
		if(!ConfigFlagAmi) return setResponseText("NG");
		return setResponseText(saveAmiSetString(),"text/xml");
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private StringResource makeOpen(HttpRequestHeader requestHeader,String str,Boolean uFlag){
		if(uFlag){
			if(openBrowser(str)){
				return setResponseText("OK");
			}else{
				return setResponseText("NG");
			}
		}else{
			if(openDirectory(new File(System.getProperty("user.dir")+"/"+str))){
				return setResponseText("OK");
			}else{
				return setResponseText("NG");
			}
		}
		//return setResponseText("NULL");
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private String makeRankingTableList(String from){
		String[] cg = {"all","null",/**/"ent","music","sport",/**/
		"animal","cooking","diary","nature","science","history","radio","lecture",/**/
		"politics",/**/"sing","play","dance","draw","tech",/**/
		"anime","game",/**/"imas","toho","vocaloid","are","other"};
		String[] name = {"","",/**/"G^[eCg","y","X|[c",/**/
		"","","L","R","Ȋw","j","WI","jRjRu",/**/
		"",/**/"̂Ă݂","tĂ݂","xĂ݂","`Ă݂","jRjRZp",/**/
		"Aj","Q[",/**/"ACh}X^[","","VOCALOID","̃A","̑"};
		String[] g_cg	= {"g_ent","g_life","g_politics","g_try","g_culture","g_popular"};
		String[] g_name	= {"G^EyEX|","{E","","Ă݂","AjEQ[","a"};
		StringBuffer sb = new StringBuffer();
		String sfs10="<span style=\"font-size:10pt;text-align:center;\">";
		String pfs9="<p style=\"font-size:9pt;text-align:center;margin:0; padding:0;\">";
		String sfe="</span>";
		String pfe="</p>";
		sb.append("<table border=\"1\" cellspacing=\"0\" cellpadding=\"1\">");
		sb.append("<tr>\n<th><br></th>\n");
		sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_ENT+"\">G^EyEX|</a>"+sfe+"</th>\n");
		sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_LIFE+"\">{E</a>"+sfe+"</th>\n");
		sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_POLITICS+"\"></a>"+sfe+"</th>\n");
		sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_TRY+"\">Ă݂</a>"+sfe+"</th>\n");
		sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_CULTURE+"\">AjEQ[</a>"+sfe+"</th>\n");
		sb.append("<th>"+sfs10+"<a href=\""+URL_RANKING_POPULAR+"\">a</a>"+sfe+"</th>\n");
		sb.append("</tr>\n");
		sb.append("<tr><td><br></td>\n");
		for(int i=0;i<6;i++) sb.append("<td><a href=\"javascript:makeRankTable('"+g_cg[i]+"','"+from+"')\">"+g_name[i]+"</a></td>\n");
		sb.append("</tr>\n");
		sb.append("<tr><td valign=\"top\">\n");
		for(int i=0;i<=1;i++) sb.append("<a href=\"javascript:makeRankTable('"+cg[i]+"','"+from+"')\">"+name[i]+"</a><br>\n");
		sb.append("</td><td valign=\"top\">\n");
		for(int i=2;i<=4;i++) sb.append("<a href=\"javascript:makeRankTable('"+cg[i]+"','"+from+"')\">"+name[i]+"</a><br>\n");
		sb.append("</td><td valign=\"top\">\n");
		for(int i=5;i<=12;i++)sb.append("<a href=\"javascript:makeRankTable('"+cg[i]+"','"+from+"')\">"+name[i]+"</a><br>\n");
		sb.append("</td><td valign=\"top\">\n");
		for(int i=13;i<=13;i++)sb.append("<a href=\"javascript:makeRankTable('"+cg[i]+"','"+from+"')\">"+name[i]+"</a><br>\n");
		sb.append("</td><td valign=\"top\">\n");
		for(int i=14;i<=18;i++)sb.append("<a href=\"javascript:makeRankTable('"+cg[i]+"','"+from+"')\">"+name[i]+"</a><br>\n");
		sb.append("</td><td valign=\"top\">\n");
		for(int i=19;i<=20;i++)sb.append("<a href=\"javascript:makeRankTable('"+cg[i]+"','"+from+"')\">"+name[i]+"</a><br>\n");
		sb.append("</td><td valign=\"top\">\n");
		for(int i=21;i<=25;i++)sb.append("<a href=\"javascript:makeRankTable('"+cg[i]+"','"+from+"')\">"+name[i]+"</a><br>\n");
		sb.append("</td></tr>\n");
		sb.append("</table>\n");
		return new String(sb);
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private String htmlRegexpString(String desc){
		desc=" "+desc+" ";
		Pattern spaseP = Pattern.compile("(\\s|@){3,}");
		Matcher matcher = spaseP.matcher(desc);
		desc = matcher.replaceAll(" ");
		//---------------------------------------------------------------------------------------------
		Pattern url_pat = Pattern.compile("http://www.nicovideo.jp/?");matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll(" ");
		//---------------------------------------------------------------------------------------------
		url_pat = Pattern.compile("([a-zA-Z/])((?:mylist|user)/\\d+)");matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll("$1 $2");
		//---------------------------------------------------------------------------------------------
		url_pat = Pattern.compile("([^a-zA-Z/])(mylist/(\\d+))");matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll("$1<a href=\"./ids?mylist=$3\">$2</a>");
		//---------------------------------------------------------------------------------------------
		url_pat = Pattern.compile("([^a-zA-Z/])(user/\\d+)");matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll("$1<a href=\"../$2\">$2</a>");
		//---------------------------------------------------------------------------------------------
		String httplink="([hH]?)([tT][tT][pP][sS]?://(?:[a-zA-Z\\d\\-._~%!$&'*+,;=:]*@|)"+
		"(?:[a-zA-Z\\d+\\-._~%!$&'*+,;=]*)(?::\\d*|)"+
		"(?:\\/[a-zA-Z\\d+\\-._~%!$&'*+,;=:@]*)*(?:\\?[a-zA-Z\\d+\\-._~%!$&'*+,;=:@\\/?]*|)"+
		"(?:#[a-zA-Z\\d+\\-._~%!$&'*+,;=:@\\/?]*|))";
		url_pat = Pattern.compile(httplink);matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll("<a href=\"h$2\">h$2</a>");
		//---------------------------------------------------------------------------------------------
		url_pat = Pattern.compile("<a href=\"([^\"]+?)(http://[^\"]*)\"[^>]*>[^<]+</a>");matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll("<a href=\"$1\">$1</a> <a href=\"$2\">$2</a>");
		url_pat = Pattern.compile("<a href=\"([^\"]+?\\.(?:html|zip|rar|jpe?g|gif|png))([^\"]+)\"[^>]*>[^<]+</a>");matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll("<a href=\"$1\">$1</a> $2");
		url_pat = Pattern.compile("([^a-zA-Z/])(co\\d+)(?![\"\\\\'?.]|[^<]*>)");matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll("$1<a href=\"http://com.nicovideo.jp/community/$2\">$2</a>");
		url_pat = Pattern.compile("(myvideo/(\\d+))(?![\"\\\\'?.]|[^<]*>)");matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll("<a href=\"./ids?myvideo=$2\">$1</a>");
		url_pat = Pattern.compile("(watch/(\\d+))(?![\"\\\\'?.]|[^<]*>)");matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll("<a href=\"./ids?data=$2&amp;b\">$1</a>");
		url_pat = Pattern.compile("(?<![a-zA-Z])((?:sm|ax|ca|cw|fz|na|nm|yo|za|zb|so)\\d+)(?:\\?eco=1|)(?![\"\\\\'?./&]|[^<]*>)");
		matcher = url_pat.matcher(desc);
		desc = matcher.replaceAll("<a href=\"./ids?data=$1&amp;b\">$1</a>");
		desc=htmlRegexpString_cache(desc);
		return desc;
	}
	private String htmlRegexpString_cache(String desc){
		Pattern clp = Pattern.compile("(<a href=\\\"./ids\\?data=([^&]+)&amp;b\\\">(.+?)</a>)");
		Matcher m = clp.matcher(desc);
		String al="";
		String m_al="";
		while(m.find()){
			m_al="<a href=\"./ids[^>]+data="+m.group(2)+"&amp;b\">"+m.group(3)+"</a>";
			al=htmlAlinkClassPlus(m.group(2),m.group(3));
			desc = desc.replaceAll(m_al,al);
		}
		return desc;
	}
	private String htmlSmLinks(String videoid,String count,String nums,Boolean ferm){
		return htmlSmLinks(videoid,count,nums,ferm,false);
	}
	private String htmlSmLinks(String videoid,String count,String nums,Boolean ferm,Boolean alls){
		String videoid2 = videoid.replaceAll("low","");
		StringBuffer sb = new StringBuffer();
		//watch,relation,open,add_infi,rm_infi,add_defmy,fetch,cacheRm,fetchRm
		String sa = "";
		String slash = " / ";
		String[] temp = ConfigFlagSmLinksArray;
		if(alls){
			ferm=true;
			temp = ConfigFlagSmLinksString.split(",");
		}
		for (int i = 0 ; i < temp.length ; i++){
			sa = temp[i];
			if(sa == null)break;
			if(i==temp.length-1)slash ="";
			if(sa.startsWith("watch")){
				sb.append(htmlWatchString(videoid2)+slash);
			}else if(sa.startsWith("relation")){
				sb.append(htmlRelationString(videoid2)+slash);
			}else if(sa.startsWith("open")){
				sb.append(htmlOpenString(videoid2)+slash);
			}else if(sa.startsWith("add_infi") && ConfigFlagInfiMylist){
				sb.append(htmlInfiAddString(videoid2,count)+slash);
			}else if(sa.startsWith("rm_infi") && ConfigFlagInfiMylist){
				sb.append(htmlInfiRemoveString(videoid2,count)+slash);
			}else if(sa.startsWith("add_defmy")){
				sb.append(htmlAddDefMyListString(videoid2,count)+slash);
			}else if(sa.startsWith("fetchRm") && ConfigFlagFetcher){
				if(ferm)sb.append(htmlFetchedRemoveId(videoid2,count)+slash);
			}else if(sa.startsWith("fetch") && ConfigFlagFetcher){
				sb.append(htmlFetchString(videoid2,nums)+slash);
			}else if(sa.startsWith("cacheRm")){
				sb.append(htmlNlRemoveString(videoid2,count)+slash);
			}
			try{
				if(temp[i+1].startsWith("fetchRm") && !ferm)slash =""; else slash =" / ";
			}catch(ArrayIndexOutOfBoundsException e){}
		}
		return new String(sb);
	}
	private String htmlDefaultString(String videoid,String imgid,int count,String title,String time,String smdata,String smlen,String desc){
		String smlink=htmlSmLinks(videoid,count+"",2+"",false);
		StringBuffer sb = new StringBuffer();
		sb.append("<div class=\"default_all\">\n");
		sb.append("<div class=\"default_img\">");
		sb.append(htmlImgString(imgid,videoid,smlen,1,1,false));
		sb.append("</div>\n");
		sb.append("<div class=\"default_body\">"+time+" / "+smdata+smlen+"<br>"+videoid+" / "+smlink+"\n");
		sb.append("<div class=\"default_title\">"+htmlAlinkClassPlus(videoid,title)+"</div>\n");
		sb.append("</div>\n");
		sb.append("<div class=\"default_desc\">"+((!desc.startsWith("none")) ? desc : "")+"</div>\n");
		sb.append("</div>\n\n");
		return new String(sb);
	}
	private String htmlSimpleString(String videoid,String imgid,int count,String title,String time,String smdata,String smlen,String desc){
		StringBuffer sb = new StringBuffer();
		String desclink="<a href=\"javascript:void(0)\" onclick=\"showHide('th_"+count+"')\">...</a>";
		String desclink2="<a href=\"javascript:void(0)\" onclick=\"getThumInfo('"+videoid+"','gti_"+count+"')\">...</a>";
		String smlink=htmlSmLinks(videoid,count+"",2+"",false);
		sb.append("<div class=\"simple_all\">\n");
		sb.append("<div class=\"simple_img\">");
		sb.append(htmlImgString(imgid,videoid,smlen,2,2,false));
		sb.append("</div>\n");
		sb.append("<div class=\"simple_body\">");
		sb.append(time);
		if(time != "")
			sb.append(" / ");
		sb.append(smdata+smlen);
		if(time != "" || smdata!= "")
			sb.append("<br>");
		sb.append(videoid+" / "+smlink+"\n");
		sb.append("<div class=\"simple_title\">"+htmlAlinkClassPlus(videoid,title)+" "+((desc == "none") ? desclink2 : desclink)+"</div>\n");
		sb.append("</div>\n");
		sb.append("<div class=\"simple_desc\" id=\"th_"+count+"\">"+desc+"</div>\n");
		sb.append("<div class=\"simple_desc\" id=\"gti_"+count+"\"></div>\n");
		sb.append("</div>\n\n");
		return new String(sb);
	}
	private String htmlSimpleMyListString(String videoid,String imgid,int count,String title,String time,String smdata,String smlen,String memo,String desc){
		StringBuffer sb = new StringBuffer();
		String desclink="<a href=\"javascript:void(0)\" onclick=\"showHide('th_"+count+"')\">...</a>";
		String smlink=htmlSmLinks(videoid,count+"",2+"",false);
		sb.append("<div class=\"simple_all\">\n");
		sb.append("<div class=\"simple_img\">");
		sb.append(htmlImgString(imgid,videoid,smlen,2,2,false));
		sb.append("</div>\n");
		sb.append("<div class=\"simple_body\">");
		sb.append(time+" / "+smdata+smlen);
		if(time != "" || smdata!= "")sb.append("<br>");
		sb.append(videoid+" / "+smlink+"\n");
		sb.append("<div class=\"simple_title\">"+htmlAlinkClassPlus(videoid,title)+((desc == "none") ? "" : " "+desclink)+"</div>\n");
		sb.append("</div>\n");
		sb.append("<div class=\"simple_desc\" id=\"th_"+count+"\">"+memo+desc+"</div>\n");
		sb.append("</div>\n\n");
		return new String(sb);
	}
	private String htmlSimpleFetchString(String videoid,String imgid,int count,String title){
		StringBuffer sb = new StringBuffer();
		String smlink=htmlSmLinks(videoid,count+"",2+"",false);
		sb.append("<div class=\"simple_all\">\n");
		sb.append("<div class=\"simple_img\">");
		sb.append(htmlImgString(imgid,videoid,"",2,2,false));
		sb.append("</div>\n");
		sb.append("<div class=\"simple_body\">"+videoid+" / "+title+"<!--<br>"+smlink+"-->\n");
		sb.append("<div class=\"simple_title\">"+htmlAlinkClassPlus(videoid,videoid)+"</div>\n");
		sb.append("</div>\n");
		sb.append("<div class=\"simple_desc\" id=\"th_"+count+"\"></div>\n");
		sb.append("</div>\n\n");
		return new String(sb);
	}
	private String htmlSimpleFetchedString(String videoid,String imgid,int count,String title,String time,String smdata,String desc){
		StringBuffer sb = new StringBuffer();
		String desclink="<a href=\"javascript:void(0)\" onclick=\"showHide('th_"+count+"')\">...</a>";
		String desclink2="<a href=\"javascript:void(0)\" onclick=\"getThumInfo('"+videoid+"','gti_"+count+"')\">...</a>";
		String smlink=htmlSmLinks(videoid,count+"",2+"",true);
		sb.append("<div class=\"simple_all\" id=\""+videoid+"\">\n");
		sb.append("<div class=\"simple_img\">");
		sb.append(htmlImgString(imgid,videoid,"",2,2,false));
		sb.append("</div>\n");
		sb.append("<div class=\"simple_body\">");
		sb.append(time);
		if(time != "")
			sb.append(" / ");
		sb.append(smdata);
		if(time != "" || smdata!= "")
			sb.append("<br>");
		sb.append(videoid+"<br>"+smlink+"\n");
		sb.append("<div class=\"simple_title\">"+htmlAlinkClassPlus(videoid,title)+" "+((desc == "none") ? desclink2 : desclink)+"</div>\n");
		sb.append("</div>\n");
		sb.append("<div class=\"simple_desc\" id=\"th_"+count+"\">"+desc+"</div>\n");
//		sb.append("<span><a href=\"javascript:void(0)\" onclick=\"getFullDesc(this)\" ></A></span>\n");
		sb.append("<div class=\"simple_desc\" id=\"gti_"+count+"\"></div>\n");
		sb.append("</div>\n\n");
		return new String(sb);
	}
	private String htmlSimpleTmpString(String videoid,String imgid,int count,String title,String time,String smdata,String desc){
		StringBuffer sb = new StringBuffer();
		String smid = videoid.replaceAll("low","");
		imgid = imgid.replaceAll("low","");
		String desclink="<a href=\"javascript:void(0)\" onclick=\"getThumInfo('"+smid+"','gti_"+count+"')\">...</a>";
		String smlink=htmlSmLinks(videoid,count+"",2+"",false);
		sb.append("<div class=\"simple_all\">\n");
		sb.append("<div class=\"simple_img\">");
		sb.append(htmlImgString(imgid,smid,"",2,2,false));
		sb.append("</div>\n");
		sb.append("<div class=\"simple_body\">");
		sb.append(time);
		if(time != "")
			sb.append(" / ");
		sb.append(smdata);
		if(time != "" || smdata!= "")
			sb.append("<br>");
		sb.append(videoid+" / "+smlink+"\n");
		sb.append("<div class=\"simple_title\">"+htmlAlinkClassPlus(videoid,title)+" "+desclink+"</div>\n");
		sb.append("<div class=\"simple_desc\" id=\"gti_"+count+"\"></div>\n");
		sb.append(desc+"\n");
		sb.append("</div>\n");
		sb.append("</div>\n\n");
		return new String(sb);
	}
	private String htmlSimpleLiveString(String count,String liveid,String title,String imgurl,String time,String desc,String cotitle,String coid,String coowner,String var){
		coid = htmlRegexpString(coid);
		StringBuffer sb = new StringBuffer();
		String desclink="<a href=\"javascript:void(0)\" onclick=\"showHide('live_"+count+"')\">...</a>";
		sb.append("<div class=\"simple_all\">\n");
		sb.append("<div class=\"simple_img\">");
		sb.append("<img src=\""+imgurl+"\" alt=\"\">");
		sb.append("</div>\n");
		sb.append("<div class=\"simple_body\">"+time+":Jn / "+var+"<br>");
		sb.append(cotitle+" / "+coid+" / :"+coowner+"<br>\n");
		sb.append("<div class=\"simple_title\">"+htmlLiveDataString(liveid)+"<a href=\""+liveid+"\">"+title+"</a> "+desclink+"</div>\n");
		sb.append("</div>\n");
		sb.append("<div class=\"simple_desc\" id=\"live_"+count+"\">"+desc+"</div>\n");
		sb.append("</div>\n\n");
		return new String(sb);
	}
	private String htmlNewMyList(String data,Integer count){
		if(data == null)return "";
		data=data.replaceAll("<>null<>","<>nullnull<>");
		String[] linedata=data.split("<>");
		String ret="";
		String watchurl = linedata[2].replaceAll(URL_WATCH+"(.+)","$1");
		String desc=htmlRegexpString(linedata[6]);
		String memo=htmlRegexpString(linedata[4]);
		memo="memo:"+memo+"<br>";
		if(memo.startsWith("memo: nullnull")) memo ="";
		String vmm="";
		try{
			vmm = "Đ:"+linedata[9]+" Rg:"+linedata[10]+" }CXg:"+linedata[11]+" ";
		}catch(ArrayIndexOutOfBoundsException e){}
		try{
			ret= htmlSimpleMyListString(watchurl,linedata[5],count,linedata[1],linedata[8],vmm+" ",linedata[7],memo,desc);
		}catch(ArrayIndexOutOfBoundsException e){
			ret ="";
		}
		return ret;
	}
	private String htmlLiveDataString(String id){
		return "";
	}
	private String htmlTabeSort(String smid) throws IOException {
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		if(ACBROWSER.startsWith("Firefox")){
			if(smid.length()<12){
				for(int j=0;10>j+smid.length();j++)
				bout.write(" ".getBytes("UTF-8"));
			}
		}else if(ACBROWSER.startsWith("Chrome") || ACBROWSER.startsWith("Safari")){
			bout.write("<font class=\"TableSortZero\">".getBytes("UTF-8"));
			if(smid.length()<12){
				for(int j=0;10>j+smid.length();j++)
				bout.write("0".getBytes("UTF-8"));
			}
			bout.write("</font>".getBytes("UTF-8"));
		}else{
			bout.write("<font class=\"TableSortZero_IE\">".getBytes("UTF-8"));
			if(smid.length()<12){
				for(int j=0;10>j+smid.length();j++)
				bout.write("0".getBytes("UTF-8"));
			}
			bout.write("</font>".getBytes("UTF-8"));
		}
		return bout.toString();
	}
	private String htmlOpenString(String videoid){
		return "<a href=\"./ids?openmylist="+videoid+"\">(open)</a>";
	}
	private String htmlRelationString(String videoid){
		return "<a href=\"./ids?relation="+videoid+"\">(relation)</a>";
	}
	private String htmlWatchString(String videoid){
		return "<a href=\"../watch/"+videoid+"\">(watch)</a>";
	}
	private String htmlFetchString(String videoid,String num){
		if(!ConfigFlagFetcher) return "";
		return "<a href=\"javascript:void(0)\" onclick=\"nicofetch(this,'"+videoid+"',"+num+")\">(fetch)</a>";
	}
	private String htmlFetchedRemoveId(String videoid,String num){
		if(!ConfigFlagFetcher) return "";
		if(!ConfigFlagDelCheck){
			return "<span id=\"ferm_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"removeFetchId('"+videoid+"','ferm_"+num+"')\">(FetchRm)</a></span>";
		}else{
			return "<span id=\"ferm_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"removeFetchId2('"+videoid+"','ferm_"+num+"')\">(FetchRm)</a></span>";
		}
	}
	private String htmlAlinkClassPlus(String videoid,String title){
		String gflag = Cache.getType(videoid);
		if(gflag == null){
			return "<a href=\"./ids?data="+videoid+"&amp;b\">"+title+"</a>";
		}else if(gflag == "low"){
			return "<a class=\"cache_eco\" href=\"./ids?data="+videoid+"&amp;b\">"+title+"</a>";
		}else{
			return "<a class=\"cache\" href=\"./ids?data="+videoid+"&amp;b\">"+title+"</a>";
		}
	}
	private String htmlNlRemoveString(String videoid,String num){
		if(!ConfigFlagDelCheck){
			return "<span id=\"nlrm_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"removeId('"+videoid+"','nlrm_"+num+"')\">(CacheRm)</a></span>";
		}else{
			return "<span id=\"nlrm_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"removeId2('"+videoid+"','nlrm_"+num+"')\">(CacheRm)</a></span>";
		}
	}
	private String htmlAlink(String href,String title){
		return "<a href=\""+href+"\">"+title+"</a>";
	}
	private String htmlFaAddString(String videoid,String num){
		if(!ConfigFlagFaMylist) return "";
		if(!ConfigFlagDelCheck){
			return "<span id=\"a_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"getFIAdd('"+videoid+"','fa','a_"+num+"')\">(add_fa)</a></span>";
		}else{
			return "<span id=\"a_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"getFIAdd2('"+videoid+"','fa','a_"+num+"')\">(add_fa)</a></span>";
		}
	}
	private String htmlInfiAddString(String videoid,String num){
		if(!ConfigFlagInfiMylist) return "";
		if(!ConfigFlagDelCheck){
			return "<span id=\"a_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"getFIAdd('"+videoid+"','infi','a_"+num+"')\">(add_infi)</a></span>";
		}else{
			return "<span id=\"a_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"getFIAdd2('"+videoid+"','infi','a_"+num+"')\">(add_infi)</a></span>";
		}
	}
	private String htmlFaRemoveString(String videoid,String num){
		if(!ConfigFlagFaMylist) return "";
		if(!ConfigFlagDelCheck){
			return "<span id=\"r_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"getFIRemove('"+videoid+"','fa','r_"+num+"')\">(rm_fa)</a></span>";
		}else{
			return "<span id=\"r_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"getFIRemove2('"+videoid+"','fa','r_"+num+"')\">(rm_fa)</a></span>";
		}
	}
	private String htmlInfiRemoveString(String videoid,String num){
		if(!ConfigFlagInfiMylist) return "";
		if(!ConfigFlagDelCheck){
			return "<span id=\"r_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"getFIRemove('"+videoid+"','infi','r_"+num+"')\">(rm_infi)</a></span>";
		}else{
			return "<span id=\"r_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"getFIRemove2('"+videoid+"','infi','r_"+num+"')\">(rm_infi)</a></span>";
		}
	}
	private String htmlAddDefMyListString(String videoid,String num){
		String olds = "";
		if(matchPattern(DEFMYLIST_PAT,videoid))return "<span style=\"color:#F55;\">(add_defmy)</span>";
		if(!ConfigFlagDelCheck){
			return "<span id=\"mdn_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"addDefMylist_nt('"+videoid+"','mdn_"+num+"')\">(add_defmy)</a></span>";
		}else{
			return "<span id=\"mdn_"+num+"\"><a href=\"javascript:void(0)\" onclick=\"addDefMylist_nt('"+videoid+"','mdn_"+num+"')\">(add_defmy)</a></span>";
		}
	}
	private String htmlImgString(String imgurl,String videoid,String times,float bw,float bh,boolean idflag){
		if(imgurl==null)return "no Image<br>\n";
		if(bw == 2){bh=bw=0.5f;
		}else if(bw ==  3){bh=bw=0.75f;
		}else if(bw ==  4){bh=bw=0.4f;
		}else if(bw ==  5){bh=bw=0.3f;
		}else if(bw ==  8){bh=bw=0.8f;
		}else if(bw ==  85){bh=bw=0.85f;
		}else if(bw ==  86){bh=bw=0.86f;
		}else if(bw ==  87){bh=bw=0.87f;
		}else if(bw ==  88){bh=bw=0.88f;
		}else if(bw ==  9){bh=bw=0.9f;
		}else{bh=bw=1;}
		videoid=videoid.replaceAll("low","");
		StringBuffer sb = new StringBuffer();
		String gflag = Cache.getType(videoid);
		String cacheicon ="";
		int timesize=12;
		int timetop=0;
		switch(timesize){
			case 9:timetop=17;break;
			case 10:timetop=18;break;
			case 11:timetop=19;break;
			case 12:timetop=22;break;
			case 15:timetop=26;break;
			default:timetop=0;break;
		}
		String imgpos="";
		if(ConfigFlagImageLength){
			imgpos="left";
		}else{
			times="";
			imgpos="right";
		}
		String sfse="";
		String timemask="";
		if(times==""){
		}else{
			sfse="<span style=\"font-size:"+timesize+"pt;color:#FFF;background:url('http://res.nimg.jp/img/common/bg_b_a60.png');\">"+times+"</span>";
			timemask="<div style=\"position:absolute; top:-"+timetop+"px;right:0px;\">"+sfse+"</div>";
			sfse=null;
		}
		if(idflag)sb.append(videoid+"<br>\n");
		sb.append("<img width=\""+(int)(130*bw)+"\" height=\""+(int)(100*bh)+"\" src=\""+imgurl+"\" alt=\"\">");
		if(gflag == null || ConfigFlagCacheIcon==0){
			FetchingAddList.add(videoid);
			if(times==""){}else{sb.append("<div style=\"position:relative;\">"+timemask+"</div>");}
		}else if(gflag == "low"){
			FetchingAddList.add(videoid);
			sb.append("<div style=\"position:relative;\"><div style=\"position:absolute; top:-"+(int)(CaIcHeight*bh)+"px;"+imgpos+":0px;\">");
			sb.append("<img width=\""+(int)(CaIcWidth*bw)+"\" height=\""+(int)(CaIcHeight*bh)+"\" src=\"../local/cacheeconomy.gif\" alt=\"\"></div>");
			sb.append(timemask+"</div>");
		}else{
			sb.append("<div style=\"position:relative;\"><div style=\"position:absolute; top:-"+(int)(CaIcHeight*bh)+"px;"+imgpos+":0px;\">");
			sb.append("<img width=\""+(int)(CaIcWidth*bw)+"\" height=\""+(int)(CaIcHeight*bh)+"\" src=\"../local/cacheicon.gif\" alt=\"\"></div>");
			sb.append(timemask+"</div>");
		}
		timemask=null;
		return new String(sb);
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private String htmlHearderString(){
		return htmlHearderString("");
	}
	private String htmlHearderString(String title){
		String sla=" / ";
		if(title == "") sla="";
		String hdata=HTMLHEADER1+HTMLHEADERJS+""+
		"<title>"+title+sla+NLTITLE2+"@"+ACBROWSER+"</title>"+HTMLHEADER2;
		String pdata=htmlHearderPlusString();
		return hdata+"<div id=\"all\">\n"+pdata;
	}
	private String htmlHearderPlusString(){
		return htmlHearderPlusString(true);
	}
	private String htmlHearderPlusString(Boolean banar){
		if(!ConfigFlagHtml) return "";
		StringBuffer sb = new StringBuffer();
		sb.append("<div class=\"link_menu\">\n");
		sb.append("<ul>\n");
		sb.append("<li id=\"t_link_nt\"><a href=\"../?g=all\">NicoTop</a> / </li>\n");
		sb.append("<li id=\"t_link_nc\"><a href=\"../cache/\">Cache</a> / </li>\n");
		sb.append("<li id=\"t_link_it\"><a href=\"./ids\">idsTop</a> / </li>\n");
		sb.append("<li id=\"t_link_cl\"><a href=\"./ids?list\">CacheList</a> / </li>\n");
		sb.append("<li id=\"t_link_ll\"><a href=\"./ids?lowlist\">LowList</a> / </li>\n");
		sb.append("<li id=\"t_link_tl\"><a href=\"./ids?templist\">TempList</a> / </li>\n");
		sb.append("<li id=\"t_link_rt\"><a href=\"./ids?rankingtop\">Ranking</a> / </li>\n");
		sb.append("<li id=\"t_link_rl\"><a href=\"./ids?rankinglist\">RankingList</a> / </li>\n");
		sb.append("<li id=\"t_link_lil\"><a href=\"./ids?livelist\">LiveList</a> / </li>\n");
		if(ConfigFlagFaMylist)
			sb.append("<li id=\"t_link_fm\"><a href=\"./ids?famylist\">FaMyList</a> / </li>\n");
		if(ConfigFlagInfiMylist)
			sb.append("<li id=\"t_link_im\"><a href=\"./ids?infimylist\">InfiMyList</a> / </li>\n");
		if(ConfigFlagFetcher){
			sb.append("<li id=\"t_link_fl\"><a href=\"./ids?fetchedlist\">FetchedList</a> / </li>\n");
			sb.append("<li id=\"t_link_fil\"><a href=\"./ids?fetchinglist\">FetchingList</a> / </li>\n");
			sb.append("<li id=\"t_link_fll\"><a href=\"../local/fetched.html\">FetchedLocalList</a> / </li>\n");
		}
		sb.append("<li id=\"t_link_my\"><a href=\"./ids?mypage\">MyPage</a> / </li>\n");
		sb.append("<li id=\"t_link_sl\"><a href=\"./ids?seigalist\">SeigaList</a> / </li>\n");
		sb.append("<li id=\"t_link_mml\"><a href=\"./ids?mymylist\">MyMyList</a> / </li>\n");
//		sb.append(LOGINUSERSESSION);
		sb.append("</ul>\n");
		sb.append("</div>\n");
		if(banar){
			sb.append("<div align=\"center\">\n");
			if(LOGINUSERSESSION == null){
				sb.append("<font size=\"5\" color=\"red\">OAEgԂ̂lq</font><br>\n");
			}
			sb.append("</div>\n");
		}
		return new String(sb);
	}
	private String htmlRightMenuString(HttpRequestHeader requestHeader){
		StringBuffer sb = new StringBuffer();
		sb.append("<div id=\"right\">\n");
		sb.append("\n");
		sb.append("<div class=\"right_all\" id=\"right_links\">\n");
		sb.append("<div class=\"right_title\">Link</div>\n");
		sb.append("<div class=\"right_body\">\n");
		sb.append("<ul>\n");
		sb.append("<li id=\"r_link_nt\"><a href=\"../?g=all\">NicoNicoTop</a></li>\n");
		sb.append("<li id=\"r_link_nc\"><a href=\"../cache/\">Cache</a></li>\n");
		sb.append("<li id=\"r_link_it\"><a href=\"./ids\">idsTop</a></li>\n");
		sb.append("<li id=\"r_link_cl\"><a href=\"./ids?list\">CacheList</a></li>\n");
		sb.append("<li id=\"r_link_ll\"><a href=\"./ids?lowlist\">LowList</a></li>\n");
		sb.append("<li id=\"r_link_tl\"><a href=\"./ids?templist\">TempList</a></li>\n");
		sb.append("<li id=\"r_link_rt\"><a href=\"./ids?rankingtop\">Ranking</a></li>\n");
		sb.append("<li id=\"r_link_rl\"><a href=\"./ids?rankinglist\">RankingList</a></li>\n");
		sb.append("<li id=\"r_link_lil\"><a href=\"./ids?livelist\">LiveList</a></li>\n");
		if(ConfigFlagFaMylist)
			sb.append("<li id=\"r_link_fm\"><a href=\"./ids?famylist\">FavoriteMyList</a></li>\n");
		if(ConfigFlagInfiMylist)
			sb.append("<li id=\"r_link_im\"><a href=\"./ids?infimylist\">InfityMyList</a></li>\n");
		if(ConfigFlagFetcher){
			sb.append("<li id=\"r_link_fl\"><a href=\"./ids?fetchedlist\">FetchedList</a></li>\n");
			sb.append("<li id=\"r_link_fil\"><a href=\"./ids?fetchinglist\">FetchingList</a></li>\n");
			sb.append("<li id=\"r_link_fll\"><a href=\"../local/fetched.html\">FetchedLocalList</a></li>\n");
		}
		sb.append("<li id=\"r_link_my\"><a href=\"./ids?mypage\">MyPage</a></li>\n");
		sb.append("<li id=\"r_link_sl\"><a href=\"./ids?seigalist\">SeigaList</a></li>\n");
		sb.append("</ul>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("\n");
		sb.append("<div class=\"right_all\" id=\"right_ranking\">\n");
		sb.append("<div class=\"right_title\">RankingList</div>\n");
		sb.append("<div class=\"right_body\">\n");
		sb.append("<ul>\n");
		sb.append("<li><a href=\"./ids?ranking=view/hourly/all\">view/hourly/all</a></li>\n");
		sb.append("<li><a href=\"./ids?ranking=view/daily/all\">view/daily/all</a></li>\n");
		sb.append("<li><a href=\"./ids?ranking=res/hourly/all\">res/hourly/all</a></li>\n");
		sb.append("<li><a href=\"./ids?ranking=res/daily/all\">res/daily/all</a></li>\n");
		sb.append("<li><a href=\"./ids?ranking=mylist/hourly/all\">mylist/hourly/all</a></li>\n");
		sb.append("<li><a href=\"./ids?ranking=mylist/daily/all\">mylist/daily/all</a></li>\n");
		sb.append("</ul>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("\n");
		String fadata="";
		String linedata[] = new String[5];
		if(ConfigFlagFaMylist){
			sb.append("<div class=\"right_all\" id=\"right_falist\">\n");
			sb.append("<div class=\"right_title\">FavoriteMyList/Top50</div>\n");
			sb.append("<div class=\"right_body\">\n");
			sb.append("<ul>\n");
			for (int i = FAMYLISTLIST.size()-1 ; i >= FAMYLISTLIST.size()-50  ; i--){
				if(i<0)break;
				fadata = FAMYLISTLIST.get(i);
				linedata = fadata.split("<>");
				sb.append("<li>E<a href=\"./ids?mylist="+linedata[1]+"\">"+linedata[2]+"</a></li>\n");
			}
			sb.append("</ul>\n");
			sb.append("</div>\n");
			sb.append("</div>\n");
		}
		sb.append("\n");
		sb.append("<div class=\"right_all\" id=\"right_memo\">\n");
		sb.append("<div class=\"right_title\">Memo</div>\n");
		sb.append("<div class=\"right_body\">\n");
		sb.append("<ul>\n");
/*		sb.append("<li>CacheSize -&gt; "+cacheSmNum+"</li>\n");
		sb.append("<li>LowCacheSize -&gt; "+cacheSmLowNum+"</li>\n");
		sb.append("<li>TmpCacheSize -&gt; "+cacheSmTmpNum+"</li>\n");
		sb.append("<li>DefMyListSize -&gt; "+DEFMYLIST_PAT.size()+"</li>\n");
		sb.append("<li>LinesNumberOfLog  -&gt; "+logcount+"</li>\n");
		if(ConfigFlagFaMylist)
			sb.append("<li>FavoriteMyListSize -&gt; "+FAMYLISTLIST.size()+"</li>\n");
		if(ConfigFlagInfiMylist)
			sb.append("<li>InfityMyListSize -&gt; "+INFIMYLISTLIST.size()+"</li>\n");
		if(ConfigFlagFetcher){
			sb.append("<li>FetchedSize -&gt; "+fetchNum+"</li>\n");
		}
*/
		if(FetchingAddList!= null && FetchingAddList.size() > 0){
			StringBuffer allfetch = new StringBuffer();
			for (int i = 0 ; i < FetchingAddList.size()-1; i++){
				allfetch.append(FetchingAddList.get(i)+"+");
			}
			allfetch.append(FetchingAddList.get(FetchingAddList.size()-1));
			sb.append("<li><a href=\"./ids?fetchall="+allfetch+"\">FetchALL</a></li>\n");
			allfetch=null;
		}
		sb.append("<li>PageVideoSize -&gt; "+FetchingAddList.size()+"</li>\n");
		FetchingAddList.clear();
/*		sb.append("</ul>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("\n");
		sb.append("<div class=\"right_all\" id="right_debugmemo">\n");
		sb.append("<div class=\"right_title\">DebugMemo</div>\n");
		sb.append("<div class=\"right_body\">\n");
		sb.append("<ul>\n");
		long totalSize = Long.valueOf(Cache.size());
		long freeSize = DiskFreeSpace.get(Cache.getCacheDir());
		sb.append("<li>---------------------------------</li>\n");
		sb.append("<li>MainVersion-"+Main.getVersion()+"</li>\n");
		sb.append("<li>JavaVersion-"+System.getProperty("java.version")+"</li>\n");
//		sb.append("<li>OS Name-"+System.getProperty("os.name")+"</li>\n");
*/		sb.append("<li>---------------------------------</li>\n");
		sb.append("<li>ExtensionVersion -&gt; "+NLTITLE2+" "+VERSION+"</li>\n");
		sb.append("<li>Browser -&gt; "+ACBROWSER+"</li>\n");
//		sb.append("<li>TotalCacheSize -&gt; "+String.format("%,d", totalSize)+" Byte</li>\n");
//		sb.append("<li>DiscFreeSpace -&gt; "+String.format("%,d", freeSize)+" Byte</li>\n");
//		sb.append("<li>TotalCacheSize2 -&gt; "+String.format("%.3f", totalSize/1024.0/1024/1024)+" GigaByte</li>\n");
//		sb.append("<li>DiscFreeSpace2 -&gt; "+String.format("%.3f", freeSize/1024.0/1024/1024)+" GigaByte</li>\n");
//		sb.append("<li>---------------------------------</li>\n");
//		sb.append("<li>---------------------------------</li>\n");
//		sb.append("<li>FLV -&gt; "+FLV_GDATA.size()+"</li>\n");
//		sb.append("<li>NCOM -&gt; "+COMMENT_N_GDATA.size()+"</li>\n");
//		sb.append("<li>TCOM -&gt; "+COMMENT_T_GDATA.size()+"</li>\n");
//		sb.append("<li>---------------------------------</li>\n");
		sb.append("</ul>\n");
		sb.append("</div>\n");
		sb.append("</div>\n");
		sb.append("\n");
		sb.append("</div>\n");
		return new String(sb);
	}
	private String htmlFooterString(HttpRequestHeader requestHeader){
		return htmlFooterString(requestHeader,true);
	}
	private String htmlFooterString(HttpRequestHeader requestHeader,Boolean rflag){
		String ret="";
		if(rflag)
			ret+=htmlRightMenuString(requestHeader);
		ret+="<br class=\"c-both\">\n";
		if(ConfigFlagFooLink)
			ret+=htmlHearderPlusString(false);
		ret+="</div>\n";
		return ret+HTMLFOOTER;
	}
	private String htmlMemoryView(){
		return htmlMemoryView(true,false);
	}
	private String htmlMemoryView(Boolean textf,Boolean lif){
		StringBuffer sb = new StringBuffer();
		long memoryfree = Runtime.getRuntime().freeMemory() / 1024;
		long memorytotal = Runtime.getRuntime().totalMemory() / 1024;
		long memorymax = Runtime.getRuntime().maxMemory() / 1024;
		long memoryused = memorytotal - memoryfree;
		double memoryratio = (memoryused * 100 / (double)memorytotal);
		double memorytotalratio = (memoryused * 100 / (double)memorymax);
		String br="";
		String lis="";
		String lie="";
		if(textf){sb.append("\n");}else{br="<br>";}//&gt;
		if(lif){lis="<li>";lie="</li>";}else{}
		sb.append(lis+"MemoryMax => "+String.format("%.3f",memorymax/1024.0)+" MByte"+lie+br+"\n");
		sb.append(lis+"MemoryTotal => "+String.format("%.3f",+memorytotal/1024.0)+" MByte"+lie+br+"\n");
		sb.append(lis+"MemoryFree => "+String.format("%.3f",memoryfree/1024.0)+" MByte"+lie+br+"\n");
		sb.append(lis+"MemoryUsed => "+String.format("%.3f",memoryused/1024.0)+" MByte"+lie+br+"\n");
		sb.append(lis+"MemoryRatio => "+String.format("%.3f",memoryratio)+"%"+lie+br+"\n");
		sb.append(lis+"MemoryTotalRatio => "+String.format("%.3f",memorytotalratio)+"%"+lie+br+"\n");
		return new String(sb);
	}
	private String htmlCacheView(Boolean textf,Boolean lif){
		StringBuffer sb = new StringBuffer();
		long cachetotalSize = Long.valueOf(Cache.size());
		long freeSize = DiskFreeSpace.get(Cache.getCacheDir());
		long totalSize = 0l;
		String cFile = "";
		if (System.getProperty("cacheFolder").equals("cache")){
			cFile = System.getProperty("user.dir");
		}else{
			cFile = System.getProperty("cacheFolder");
		}
		try{
			totalSize = new File(cFile.substring(0,2)).getTotalSpace();
		}catch (Error e) {
		}catch(SecurityException e){
		}catch(Exception e){
		}
		String br="";
		String lis="";
		String lie="";
		if(textf){sb.append("\n");}else{br="<br>";}//&gt;
		if(lif){lis="<li>";lie="</li>";}else{}
		sb.append(lis+"TotalCacheSize1 => "+String.format("%,d", cachetotalSize)+" Byte"+lie+br+"\n");
		sb.append(lis+"TotalCacheSize2 => "+String.format("%.3f", cachetotalSize/1024.0/1024/1024)+" GigaByte"+lie+br+"\n");
		sb.append(lis+"DiscFreeSpace1 -=> "+String.format("%,d", freeSize)+" Byte"+lie+br+"\n");
		sb.append(lis+"DiscFreeSpace2 -=> "+String.format("%.3f", freeSize/1024.0/1024/1024)+" GigaByte"+lie+br+"\n");
		if(totalSize > 0){
			long useDiscSize = totalSize - freeSize;
			double cacheratio = (cachetotalSize *100 / (double)totalSize);
			double freeratio = (freeSize *100 / (double)totalSize);
			double useratio = (useDiscSize *100 / (double)totalSize);
			sb.append(lis+"TotalDiscSize1 => "+String.format("%,d", totalSize)+" Byte"+lie+br+"\n");
			sb.append(lis+"TotalDiscSize2 => "+String.format("%.3f", totalSize/1024.0/1024/1024)+" GigaByte"+lie+br+"\n");
			sb.append(lis+"UseDiscSize1 => "+String.format("%,d", useDiscSize)+" Byte"+lie+br+"\n");
			sb.append(lis+"UseDiscSize2 => "+String.format("%.3f", useDiscSize/1024.0/1024/1024)+" GigaByte"+lie+br+"\n");
			sb.append(lis+"DiscCacheRatio => "+String.format("%.3f",cacheratio)+"%"+lie+br+"\n");
			sb.append(lis+"DiscUseRatio -=> "+String.format("%.3f",useratio)+"%"+lie+br+"\n");
			sb.append(lis+"DiscFreeRatio -=> "+String.format("%.3f",freeratio)+"%"+lie+br+"\n");
		}else{
			sb.append(lis+"CacheRatio => ???%"+lie+br+"\n");
			sb.append(lis+"DiscRatio -=> ???%"+lie+br+"\n");
		}
		return new String(sb);
	}
	private String htmlNowSeigaTable(HttpRequestHeader requestHeader)throws IOException {
		ArrayList<String> nowlive = getNowSigaList(requestHeader);
		StringBuffer sb = new StringBuffer();
		String ldata="";
		String[] linedata = new String[10];
		if(nowlive != null && nowlive.size()>0){
			sb.append("<table width=\"100%\">\n<tr>");
			sb.append("<th colspan=\"2\" align=\"center\">gbvÉ惊Xg/"+nowlive.size()+"</th>");
//			sb.append("gbvÉ惊Xg/"+nowlive.size()+"<br>\n");
			sb.append("</tr>\n");
			for (int i = 0 ; i < nowlive.size() ; i++){
				sb.append("<tr><td width=\"1%\">\n");
				ldata = nowlive.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append(linedata[2]+"</td><td><a href=\"ids?seigabbs="+linedata[0]+"\">"+linedata[1]+"</a>");
				}catch(ArrayIndexOutOfBoundsException e){
				}
				sb.append("\n</td></tr>\n");
			}
			sb.append("</table>\n");
		}
		return new String(sb);
	}
	private String htmlNowLiveTable(HttpRequestHeader requestHeader)throws IOException {
		ArrayList<String> nowlive = getNowLiveList(requestHeader);
		StringBuffer sb = new StringBuffer();
		String ldata="";
		String urllv="";
		String[] linedata = new String[10];
		if(nowlive != null && nowlive.size()>0){
			sb.append("<table width=\"100%\">\n<tr>");
			sb.append("<th align=\"center\">/"+nowlive.size()+"</th>");
//			sb.append("/"+nowlive.size()+"<br>\n");
			sb.append("</tr>\n<tr><td>\n");
			for (int i = 0 ; i < nowlive.size() ; i++){
				ldata = nowlive.get(i);
				linedata = ldata.split("<>");
				try{
					urllv = linedata[0].replaceAll(".+?/(watch|gate)/","");
					sb.append("<!--<a href=\""+URL_API_LIVE_INFO+urllv+"\">[IL]</a> ");
					sb.append("<a href=\""+URL_API_LIVE_FLV+urllv+"\">[FL]</a> / -->");
					sb.append("<a href=\""+linedata[0]+"\">"+linedata[1]+"</a> / @"+urllv+"");
					sb.append("<br>\n");
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
			sb.append("</td></tr></table>\n");
		}
		return new String(sb);
	}
	private String htmlNowLiveTable2(HttpRequestHeader requestHeader)throws IOException {
		ArrayList<String> nowlive = getNowLiveList(requestHeader);
		StringBuffer sb = new StringBuffer();
		String ldata="";
		String[] linedata = new String[10];
		if(nowlive != null && nowlive.size()>0){
			for (int i = 0 ; i < nowlive.size() ; i++){
				ldata = nowlive.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append("<a href=\""+linedata[0]+"\">"+linedata[1]+"</a>\n");
					if(i+1 < nowlive.size()){
						sb.append("<br>");
					}
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
		}else{
			sb.append("Ȃ");
		}
		return new String(sb);
	}
	private String htmlGateLiveTable(HttpRequestHeader requestHeader)throws IOException {
		ArrayList<String> nowlive = getGateLiveList(requestHeader);
		StringBuffer sb = new StringBuffer();
		String ldata="";
		String[] linedata = new String[10];
		if(nowlive != null && nowlive.size()>0){
			sb.append("<table width=\"100%\">\n<tr>");
			sb.append("<th align=\"center\">\񒆂܂͏I/"+nowlive.size()+"</th>");
			sb.append("</tr>\n<tr><td>\n");
			for (int i = 0 ; i < nowlive.size() ; i++){
				ldata = nowlive.get(i);
				linedata = ldata.split("<>");
				try{
					sb.append("<a href=\""+linedata[0]+"\">"+linedata[1]+"</a> / @"+(linedata[0].replaceAll(".+?/(watch|gate)/","")));
					sb.append(" / (<a href=\""+linedata[0].replaceAll("gate","watch")+"\">w</a>)");
					sb.append("<br>\n");
				}catch(ArrayIndexOutOfBoundsException e){
				}
			}
			sb.append("</td></tr></table>\n");
		}
		return new String(sb);
	}
	private String htmlFavoriteMyListNum(String num){
		try{
			String line =FAMYLISTLIST.get(parStringInteger(num));
			String[] linedata = line.split("<>");
			return "<a href=\"./ids?mylist="+linedata[1]+"\">"+linedata[2]+"</a>";
		}catch(IndexOutOfBoundsException e){
			return "";
		}
	}
	private String htmlFlvTable(ConcurrentHashMap<String, String>getMap,String smid)throws IOException {
		String data="No Data";
		String dataL="No Login";
		String dataA="Access Locked";//error=access_locked&done=true
		if(getMap == null) return data;
		if(getMap.containsKey("error")) return dataA;
		if(getMap.containsKey("closed")) return dataL;
		if(getMap == null) return data;
		String flvPrem = getMap.get("is_premium");
		Boolean preFlag = false;
		String yTime = " -&gt; ";
		SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		Date date1 = new Date(parStringLong(getMap.get("time"))*1000);
		yTime += sdf1.format(date1);
		if(flvPrem.startsWith("1")) preFlag=true;
		StringBuffer sb = new StringBuffer();
		sb.append("<table cellpadding=1 cellspacing=1 class=\"sortable\" id=\"info\">\n");
		sb.append("<tr><th class=\"unsortable\">key</th><th class=\"unsortable\">data</th></tr>\n");
		sb.append("<tr><td>FlvURL</td><td>"+URL_API_FLV+smid+" <a href=\""+URL_API_FLV+smid+"\">[L]</a></td></tr>\n");
		sb.append("<tr><td>Premium</td><td>"+flvPrem+"<!-- ("+preFlag+")--></td></tr>\n");
		sb.append("<tr><td>Thread</td><td>"+getMap.get("thread_id")+"</td></tr>\n");
		sb.append("<tr><td>Url</td><td>"+getMap.get("url")+"</td></tr>\n");
		sb.append("<tr><td>Hms</td><td>"+getMap.get("hms")+"</td></tr>\n");
		sb.append("<tr><td>Nick</td><td>"+getMap.get("nickname")+"</td></tr>\n");
		sb.append("<tr><td>Link</td><td>"+getMap.get("link")+" <a href=\""+getMap.get("link")+"\">[L]</a></td></tr>\n");
		sb.append("<tr><td>Ms</td><td>"+getMap.get("ms")+"</td></tr>\n");
		sb.append("<tr><td>Hmstk</td><td>"+getMap.get("hmstk")+"</td></tr>\n");
		sb.append("<tr><td>Time</td><td>"+ getMap.get("time") + yTime+"</td></tr>\n");
		sb.append("<tr><td>UserId</td><td>"+getMap.get("user_id")+"</td></tr>\n");
		sb.append("<tr><td>Time(sec)</td><td>"+getMap.get("l")+"</td></tr>\n");
//		sb.append("<tr><td>Hmst</td><td>"+getMap.get("hmst")+"</td></tr>\n");
//		sb.append("<tr><td>Done</td><td>"+getMap.get("done")+"</td></tr>\n");
//		sb.append("<tr><td>Hmsp</td><td>"+getMap.get("hmsp")+"</td></tr>\n");
		sb.append("<tr><td>NgLv</td><td>"+getMap.get("ng_rv")+"</td></tr>\n");
		if(getMap.containsKey("ng_up") && getMap.get("ng_up") != null){
			if(getMap.get("ng_up").startsWith("%")){
				sb.append("<tr><td>NgUp</td><td>"+URLDecoder.decode(getMap.get("ng_up"), "utf-8").replaceAll("&","<br>")+"</td></tr>\n");
			}else{
				sb.append("<tr><td>NgUp</td><td>"+getMap.get("ng_up").replaceAll("&","<br>")+"</td></tr>\n");
			}
		}
		sb.append("</table>\n");
		return new String(sb);
	}
	private String htmlInfoTable(ConcurrentHashMap<String, String>getMap,String smid){
		String data="No Data";
		if (getMap == null) return data;
//		String infoThubType = getMap.get("thumb_type");
//		String infoEmbe = getMap.get("embeddable");
		long fltime = htmlLocalTime(getMap.get("first_retrieve"));
		String infoDesc = htmlRegexpString(getMap.get("description"));
		StringBuffer sb = new StringBuffer();
		sb.append("<table cellpadding=1 cellspacing=1 class=\"sortable\" id=\"info\">\n");
		sb.append("<tr><th class=\"unsortable\">key</th><th class=\"unsortable\">data</th></tr>\n");
		sb.append("<tr><td>InfoURL</td><td>"+URL_API_INFO + smid+" <a href=\""+URL_API_INFO+smid+"\">[L]</a></td></tr>\n");
		sb.append("<tr><td>VideoId</td><td>"+getMap.get("video_id")+"</td></tr>\n");
		sb.append("<tr><td>Title</td><td>"+getMap.get("title")+"</td></tr>\n");
		sb.append("<tr><td>Time</td><td>"+getMap.get("first_retrieve")+" / "+fltime+"</td></tr>\n");
		sb.append("<tr><td>WatchURL</td><td>"+getMap.get("watch_url")+" <a href=\""+getMap.get("watch_url")+"\">[L]</a></td></tr>\n");
		sb.append("<tr><td>Thumbnail</td><td>"+getMap.get("thumbnail_url")+" <a href=\""+getMap.get("thumbnail_url")+"\">[L]</a></td></tr>\n");
		sb.append("<tr><td>user_id</td><td>"+getMap.get("user_id")+" <a href=\""+URL_USER+getMap.get("user_id")+"\">[L]</a></td></tr>\n");
		sb.append("<tr><td>View</td><td>"+getMap.get("view_counter")+"</td></tr>\n");
		sb.append("<tr><td>Comment</td><td>"+getMap.get("comment_num")+"</td></tr>\n");
		sb.append("<tr><td>MyList</td><td>"+getMap.get("mylist_counter")+"</td></tr>\n");
		sb.append("<tr><td>Length</td><td>"+getMap.get("length")+"</td></tr>\n");
		if(getMap.containsKey("size_high")){
			sb.append("<tr><td>HighSize</td><td>"+String.format("%,d",parStringLong(getMap.get("size_high"))/1024)+" KByte</td></tr>\n");
		}
		if(getMap.containsKey("size_low") && parStringLong(getMap.get("size_low"))>0){
			sb.append("<tr><td>LowSize</td><td>"+String.format("%,d",parStringLong(getMap.get("size_low"))/1024)+" KByte</td></tr>\n");
		}
		sb.append("<tr><td>Tags</td><td>");
		for(int i=1;i<=10;i++){
			if(getMap.containsKey("tag"+i))
				sb.append("<a href=\"../tag/"+getMap.get("tag"+i)+"\">"+getMap.get("tag"+i)+"</a> / ");
//				sb.append("<a href=\"./ids?testsearch="+getMap.get("tag"+i)+"\">"+getMap.get("tag"+i)+"</a> / ");
		}
		sb.append("</td></tr>\n");
		sb.append("<tr><td>Description</td><td>"+infoDesc+" </td></tr>\n");
		sb.append("</table>\n");
		return new String(sb);
	}
	private String htmlPostTable(ConcurrentHashMap<String, String> mappost,ConcurrentHashMap<String, String> mapflv){
		StringBuffer sb = new StringBuffer();
		if(ConfigFlagComP){
			sb.append("<table cellpadding=1 cellspacing=1 class=\"sortable\" id=\"info\">\n");
			sb.append("<tr><th class=\"unsortable\">key</th><th class=\"unsortable\">data</th></tr>\n");
			sb.append("<tr><td>PostUrl</td><td>"+mappost.get("posturl")+"</td></tr>\n");
			sb.append("<tr><td>PostTicket</td><td>"+mappost.get("ticket")+"</td></tr>\n");
			sb.append("<tr><td>PostLastRes</td><td>"+mappost.get("lastres")+"</td></tr>\n");
			sb.append("<tr><td>PostBlockNo</td><td>"+mappost.get("blockno")+"</td></tr>\n");
			sb.append("<tr><td>PostKey</td><td>"+mappost.get("postkey")+"</td></tr>\n");
			if(!ConfigFlagFlv){
				sb.append("<tr><td>MsServer</td><td>"+mapflv.get("ms")+"</td></tr>\n");
				sb.append("<tr><td>UserId</td><td>"+mapflv.get("user_id")+"</td></tr>\n");
				sb.append("<tr><td>Thread</td><td>"+mapflv.get("thread_id")+"</td></tr>\n");
			}
			sb.append("</table>\n");
		}
		return new String(sb);
	}
	private String htmlSeigaBbsList(HttpRequestHeader requestHeader,String sgid)throws IOException {
		StringBuffer sb = new StringBuffer();
		String ldata="";
		String imglink="";
		String imglink2="";
		String[] linedata = new String[10];
		ArrayList<String> bbslist = getSeigaBbsList(requestHeader,sgid);
		if(bbslist != null && bbslist.size() >0){
			for (int i = 0 ; i < bbslist.size() ; i++){
				ldata = bbslist.get(i);
				linedata = ldata.split("<>");
				imglink  = URL_API_SEIGA_IMG+linedata[1];
				imglink2 = URL_API_SEIGA_SOURCE+"?id="+linedata[1];
				if(ConfigFlagSeigaImageSize.startsWith("Small")){
					sb.append(htmlSeigaBbsListS(imglink,imglink2));
				}else if(ConfigFlagSeigaImageSize.startsWith("Middle")){
					sb.append(htmlSeigaBbsListM(imglink,imglink2));
				}else if(ConfigFlagSeigaImageSize.startsWith("Large")){
					sb.append(htmlSeigaBbsListL(imglink,imglink2));
				}else{
					sb.append(htmlSeigaBbsListS(imglink,imglink2));
				}
			}
		}
		return new String(sb);
	}
	private String htmlSeigaBbsListS(String imgl,String imgl2)throws IOException {
		return "<a href=\""+imgl2+"\"><img src=\""+imgl+"s\" width=\"96px\" height=\"72px\"></a>\n";
	}
	private String htmlSeigaBbsListM(String imgl,String imgl2)throws IOException {
		return "<a href=\""+imgl2+"\"><img src=\""+imgl+"m\"></a><br>\n";
	}
	private String htmlSeigaBbsListL(String imgl,String imgl2)throws IOException {
		return "<a href=\""+imgl2+"\"><img src=\""+imgl+"l\"></a><br>\n";
	}
	private String htmlLiveFlvTable(ConcurrentHashMap<String, String>getMap){
		StringBuffer sb = new StringBuffer();
		sb.append("<table cellpadding=1 cellspacing=1 class=\"sortable\" id=\"info\">\n");
		sb.append("<tr><th class=\"unsortable\">key</th><th class=\"unsortable\">data</th></tr>\n");
		sb.append("<tr><td>LiveDataURL</td><td>"+URL_API_LIVE_FLV+getMap.get("video_id")+"</td></tr>\n");
		sb.append("<tr><td>video_id</td><td>"+getMap.get("video_id")+"</td></tr>\n");
		sb.append("<tr><td>watch_count</td><td>"+getMap.get("watch_count")+"</td></tr>\n");
		sb.append("<tr><td>comment_count</td><td>"+getMap.get("comment_count")+"</td></tr>\n");
		sb.append("<tr><td>room_label</td><td>"+getMap.get("room_label")+"</td></tr>\n");
		sb.append("<tr><td>room_seetno</td><td>"+getMap.get("room_seetno")+"</td></tr>\n");
		sb.append("<tr><td>ms</td><td>"+getMap.get("ms")+"</td></tr>\n");
		sb.append("<tr><td>ms_port</td><td>"+getMap.get("ms_port")+"</td></tr>\n");
		sb.append("<tr><td>thread_id</td><td>"+getMap.get("thread_id")+"</td></tr>\n");
		sb.append("<tr><td>url</td><td>"+getMap.get("url")+"</td></tr>\n");
		sb.append("<tr><td>stream_ticket</td><td>"+getMap.get("stream_ticket")+"</td></tr>\n");
		sb.append("<tr><td>stream_name</td><td>"+getMap.get("stream_name")+"</td></tr>\n");
		sb.append("</table>\n");
//		sb.append("<tr><td>comment_lock</td><td>"+getMap.get("comment_lock")+"</td></tr>\n");
//		sb.append("<tr><td>base_time</td><td>"+getMap.get("base_time")+"</td></tr>\n");
//		sb.append("<tr><td>ichiba_notice_enable</td><td>"+getMap.get("ichiba_notice_enable")+"</td></tr>\n");
//		sb.append("<tr><td>is_premium</td><td>"+getMap.get("is_premium")+"</td></tr>\n");
//		sb.append("<tr><td>user_id</td><td>"+getMap.get("user_id")+"</td></tr>\n");
//		sb.append("<tr><td>nickname</td><td>"+getMap.get("nickname")+"</td></tr>\n");
//		sb.append("<tr><td>time</td><td>"+getMap.get("time")+"</td></tr>\n");
		return new String(sb);
	}
	private String htmlLiveInfoTable(ConcurrentHashMap<String, String>getMap){
		StringBuffer sb = new StringBuffer();
		String bTime = " -&gt; ";
		String oTime = " -&gt; ";
		String sTime = " -&gt; ";
		SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		Date date1 = new Date(parStringLong(getMap.get("base_time"))*1000);
		bTime += sdf1.format(date1);
		date1 = new Date(parStringLong(getMap.get("open_time"))*1000);
		oTime += sdf1.format(date1);
		date1 = new Date(parStringLong(getMap.get("start_time"))*1000);
		sTime += sdf1.format(date1);
		sb.append("<table cellpadding=1 cellspacing=1 class=\"sortable\" id=\"info\">\n");
		sb.append("<tr><th class=\"unsortable\">key</th><th class=\"unsortable\">data</th></tr>\n");
		sb.append("<tr><td>LiveDataURL</td><td>"+URL_API_LIVE_INFO+getMap.get("id")+"</td></tr>\n");
		sb.append("<tr><td>View</td><td>" + getMap.get("watch_count")+"</td></tr>\n");
		sb.append("<tr><td>comment</td><td>"+getMap.get("comment_count")+"</td></tr>\n");
		sb.append("<tr><td>type</td><td>"+getMap.get("provider_type")+"</td></tr>\n");
		sb.append("<tr><td>community</td><td>"+getMap.get("default_community")+"</td></tr>\n");
		sb.append("<tr><td>community2</td><td>"+getMap.get("room_label")+"</td></tr>\n");
		sb.append("<tr><td>base_time</td><td>"+getMap.get("base_time")+bTime+"</td></tr>\n");
		sb.append("<tr><td>open_time</td><td>"+getMap.get("open_time")+oTime+"</td></tr>\n");
		sb.append("<tr><td>start_time</td><td>"+getMap.get("start_time")+sTime+"</td></tr>\n");
		sb.append("<tr><td>msg url</td><td>"+getMap.get("addr")+"</td></tr>\n");
		sb.append("<tr><td>msg port</td><td>"+getMap.get("port")+"</td></tr>\n");
		sb.append("<tr><td>thread</td><td>"+getMap.get("thread")+"</td></tr>\n");
		sb.append("</table>\n");
		return new String(sb);
	}
	private String htmlLiveNgTable(ArrayList<String>getMap,String id){
		StringBuffer sb = new StringBuffer();
		sb.append("<table cellpadding=1 cellspacing=1 class=\"sortable\" id=\"info\">\n");
		sb.append("<tr><th class=\"unsortable\">key</th><th class=\"unsortable\">data</th></tr>\n");
		sb.append("<tr><td>LiveNgURL</td><td>");
		sb.append(URL_API_LIVE_NG+id+"&mode=get");
		sb.append("</td></tr>\n");
		String line="";
		String linedata[]= new String[5];
		String nTime = "";
		SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		for (int i = 0 ; i < getMap.size() ; i++){
			line = getMap.get(i);
			line=line.replaceAll("</?register_time>","<>");
			line=line.replaceAll("<type>[^<]+</type>","");
			line=line.replaceAll("<[^>]+>","");
			linedata=line.split("<>");
			nTime = " -&gt; ";
			Date date1 = new Date(parStringLong(linedata[1])*1000);
			nTime += sdf1.format(date1);
			sb.append("<tr><td>"+linedata[0]+"</td><td>"+linedata[1]+nTime+"</td></tr>\n");
		}
		sb.append("</table>\n");
		return new String(sb);
	}
	private String htmlNCommentString(ArrayList<String> content){
		String data="No Data";
		String ret="";
		String lda="";
		StringBuffer sb = new StringBuffer();
		String line[] = new String[10];
		String ops="";String opa="";
		int vpos=0;
		String comType="NOMAL COMMENT/"+content.size()+"<br>\n";
		String tableTh="<table width=\"100%\" border=0 class=\"sortable\" id=\"comm\">\n"+
			"<tr><th>num</th><th>vpos</th><th>id</th><th>res</th>";
		if(ConfigFlagHtml && ConfigFlagComD)tableTh+="<th>date</th>";
		if(ConfigFlagHtml)sb.append(comType);
		sb.append(tableTh+"</tr>\n");
		SimpleDateFormat sdf1 = new SimpleDateFormat("yy/MM/dd HH:mm:ss");
		Date date1 = new Date();
		String pDate="";
		ConcurrentHashMap<Integer,Integer> vpc = new ConcurrentHashMap<Integer,Integer>();
		ConcurrentHashMap<String,Integer> idc = new ConcurrentHashMap<String,Integer>();
		Integer vpcmax=1;Integer idcmax=1;
		for (int i = 0 ; i < content.size() ; i++){
			lda = content.get(i);
			line = lda.split("<>");
			try{
				vpos=parStringInteger(line[3]);
				vpos=vpos/100;
				if(vpos/60<10){ops="0";}else{ops="";}
				if(vpos%60<10){opa="0";}else{opa="";}
				if(vpc.containsKey(vpos)){
					vpc.replace(vpos,vpc.get(vpos)+1);
					if(vpcmax<vpc.get(vpos))vpcmax=vpc.get(vpos);
				}else{
					vpc.put(vpos,1);
				}
				date1 = new Date(parStringLong(line[4])*1000);
				pDate = sdf1.format(date1);
				if(idc.containsKey(line[5])){
					idc.replace(line[5],idc.get(line[5])+1);
					if(idcmax<idc.get(line[5]))idcmax=idc.get(line[5]);
				}else{
					idc.put(line[5],1);
				}
				sb.append("<tr><td>"+line[2]+"</td>");
				sb.append("<td>"+ops + vpos/60+":"+opa + vpos%60+"</td>");
				sb.append("<td>"+line[6]+"</td>");
				sb.append("<td>"+line[7]+"</td>");
				if(ConfigFlagHtml && ConfigFlagComD)sb.append("<td>"+pDate+"</td>");
				sb.append("</tr>\n");
			} catch (ArrayIndexOutOfBoundsException e) {
				sb.append("<tr><td>???</td><td>???</td>");
				sb.append("<td>???</td><td>???</td></tr>");
			}
		}
		sb.append("</table>\n");
		sb.append("<!--size"+vpc.size()+"(max"+vpcmax+")/size"+idc.size()+"(max"+idcmax+")-->\n");
		return new String(sb);
	}
	private String htmlTCommentString(ArrayList<String> content){
		String data="No Data";
		String ret="";
		String lda="";
		StringBuffer sb = new StringBuffer();
		String line[] = new String[10];
		String ops="";String opa="";
		if(content.size() == 0)return data;
		int vpos=0;
		String comType="TOUKOUSYA COMMENT/"+content.size()+"<br>\n";
		String tableTh="<table width=\"100%\" border=0 class=\"sortable\" id=\"comm\">\n"+
			"<tr><th>num</th><th>vpos</th><th>mail</th><th>res</th>";
		if(ConfigFlagHtml && ConfigFlagComD)tableTh+="<th>date</th>";
		if(ConfigFlagHtml)sb.append(comType);
		sb.append(tableTh+"</tr>\n");
		SimpleDateFormat sdf1 = new SimpleDateFormat("yy/MM/dd HH:mm:ss");
		Date date1 = new Date();
		String pDate="";
		ConcurrentHashMap<Integer,Integer> vpc = new ConcurrentHashMap<Integer,Integer>();
		Integer vpcmax=1;
		for (int i = 0 ; i < content.size() ; i++){
			lda = content.get(i);
			line = lda.split("<>");
			try{
				vpos=parStringInteger(line[3]);
				vpos=vpos/100;
				if(vpos/60<10){ops="0";}else{ops="";}
				if(vpos%60<10){opa="0";}else{opa="";}
				if(vpc.containsKey(vpos)){
					vpc.replace(vpos,vpc.get(vpos)+1);
					if(vpcmax<vpc.get(vpos))vpcmax=vpc.get(vpos);
				}else{
					vpc.put(vpos,1);
				}
				date1 = new Date(parStringLong(line[4])*1000);
				pDate = sdf1.format(date1);
				sb.append("<tr><td>"+line[2]+"</td>");
				sb.append("<td>"+ops + vpos/60+":"+opa + vpos%60+"<!--("+vpc.get(vpos)+")--></td>");
				sb.append("<td>"+line[5]+"</td>");
				sb.append("<td>"+line[6]+"</td>");
				if(ConfigFlagHtml && ConfigFlagComD)sb.append("<td>"+pDate+"</td>");
				sb.append("</tr>\n");
			} catch (ArrayIndexOutOfBoundsException e) {
				sb.append("<tr><td>???</td><td>???</td>");
				sb.append("<td>???</td><td>???</td></tr>");
			}
		}
		sb.append("</table>\n");
		sb.append("<!--size"+vpc.size()+"(max"+vpcmax+")-->\n");
		return new String(sb);
	}
	private String htmlFilterString(ArrayList<String> content){
		if(content.size() == 0)return "NoData";
		StringBuffer sb = new StringBuffer();
		String[] linedata = new String[10];
		String line = "";
		sb.append("Filter@/"+content.size()+"<br>\n<table width=\"100%\" border=0 class=\"sortable\" id=\"comm\">\n"+
			"<tr><th>num</th><th>uO(souce)</th><th>u(destination)</th></tr>\n");
		for (int i = 0 ; i < content.size() ; i++){
			line = content.get(i);
			linedata = line.split("<>");
			sb.append("<tr><td>"+linedata[0]+"</td><td>"+linedata[1]+"</td><td>"+linedata[2]+"</td></tr>\n");
		}
		sb.append("</table>\n");
		return new String(sb);
	}
	private Long htmlLocalTime(String _time){
		if(_time == null)return 0l;
		_time = _time.replaceAll("F",":").replaceAll("@"," ");
		_time = _time.replaceAll("|\\+09:00","").replaceAll("T"," ");
		_time = _time.replaceAll("\\-|N|","/");
		SimpleDateFormat format = new SimpleDateFormat();
		format.applyPattern("yyyy/MM/dd HH:mm:ss");
		Date d = new Date();
		try{d = format.parse(_time);}catch(Exception e){}
		return d.getTime() / 1000;
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
		private ArrayList<String> getLiveList(HttpRequestHeader requestHeader,String tab)throws IOException {
		ArrayList<String> arraylist = getLiveRss(requestHeader,tab,1);
		ArrayList<String> arraylist_temp=null;
		if(arraylist != null){
			for(int i=2;i<8;i++){
				arraylist_temp = getLiveRss(requestHeader,tab,i);
				if(arraylist_temp != null){
					arraylist.addAll(arraylist_temp);
					arraylist_temp=null;
				}
			}
		}
		return arraylist;
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private String convUnescape(String str){
		String spstr[] = new String[2];
		StringBuffer sb = new StringBuffer();
		str = str.replaceAll("\\\\u","<>0x").replaceAll("\\\\/","/");
		spstr = str.split("<>");
		for(int i = 0;i<spstr.length;i++){
			if(spstr[i].length()==6 && spstr[i].startsWith("0x")){
				int iHex = Integer.decode(spstr[i]);
				char ci = (char)iHex;
				sb.append(ci);
			}else if(spstr[i].length()>6 && spstr[i].startsWith("0x")){
				int iHex = Integer.decode(spstr[i].substring(0,6));
				char ci = (char)iHex;
				sb.append(ci);
				sb.append(spstr[i].substring(6,spstr[i].length()));
			}else{
				sb.append(spstr[i]);
			}
		}
		return new String(sb);
	}
	private ConcurrentHashMap<String, String> getMyListMap(HttpRequestHeader req,String id)throws IOException {
		ConcurrentHashMap<String, String> newMap = new ConcurrentHashMap<String, String>();
		ConcurrentHashMap<String, String> mapData = new ConcurrentHashMap<String, String>();
		String str = getHttpRespons(req,URL_MYLIST+id+"?rss=2.0",false);
		Pattern pattern    = Pattern.compile("<item>(.+?)</item>",Pattern.DOTALL);
		Pattern pat_watch  = Pattern.compile("<link>"+URL_WATCH+"(.+)?</link>");
		Pattern pat_title  = Pattern.compile("<title>(.+?)</title>");
		Pattern pat_memo   = Pattern.compile("<p class=\"nico-memo\">(.+?)</p>");
		Pattern pat_desc   = Pattern.compile("<p class=\"nico-description\">(.+?)</p>");
		Pattern pat_length = Pattern.compile("<strong class=\"nico-info-length\">(.+?)</strong>");
		Pattern pat_data   = Pattern.compile("<strong class=\"nico-info-date\">(.+?)</strong>");
		Pattern pat_alltitle = Pattern.compile("<title>}CXg\\s+(.+?)\\s+].+?</title>");
		Pattern pat_crea     = Pattern.compile("<dc:creator>(.+?)</dc:creator>");
		Pattern pat_alldesc  = Pattern.compile("<description>(.+?)</description>");
		Matcher m = pattern.matcher(str);
		Matcher m_at = null;
		Matcher m_ad = null;
		Matcher m_ac = null;
		Matcher m_t = null;
		Matcher m_w = null;
		Matcher m_d = null;
		Matcher m_m = null;
		Matcher m_l = null;
		Matcher m_d2 = null;
		Integer count = 1;
		String smid = "";
		String line = "";
		m_at  = pat_alltitle.matcher(str);if(m_at.find()) newMap.put("title",m_at.group(1));
		m_ac  = pat_crea.matcher(str);    if(m_ac.find()) newMap.put("creator",m_ac.group(1));
		m_ad  = pat_alldesc.matcher(str); if(m_ad.find()) newMap.put("desc",m_ad.group(1));
		while(m.find()){
			line = m.group(1);
			m_w  = pat_watch.matcher(line);if(m_w.find()) smid = m_w.group(1);
			m_m  = pat_memo.matcher(line);if(m_m.find()) mapData.put("memo",m_m.group(1));
			m_t  = pat_title.matcher(line);if(m_t.find()) mapData.put("title",m_t.group(1));
			m_d  = pat_desc.matcher(line);if(m_d.find()) mapData.put("desc",m_d.group(1));
			m_l  = pat_length.matcher(line);if(m_l.find()) mapData.put("len",m_l.group(1));
			m_d2 = pat_data.matcher(line);if(m_d2.find())mapData.put("data",m_d2.group(1));
			mapData.put("count",count+"");
			newMap.put(smid,mapData.toString());
			count++;
		}
		return newMap;
	}
	/*private String {
	}*/
	/*private String {
	}*/
	/*private String {
	}*/
	/*private String {
	}*/
	/*private String {
	}*/
	/*private String {
	}*/
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private ArrayList<String> getApiDataCommentTSplit(String content){
		int count=1;
		Pattern pattern = Pattern.compile("^[\\s\\S]*?<chat([^>]+>[\\s\\S]+?)</chat>([\\s\\S]+)$");
		ArrayList<String> newList = new ArrayList<String>();
		String line ="";
		while (true) {
			Matcher m = pattern.matcher(content);
			if (m.matches()) {
				line = m.group(1);
				line = line.replaceAll("<>","<,>").replaceAll("premium=\"1\" ","");
				line = line.replaceAll("(date=\"[^\"]+\")\\s+fork=\"1\"","$1 mail=\"null\"").replaceAll(" fork=\"1\"","");
				line = line.replaceAll("\\s[^\"]+\"([^\"]+)\"","$1<>");
				line = line.replaceAll("<>>","<>");
				newList.add(count+"<>"+line);
				content = m.group(2);
				count += 1;
			} else {
				break;
			}
		}
		return newList;
	}
	private ArrayList<String> getApiDataCommentNSplit(String content){
		int count=1;
		Pattern pattern = Pattern.compile("^[\\s\\S]*?(<chat[^>]+>[\\s\\S.]+?)</chat>([\\s\\S]+)$");
		ArrayList<String> newList = new ArrayList<String>();
		String line ="";
		while (true) {
//<chat thread="1173108780" no="3678606" vpos="17781" date="1277118807" mail="184 #00cccc" user_id="5cuuR7eB5EXUApUe8rmHEqqUlDQ" premium="1" anonymity="1">
			Matcher m = pattern.matcher(content);
			if (m.matches()) {
				line = m.group(1).replaceAll("<>","<,>").replaceAll("fork=\"1\" ","");
				line = line.replaceAll("^<chat","").replaceAll("(date=\"[^\"]+\") user_id=\"","$1 mail=\"null\" user_id=\"");
				line = line.replaceAll("user_id=\"([^\"]+\") premium=\"1\"","user_id=\"(p) $1").replaceAll(" anonymity=\"1\"","");
				line = line.replaceAll("\\s[^\"]+\"([^\"]+)\">?","$1<>");
				newList.add(count+"<>"+line);
				content = m.group(2);
				count += 1;
			} else {
				break;
			}
		}
		return newList;
	}
	private String getApiDataCommentN(HttpRequestHeader requestHeader,ConcurrentHashMap<String, String> getMap,String smid) throws IOException {
		String data="No Data";
		if (getMap == null) return data;
		if(COMMENT_N_GDATA.containsKey(smid)){
			if(ConfigFlagMakeLog3)loginfo1("Already Cached(N)...");
			return COMMENT_N_GDATA.get(smid);
		}
		String resfrom="1000";
		String postData =
			"<packet><thread fork=\"0\" user_id=\""+getMap.get("user_id")+"\" "+
			"res_from=\"-"+resfrom+"\" version=\"20061206\" "+
			"thread=\""+getMap.get("thread_id")+"\" /></packet>";
		String url = getMap.get("ms");
		if (url == null) return data;
		byte[] buf = getCommentContent(requestHeader, url, postData);
		if (buf == null) return data;
		String content = new String(buf, "utf-8");
		content=content.replaceAll("></chat>","> </chat>");
		content=content.replaceAll("\\n|\\r","");
		if(ConfigFlagGDataCache)COMMENT_N_GDATA.put(smid,content);
		return content;
	}
	private String getApiDataCommentT(HttpRequestHeader requestHeader,ConcurrentHashMap<String, String>getMap,String smid) throws IOException {
		String data="No Data";
		if (getMap == null) return data;
		if(COMMENT_T_GDATA.containsKey(smid)){
			if(ConfigFlagMakeLog3)loginfo1("Already Cached(T)...");
			return COMMENT_T_GDATA.get(smid);
		}
		String postData =
			"<packet><thread fork=\"1\" user_id=\""+getMap.get("user_id")+"\" "+
			"res_from=\"-1000\" version=\"20061206\" "+
			"thread=\""+getMap.get("thread_id")+"\" /></packet>";
		String url = getMap.get("ms");
		if (url == null) return data;
		byte[] buf = getCommentContent(requestHeader, url, postData);
		if (buf == null) return data;
		String content = new String(buf, "utf-8");
		content=content.replaceAll("></chat>","> </chat>");
		content=content.replaceAll("\\n|\\r","");
		if(ConfigFlagGDataCache)COMMENT_T_GDATA.put(smid,content);
		return content;
	}
	private String getApiLiveDataComment(HttpRequestHeader requestHeader,String url,String port,String thread) throws IOException {
		String postData ="<thread thread=\""+thread+"\" version=\"20061206\" res_from=\"-1000\" />";
		return getCommentContentSocket(requestHeader,url,port,postData);
	}
	private ConcurrentHashMap<String, String> getPostUrl(ConcurrentHashMap<String, String>mapFlv,String content){
		ConcurrentHashMap<String, String> newMap = new ConcurrentHashMap<String, String>();
		Pattern patTicket = Pattern.compile("ticket=\"([^>]+?)\"");
		Pattern patLastres = Pattern.compile("last_res=\"([^>]+?)\"");
		Matcher m = patTicket.matcher(content);
		String lastr="";
		if(m.find()){
			newMap.put("ticket",m.group(1));
		}
		m = patLastres.matcher(content);
		if(m.find()){
			newMap.put("lastres",m.group(1));
		}else{
			lastr=null;
		}
		if(lastr == "null")newMap.put("lastres","0");
		int comLast=parStringInteger(newMap.get("lastres"));
		newMap.put("blockno",comLast/100+"");
		newMap.put("posturl",URL_API_POSTKEY+"block_no="+newMap.get("blockno")+"&thread="+mapFlv.get("thread_id"));
		return newMap;
	}
	private ConcurrentHashMap<String, String> getFlvData(HttpRequestHeader requestHeader, String id)throws IOException {
		String str="";
		if(FLV_GDATA.containsKey(id)){
			if(ConfigFlagMakeLog3)loginfo1("Already Cached(FLV)...");
//			if(ConfigFlagMakeLog3)loginfo1(FLV_GDATA.get(id));
			str=FLV_GDATA.get(id);
		}else{
			str = getHttpRespons(requestHeader,URL_API_FLV+id+"?as3=1",false);
			if(str.startsWith("error=")){
				if(ConfigFlagMakeLog3)loginfo1("Access Locked/NoCacheFlvData...");
				return null;
			}else{
				if(ConfigFlagGDataCache)FLV_GDATA.put(id,str);
			}
		}
		ConcurrentHashMap<String, String> getMap = new ConcurrentHashMap<String, String>();
		Pattern pattern = Pattern.compile("^([^&=]+)=([^&=]+)(?:&(.*))?$");
		while (str != null) {
			Matcher m = pattern.matcher(str);
			if (m.matches()) {
//				getMap.put(m.group(1),m.group(2));
				getMap.put(URLDecoder.decode(m.group(1), "utf-8"),
						URLDecoder.decode(m.group(2), "utf-8"));
				str = m.group(3);
			} else {
				return null;
			}
		}
		return getMap;
	}
	private ConcurrentHashMap<String, String> getInfoData(HttpRequestHeader requestHeader, String id)throws IOException {
		String str = getHttpRespons(requestHeader,URL_API_INFO+id,false);
		str = str.replaceAll(" lock=\"1\"","");
		for(int i=1;i<11;i++){
			str = str.replaceFirst("<tag(\\s|>)",("<tag"+i+"$1"));
		}
		ConcurrentHashMap<String, String> getMap = new ConcurrentHashMap<String, String>();
		Pattern xmlpat = Pattern.compile("<([^>]+)>([^<]+)</[^>]+>");
		Matcher m = xmlpat.matcher(str);
		while(m.find()){
			getMap.put(m.group(1),m.group(2));
		}
		return getMap;
	}
	private ConcurrentHashMap<String, String> getLiveAPIFlvData(HttpRequestHeader requestHeader, String id)throws IOException {
		String str = getHttpRespons(requestHeader,URL_API_LIVE_FLV+id,false);
		ConcurrentHashMap<String, String> getMap = new ConcurrentHashMap<String, String>();
		Pattern pattern = Pattern.compile("^([^&=]+)=([^&=]+)(?:&(.*))?$");
		while (str != null) {
			Matcher m = pattern.matcher(str);
			if (m.matches()) {
				getMap.put(URLDecoder.decode(m.group(1), "utf-8"),
						URLDecoder.decode(m.group(2), "utf-8"));
				str = m.group(3);
			} else {
				return null;
			}
		}
		return getMap;
	}
	private ConcurrentHashMap<String, String> getLiveAPIInfoData(HttpRequestHeader requestHeader, String id)throws IOException {
		String str = getHttpRespons(requestHeader,URL_API_LIVE_INFO+id,false);
		ConcurrentHashMap<String, String> getMap = new ConcurrentHashMap<String, String>();
		Pattern xmlpat = Pattern.compile("<([^>]+)>([^<>/]+)</[^>]+>");
		Matcher m = xmlpat.matcher(str);
		while(m.find()){
			getMap.put(m.group(1),m.group(2));
		}
		if(getMap.containsKey("code")){
			return null;
		}else{
			return getMap;
		}
	}
	private ArrayList<String> getApiDataConfigFilter(HttpRequestHeader requestHeader, String id)throws IOException {
		String str = getHttpRespons(requestHeader,URL_API_CONFIG_FILTER+id,false);
		ArrayList<String> newList = new ArrayList<String>();
		Pattern xmlpat = Pattern.compile("<ngword><[^>]+>(.+?)</[^>]+><[^>]+>(.+?)</[^>]+></ngword>");
		Matcher m = xmlpat.matcher(str);
		int count=0;
		while(m.find()){
			count++;
			newList.add(count+"<>"+m.group(1)+"<>"+m.group(2));
		}
		return newList;
	}
	private ArrayList<String> getSeigaBbsList(HttpRequestHeader requestHeader, String id)throws IOException {
		//http://seiga.nicovideo.jp/api/theme/data?theme_id=600
		String str = getHttpRespons(requestHeader,URL_API_SEIGA_LIST+"?theme_id="+id,false);
		ArrayList<String> newList = new ArrayList<String>();
		Pattern xmlpat = Pattern.compile("<image_id>(\\d+)</image_id>");
		Matcher m = xmlpat.matcher(str);
		int count=1;
		while(m.find()){
			newList.add(count+"<>"+m.group(1));
			count+=1;
		}
		return newList;
	}
	private ArrayList<String> getSeigaBbsName(HttpRequestHeader requestHeader, String id)throws IOException {
		String str = getHttpRespons(requestHeader,URL_API_SEIGA_INFO+"?id="+id,false);
		String title="";
		String content="";
		String created="";
		String update="";
		ArrayList<String> newList = new ArrayList<String>();
		Pattern xml_tit_pat = Pattern.compile("<title>(.+?)</title>");
		Pattern xml_con_pat = Pattern.compile("<content>(.+?)</content>");
		Pattern xml_cda_pat = Pattern.compile("<created>(.+?)</created>");
		Pattern xml_uda_pat = Pattern.compile("<updated>(.+?)</updated>");
		Matcher m = xml_tit_pat.matcher(str);
		while(m.find()){title = m.group(1);}
		m = xml_con_pat.matcher(str);
		while(m.find()){content = m.group(1);}
		m = xml_cda_pat.matcher(str);
		while(m.find()){created = m.group(1);}
		m = xml_uda_pat.matcher(str);
		while(m.find()){update = m.group(1);}
		newList.add(title);newList.add(content);newList.add(created);newList.add(update);
		return newList;
	}
	private ArrayList<String> getLiveNgAPIData(HttpRequestHeader requestHeader, String id)throws IOException {
		String str = getHttpRespons(requestHeader,URL_API_LIVE_NG+id+"&mode=get",false);
		ArrayList<String> newList = new ArrayList<String>();
		Pattern xmlpat = Pattern.compile("(<ngclient[^>]+>.+?</ngclient>)");
		Matcher m = xmlpat.matcher(str);
		while(m.find()){
			newList.add(m.group(1));
		}
		return newList;
	}
	private ArrayList<String> getCommunity(HttpRequestHeader requestHeader)throws IOException {
		String str = getHttpRespons(requestHeader,URL_COMYU,false);
		ArrayList<String> newList = new ArrayList<String>();
		ArrayList<String> newList_t = new ArrayList<String>();
		Pattern pattern = Pattern.compile("<a[^>]+href=\"/community/([^\"]+)\"[^>]+>([^<].+?)</a>");
		Matcher m = pattern.matcher(str);
		int count=1;
		COLIST_PAT.clear();
		Pattern pat = null;
		while(m.find()){newList.add(count+"<>"+m.group(1)+"<>"+m.group(2)+"<>");count+=1;
		pat = Pattern.compile("^"+m.group(1)+"$");COLIST_PAT.add(pat);}
		if(newList != null){
			str = getHttpRespons(requestHeader,URL_COMYU+"?page=2",false);
			m = pattern.matcher(str);
			while(m.find()){newList_t.add(count+"<>"+m.group(1)+"<>"+m.group(2)+"<>");count+=1;
			pat = Pattern.compile("^"+m.group(1)+"$");COLIST_PAT.add(pat);}
			if(newList_t != null){
				newList.addAll(newList_t);newList_t=null;
				str = getHttpRespons(requestHeader,URL_COMYU+"?page=3",false);
				m = pattern.matcher(str);
				while(m.find()){newList_t.add(count+"<>"+m.group(1)+"<>"+m.group(2)+"<>");count+=1;
				pat = Pattern.compile("^"+m.group(1)+"$");COLIST_PAT.add(pat);}
				if(newList_t != null){
					newList.addAll(newList_t);newList_t=null;
					str = getHttpRespons(requestHeader,URL_COMYU+"?page=4",false);
					m = pattern.matcher(str);
					while(m.find()){newList_t.add(count+"<>"+m.group(1)+"<>"+m.group(2)+"<>");count+=1;
					pat = Pattern.compile("^"+m.group(1)+"$");COLIST_PAT.add(pat);}
					if(newList_t != null){
						newList.addAll(newList_t);newList_t=null;
						str = getHttpRespons(requestHeader,URL_COMYU+"?page=5",false);
						m = pattern.matcher(str);
						while(m.find()){newList_t.add(count+"<>"+m.group(1)+"<>"+m.group(2)+"<>");count+=1;
						pat = Pattern.compile("^"+m.group(1)+"$");COLIST_PAT.add(pat);}
						if(newList_t != null){
							newList.addAll(newList_t);newList_t=null;
							str = getHttpRespons(requestHeader,URL_COMYU+"?page=6",false);
							m = pattern.matcher(str);
							while(m.find()){newList_t.add(count+"<>"+m.group(1)+"<>"+m.group(2)+"<>");count+=1;
							pat = Pattern.compile("^"+m.group(1)+"$");COLIST_PAT.add(pat);}
							if(newList_t != null){
								newList.addAll(newList_t);newList_t=null;
								str = getHttpRespons(requestHeader,URL_COMYU+"?page=7",false);
								m = pattern.matcher(str);
								while(m.find()){newList_t.add(count+"<>"+m.group(1)+"<>"+m.group(2)+"<>");count+=1;
								pat = Pattern.compile("^"+m.group(1)+"$");COLIST_PAT.add(pat);}
								if(newList_t != null){
									newList.addAll(newList_t);newList_t=null;
								}
							}
						}
					}
				}
			}
		}
		return newList;
	}
	private ArrayList<String> getMyHistory(HttpRequestHeader requestHeader)throws IOException {
		String str = getHttpRespons(requestHeader,URL_MYHISTORY,false);
		ArrayList<String> newList = new ArrayList<String>();
		Pattern pattern = Pattern.compile("<a[^>]+href=\"watch/([^\"]+)\">([^<].+?)</a>");
		Matcher m = pattern.matcher(str);
		int count=1;
		while(m.find()){
			newList.add(count+"<>"+m.group(1)+"<>"+m.group(2)+"<>");
			count+=1;
		}
		return newList;
	}
	private ArrayList<String> getMyMyListList(HttpRequestHeader requestHeader)throws IOException {
		String str = getHttpRespons(requestHeader,URL_API_GROUPMYLIST,false);
		ArrayList<String> newList = new ArrayList<String>();
		StringBuffer jsonpat = new StringBuffer();
		jsonpat.append("\\{\"id\":\"(\\d+)\",\"user_id\":\"\\d+\",\"name\":\"([^\"]*)\",");
		jsonpat.append("\"description\":\"([^\"]*)\",\"public\":\"\\d+\",\"default_sort\":\"\\d+\",");
		jsonpat.append("\"create_time\":(\\d+),\"update_time\":(\\d+),.+?\\}");
		Pattern pattern = Pattern.compile(new String(jsonpat));
		Pattern status = Pattern.compile("\"status\"\\s:\\s\"fail\"");
		Matcher ms = status.matcher(str);
		while(ms.find()){return null;}
		ms = pattern.matcher(str);
		int count=1;
		while(ms.find()){
			newList.add(count+"<>"+ms.group(1)+"<>"+ms.group(2)+"<>"+ms.group(3)+"<>"+ms.group(4)+"<>"+ms.group(5)+"<>");
			count+=1;
		}
		return newList;
	}
	private ArrayList<String> getMyMyList(HttpRequestHeader requestHeader,String id)throws IOException {
		String str = getHttpRespons(requestHeader,URL_API_MYLIST+"?group_id="+id,false);
		ArrayList<String> newList = new ArrayList<String>();
		StringBuffer jsonpat = new StringBuffer();
		jsonpat.append("\\{\"item_type\":\"?(\\d+)\"?,\"item_id\":\"(\\d+)\",");
		jsonpat.append("\"description\":\"([^\"]*)\",\"item_data\":\\{\"video_id\":\"([^\"]+)\",");
		jsonpat.append("\"title\":\"([^\"]*)\",\"thumbnail_url\":\"([^\"]+)\",\"first_retrieve\":(\\d+),");
		jsonpat.append("\"update_time\":(\\d+),\"view_counter\":\"(\\d+)\",\"mylist_counter\":\"(\\d+)\",");
		jsonpat.append("\"num_res\":\"(\\d+)\",\"group_type\":\"([^\"]+)\",\"length_seconds\":\"(\\d+)\",");
		jsonpat.append("\"deleted\":\"(\\d+)\",\"last_res_body\":\"([^\"]*)\",\"watch_id\":\"([^\"]+)\"\\},");
		jsonpat.append("\"watch\":(\\d+),\"create_time\":(\\d+),\"update_time\":(\\d+)\\}");
		Pattern pattern = Pattern.compile(new String(jsonpat));
		Pattern status = Pattern.compile("\"status\"\\s:\\s\"fail\"");
		Matcher ms = status.matcher(str);
		while(ms.find()){return null;}
		ms = pattern.matcher(str);
		StringBuffer line;
		int count=1;
		while(ms.find()){
			line = new StringBuffer();
			line.append(count+"<>"+ms.group(1)+"<>"+ms.group(2)+"<>"+ms.group(3)+"<>"+ms.group(4)+"<>"+ms.group(5)+"<>");
			line.append(ms.group(6)+"<>"+ms.group(7)+"<>"+ms.group(8)+"<>"+ms.group(9)+"<>"+ms.group(10)+"<>");
			line.append(ms.group(11)+"<>"+ms.group(12)+"<>"+ms.group(13)+"<>"+ms.group(14)+"<>"+ms.group(15)+"<>");
			line.append(ms.group(16)+"<>"+ms.group(17)+"<>"+ms.group(18)+"<>"+ms.group(19)+"<> <>");
			newList.add(new String(line));
			count+=1;
		}
		return newList;
	}
	private ArrayList<String> getMyDefMyList(HttpRequestHeader requestHeader)throws IOException {
		String str = getHttpRespons(requestHeader,URL_API_DEFMYLIST,false);
		ArrayList<String> newList = new ArrayList<String>();
		Pattern pattern = Pattern.compile("\\{\"item_type\":\"?(\\d+)\"?,\"item_id\":\"(\\d+)\",\"description\":\"([^\"]*)\",\"item_data\":\\{\"video_id\":\"([^\"]+)\",\"title\":\"([^\"]*)\",\"thumbnail_url\":\"([^\"]+)\",\"first_retrieve\":(\\d+),\"update_time\":(\\d+),\"view_counter\":\"(\\d+)\",\"mylist_counter\":\"(\\d+)\",\"num_res\":\"(\\d+)\",\"group_type\":\"([^\"]+)\",\"length_seconds\":\"(\\d+)\",\"deleted\":\"(\\d+)\",\"last_res_body\":\"([^\"]*)\",\"watch_id\":\"([^\"]+)\"\\},\"watch\":(\\d+),\"create_time\":(\\d+),\"update_time\":(\\d+)\\}");
		Pattern status = Pattern.compile("\"status\"\\s:\\s\"fail\"");
		Matcher ms = status.matcher(str);
		while(ms.find()){return null;}
		ms = pattern.matcher(str);
		int count=1;
		DEFMYLIST_PAT.clear();
		StringBuffer line;
		while(ms.find()){
			line = new StringBuffer();
			line.append(count+"<>"+ms.group(1)+"<>"+ms.group(2)+"<>"+ms.group(3)+"<>"+ms.group(4)+"<>"+ms.group(5)+"<>");
			line.append(ms.group(6)+"<>"+ms.group(7)+"<>"+ms.group(8)+"<>"+ms.group(9)+"<>"+ms.group(10)+"<>");
			line.append(ms.group(11)+"<>"+ms.group(12)+"<>"+ms.group(13)+"<>"+ms.group(14)+"<>"+ms.group(15)+"<>");
			line.append(ms.group(16)+"<>"+ms.group(17)+"<>"+ms.group(18)+"<>"+ms.group(19)+"<> <>");
			newList.add(new String(line));
			count+=1;
			//p^[o^
			Pattern pat = Pattern.compile("^"+ms.group(4)+"$");DEFMYLIST_PAT.add(pat);
		}
		return newList;
	}
	private ArrayList<String> getOpenMylist(HttpRequestHeader requestHeader,String smid,int page)throws IOException {
		String url = URL_OPENLIST+smid+"?page="+page+"&sort=c&order=d";
		String str = getHttpRespons(requestHeader,url,false);
		ArrayList<String> newList = new ArrayList<String>();
		Pattern pattern = Pattern.compile("<a [^>]*href=\"mylist/([^\"]+)[^>]*>(.+?)</a>");
		Matcher m = pattern.matcher(str);
		int count=page*10-10+1;
		while(m.find()){
			newList.add(count+"<>"+m.group(1)+"<>"+m.group(2)+"<>");
			count+=1;
		}
		return newList;
	}
	private ArrayList<String> getMylistRss(HttpRequestHeader requestHeader,String mylistid)throws IOException {
		String url = URL_MYLIST+mylistid+"?rss=2.0&numbers=1";
		String str = getHttpRespons(requestHeader,url,false);
		str=str.replaceAll("<rss[^>]+>","").replaceAll("<>","<,>");
		str=str.replaceAll("(\\[|>)\\s+(\\]|<)","$1$2").replaceAll("\\r|\\n|\\\\r|\\\\n","");
		ArrayList<String> newList = new ArrayList<String>();
		Pattern pattern = Pattern.compile("(<item>.+?</item>)",Pattern.DOTALL);
		Matcher m = pattern.matcher(str);
		String data="";
		int count = 3;
		while(m.find()){
			data=m.group(1);
			data=data.replaceAll("<img[^>]+(http://tn-skr[^\"]+)\"[^>]+>","<>$1<>");
			data=data.replaceAll("<p class=\"nico-description\"></p>","<> <>");
			data=data.replaceAll("</?[^>]+>","<>");
			data=data.replaceAll("<>tag:nicovideo[^<]+<>","<>");
			data=data.replaceAll("<>b<>","<>");
			data=data.replaceAll("<>]]><>","<>");
			data=data.replaceAll("(<>)+","<>");
			data=data.replaceAll("^<>","");
			data=data.replaceAll("<> \\S{2}<>","<>");
			data=data.replaceAll("\\+0900<>http://tn-skr","\\+0900<>null<>http://tn-skr");
			data=data.replaceAll("^(.+)<>(.+?)<>.+?<>(.+?)<>.+?<>(.+?)<>.+?<>(.+?)<>$","$2<>$3<>$4<>$5<>$1<>");
			newList.add(data);
		}
		Object[] oa =newList.toArray();
		newList.clear();
		Arrays.sort(oa);
		for(int i = oa.length-1; i >= 0; i--){
			data=oa[i].toString();
			data=data.replaceAll("^(.+?)<>(.+?)<>(.+?)<>(.+?)<>(.+)<>$","$5<>$1<>$2<>$3<>$4<>");
			newList.add(count+"<>"+data);
			count += 1;
		}
		// rev 16fa
		// pattern = Pattern.compile("<title>}CXg\\s*(.*?)\\]jRjR\\([^<]*?\\)</title>");
		pattern = Pattern.compile("<title>}CXg\\s*(.*?)\\]jRjR</title>");
		m = pattern.matcher(str);
		while(m.find()){
			newList.add(0,"0<>"+m.group(1)+"<> ");
			break;
		}
		pattern = Pattern.compile("<description>([^<]*?)</description><pub");
		m = pattern.matcher(str);
		while(m.find()){
			newList.add(1,"1<>"+m.group(1)+"<> ");
		}
		pattern = Pattern.compile("<dc:creator>(.+?)</dc:creator><lan");
		m = pattern.matcher(str);
		while(m.find()){
			newList.add(2,"2<>"+m.group(1)+"<> ");
		}
		return newList;
	}
	private ArrayList<String> getMyvideoRss(HttpRequestHeader requestHeader,String smid)throws IOException {
//		String url = URL_MYVIDEO+smid+"?rss=2.0";
		String url = URL_NICONICOTOP+"user/"+smid+"/video?rss=2.0";
		String str = getHttpRespons(requestHeader,url,false);
		str=str.replaceAll("\\[\\s+<","[<");
		str=str.replaceAll(">\\s+\\]",">]");
		str=str.replaceAll(">\\s+<","><");
		str=str.replaceAll("<rss[^>]+>","");
		str=str.replaceAll("<>","<,>");
		str=str.replaceAll("((?:\\r)?\\n)+","");
		str=str.replaceAll("^.+?<item>","<item>");
		ArrayList<String> newList = new ArrayList<String>();
		String testa[] = new String[120];
		testa = str.split("</item>");
		String data="";
		int count = 1;
		for (int i = 0 ; i < testa.length-1 ; i++){
			data = testa[i];
			data=data.replaceAll("<img[^>]+(http://tn-skr[^\"]+)\"[^>]+>","<>$1<>");
			data=data.replaceAll("<p class=\"nico-description\"></p>","<> <>");
			data=data.replaceAll("<br/>"," ");
			data=data.replaceAll("<media.+","");
			data=data.replaceAll("(F)?</?[^>]+>((@|\\s)+)?","<>");
			data=data.replaceAll("<>tag:nicovideo[^<]+<>","<>");
			data=data.replaceAll("<>b<>","<>");
			data=data.replaceAll("<>]]><>","<>");
			data=data.replaceAll("(<>)+","<>");
			data=data.replaceAll("^<>","");
			data=data.replaceAll("<>e","");
			data=data.replaceAll("^(.+)<>(.+?)<>$","$2<>$1<>");
			newList.add(data);
		}
		Object[] oa =newList.toArray();
		newList.clear();
		Arrays.sort(oa);
		for(int i = oa.length-1; i >= 0; i--){
			data=oa[i].toString();
			data=data.replaceAll("^(.+?)<>(.+)<>$","$2<>$1<>");
			newList.add(count+"<>"+data);
			count += 1;
		}
		return newList;
	}
	private ArrayList<String> getRankingRss(HttpRequestHeader requestHeader,String rank)throws IOException {
		String url = URL_RANKING+"/"+rank+"?rss=2.0";
		String str = getHttpRespons(requestHeader,url,false);
		int count=1;
		str=str.replaceAll("<rss[^>]+>","").replaceAll("\\r|\\n|\\\\r|\\\\n","").replaceAll("<>","<,>");
		str=str.replaceAll("(\\[|>)\\s+(\\]|<)","$1$2");
		String line ="";
		Pattern pattern = Pattern.compile("(<item>.+?</item>)",Pattern.DOTALL);
		ArrayList<String> newList = new ArrayList<String>();
		Matcher m = pattern.matcher(str);
		while(m.find()){
			line = m.group(1).replaceAll("<>","<,>");
			line=line.replaceAll("<img[^>]+(http://tn-skr[^\"]+)\"[^>]+>","<>$1<>");
			line=line.replaceAll("<p class=\"nico-description\"></p>","<> <>");
			line=line.replaceAll("<br/>"," ");
			line=line.replaceAll("(F)?</?[^>]+>((@|\\s)+)?","<>");
			line=line.replaceAll("<>tag:nicovideo[^<]+<>","<>");
			line=line.replaceAll("<>b<>","<>");
			line=line.replaceAll("<>]]><>","<>");
			line=line.replaceAll("(<>)+","<>");
			line=line.replaceAll("^<>","");
			line=line.replaceAll("<>e","");
			line=line.replaceAll("<>pts.b<>","pts.<>");
			newList.add(count+"<>"+line);
			count+=1;
		}
		// rev 16fa
		// pattern = Pattern.compile("<title>(.+?)\\SjRjR\\(.+?\\)</title><link>[^<]+</link><atom");
		pattern = Pattern.compile("<title>(.+?)\\SjRjR</title><link>[^<]+</link><atom");
		m = pattern.matcher(str);
		while(m.find()){
			newList.add(0,""+m.group(1)+"");
		}
		return newList;
	}
	private ArrayList<String> getRankingTopRss(HttpRequestHeader requestHeader)throws IOException {
		String url = URL_RANKING+"?rss=2.0";
		String str = getHttpRespons(requestHeader,url,false);
		int count=1;
		str=str.replaceAll("<rss[^>]+>","").replaceAll("\\r|\\n|\\\\r|\\\\n","").replaceAll("<>","<,>");
		str=str.replaceAll("(\\[|>)\\s+(\\]|<)","$1$2");
		String line ="";
		Pattern pattern = Pattern.compile("(<item>.+?</item>)",Pattern.DOTALL);
		ArrayList<String> newList = new ArrayList<String>();
		Matcher m = pattern.matcher(str);
		while(m.find()){
			line = m.group(1).replaceAll("<>","<,>");
			line=line.replaceAll("<img[^>]+(http://tn-skr[^\"]+)\"[^>]+>","<>$1<>");
			line=line.replaceAll("<p class=\"nico-description\"></p>","<> <>");
			line=line.replaceAll("<br/>"," ");
			line=line.replaceAll("(F)?</?[^>]+>((@|\\s)+)?","<>");
			line=line.replaceAll("<>tag:nicovideo[^<]+<>","<>");
			line=line.replaceAll("<>b<>","<>");
			line=line.replaceAll("<>]]><>","<>");
			line=line.replaceAll("(<>)+","<>");
			line=line.replaceAll("^<>","");
			line=line.replaceAll("<>e","");
			line=line.replaceAll("<>pts.b<>","pts.<>");
			newList.add(count+"<>"+line);
			count+=1;
		}
		return newList;
	}
	private ArrayList<String> getRelationXML(HttpRequestHeader requestHeader,int page,String id)throws IOException {
		String url = URL_API_RELATION+"?page="+page+"&sort=p&order=d&video="+id;
		//sort̓IXXxpARgrAĐvA}CXgmAefB
		//order͍~dAaB
		String str = getHttpRespons(requestHeader,url,false);
		str=str.replaceAll("\\r|\\n|\\\\r|\\\\n","").replaceAll("<>","<,>");
		Pattern pattern = Pattern.compile("(<video>.+?</video>)",Pattern.DOTALL);
		ArrayList<String> newList = new ArrayList<String>();
		int count =page*15-15+1;
		String line ="";
		Matcher m = pattern.matcher(str);
		while(m.find()){
			line = m.group(1).replaceAll("<>","<,>");
			line=line.replaceAll("<video>","<>");
			line=line.replaceAll("((@|\\s|\\t)+)?</?[^>]+>((@|\\s|\\t)+)?","<>");
			line=line.replaceAll("^(\\s|\\t)+","");
			line=line.replaceAll("(<>)+","<>");
			line=line.replaceAll("^<>","");
			line=line.replaceAll("^[^<>]+?/watch/","");
			newList.add(count+"<>"+line);
			count += 1;
		}
		return newList;
	}
	private ArrayList<String> getLiveRss(HttpRequestHeader requestHeader,String tab,int page)throws IOException {
		String url = URL_LIVE_RECENT+"/rss?tab="+tab+"&sort=start&p="+page;
		String str = getHttpRespons(requestHeader,url,false);
		getLiveCount(tab,str);
		str=str.replaceAll("<rss[^>]+>","").replaceAll("\\r|\\n|\\\\r|\\\\n","").replaceAll("<>","<,>");
		str=str.replaceAll("(\\[|>)\\s+(\\]|<)","$1$2");
		int count=page*18-18+1;
		String line ="";
		Pattern pattern = Pattern.compile("(<item>.+?</item>)",Pattern.DOTALL);
		ArrayList<String> newList = new ArrayList<String>();
		Matcher m = pattern.matcher(str);
		while(m.find()){
			line = m.group(1).replaceAll("<>","<,>");
			line=line.replaceAll("<pubDate>\\S+\\s(\\S+)\\s(\\S+)\\s(\\S+)","$3N$2$1");
			line=line.replaceAll("\\s+\\+0900","<>");
			line=line.replaceAll("NJan","N01").replaceAll("NFab","N02").replaceAll("NMar","N03").replaceAll("NApr","N04");
			line=line.replaceAll("NMay","N05").replaceAll("NJun","N06").replaceAll("NJul","N07").replaceAll("NAug","N08");
			line=line.replaceAll("NSep","N09").replaceAll("NOct","N10").replaceAll("NNov","N11").replaceAll("NDec","N12");
			line=line.replaceAll("<media[^>]+(http://icon[^\\?]+.(jpg|gif|png))[^>]+>","<>$1<>");
			line=line.replaceAll("<dc:creator>[^<]+<[^>]+>","<>").replaceAll("<guid[^>]+>[^<]+</guid>","<>").replaceAll("<category>[^<]+</category>","<>");
			line=line.replaceAll("^(\\s|\\t)+","").replaceAll("</?[^>]+>","<>");
			line=line.replaceAll("(<>)+","<>").replaceAll("^<>","");
			newList.add(count+"<>"+line);
			count += 1;
		}
		return newList;
	}
	private ArrayList<String> getNowLiveList(HttpRequestHeader requestHeader)throws IOException {
		String str = getHttpRespons(requestHeader,URL_LIVE_MY,false);
		str=str.replaceAll("\\r|\\n|\\\\r|\\\\n","").replaceAll("<>","<,>");
		str=str.replaceAll("\\s{3,}","");
		String line ="";
		Pattern pattern = Pattern.compile("<a href=\"(http://live\\.nicovideo\\.jp/watch/[^\"]+)\"\\stitle=\"([^>]+)\"><img[^>]+></a>");
		ArrayList<String> newList = new ArrayList<String>();
		Matcher m = pattern.matcher(str);
		while(m.find()){
			line = m.group(1)+"<>"+m.group(2);
			newList.add(line);
		}
		return newList;
	}
	private ArrayList<String> getGateLiveList(HttpRequestHeader requestHeader)throws IOException {
		String url = "http://live.nicovideo.jp/my";
		String str = getHttpRespons(requestHeader,url,false);
		str=str.replaceAll("\\r|\\n|\\\\r|\\\\n","").replaceAll("<>","<,>");
		str=str.replaceAll("\\s{3,}","");
		String line ="";
		Pattern pattern = Pattern.compile("<a[^>]+href=\"(http://live\\.nicovideo\\.jp/gate/[^\"]+)\"[^>]*>([^(<img)].+?)</a>");
		ArrayList<String> newList = new ArrayList<String>();
		Matcher m = pattern.matcher(str);
		while(m.find()){
			line = m.group(1)+"<>"+m.group(2);
			newList.add(line);
		}
		return newList;
	}
	private ArrayList<String> getNowSigaList(HttpRequestHeader requestHeader)throws IOException {
		String str = getHttpRespons(requestHeader,URL_SEIGA,false);
		str=str.replaceAll("\\r|\\n|\\\\r|\\\\n","").replaceAll("<>","<,>");
		str=str.replaceAll("\\s{3,}","");
		String line ="";
		String sid ="";
		String sid2 ="";
		String sidname ="";
		Pattern pattern = Pattern.compile("<a[^>]+href=\"/bbs/(sg(\\d+))\"[^>]*>([^<].+?)</a>",Pattern.DOTALL);
		ArrayList<String> newList = new ArrayList<String>();
		Matcher m = pattern.matcher(str);
		while(m.find()){
			sid=htmlTabeSort(m.group(2))+m.group(2);
			sid2=m.group(1).replaceAll("\\s","");
			sidname=m.group(3).replaceAll("\\s","");
			line = sid+"<>"+sid2+"<>"+sidname+"<>";
			newList.add(line);
		}
		Object[] oa =newList.toArray();
		newList.clear();
		Arrays.sort(oa);
		String nline="";
		String oline="";
		for(int i =0;i < oa.length; i++){
			nline=oa[i].toString();
			nline=nline.replaceAll("^(.+?)<>(.+?)<>(.+?)<>$","$2<>$3<>$1<>");
			if(!nline.equals(oline)){
				newList.add(nline);
			}
			oline=nline;
		}
		return newList;
	}
	private String getMylistTitle(HttpRequestHeader requestHeader,String id)throws IOException {
		String str = getHttpRespons(requestHeader,URL_THUMB_MYLIST+id,false);
		Pattern pattern = Pattern.compile("<a href=[^>]+><strong>([^<]+)</strong></a>");
		Matcher m = pattern.matcher(str);
		if (m.find()){
			return m.group(1);
		}
		return null;
	}
	private String getOwnerName(HttpRequestHeader requestHeader,String id)throws IOException {
		if(!ConfigFlagOwnerName) return null;
		id=id.replaceAll("^[a-z]+","");
		String str = getHttpRespons(requestHeader,URL_API_OWNERDEL+id,false);
		Pattern pattern = Pattern.compile("<p[^>]+>([^\\s]+) e");
		Matcher m = pattern.matcher(str);
		if (m.find()){
			return m.group(1).replaceAll("<[^>]+>","");
		}
		return null;
	}
	private String getOwnerName2(HttpRequestHeader requestHeader,String id)throws IOException {
		if(!ConfigFlagOwnerName) return null;
		id=id.replaceAll("^[a-z]+","");
		String str = getHttpRespons(requestHeader,URL_USER+id,false);
		Pattern pattern = Pattern.compile("<strong[^>]+>([^\\s]+)</strong> ");
		Matcher m = pattern.matcher(str);
		if (m.find()){
			return m.group(1).replaceAll("<[^>]+>","");
		}
		return null;
	}
	private String getFetch(HttpRequestHeader requestHeader,String videoid)throws IOException {
		if(!ConfigFlagFetcher)return "";
		return getHttpRespons(requestHeader,URL_EXST_FETCH_ALL+"?"+videoid,true);
	}
	private void getFetchJSON(HttpRequestHeader requestHeader,Boolean reflag)throws IOException {
		if(!ConfigFlagFetcher)return;
		FETCHLIST.clear();
		String str = getHttpRespons(requestHeader,URL_EXST_FETCH_ALL+"?json",true);
		String resp[] = new String[10];
		resp = str.split("\n");
		for (int i = 0 ; i < resp.length-1 ; i++){
			Matcher m = FETCH_JSON_PATTERN.matcher(resp[i]);
			if (m.find()){
				FETCHLIST.add((i+1)+"<>"+m.group(2)+"<>"+m.group(1)+"<>"+m.group(3));
			}
		}
		if(!reflag && FETCHLIST.size()==0){
			//loginfo1("Re ReLoad Fetched List@"+fetchNum+"/"+FETCHLIST.size());
			getFetchJSON(requestHeader,true);
		}
	}
	private void getFetchingJSON(HttpRequestHeader requestHeader,Boolean reflag)throws IOException {
		if(!ConfigFlagFetcher)return;
		FETCHINGLIST.clear();
		String str = getHttpRespons(requestHeader,URL_EXST_FETCH_ALL+"?status=all",true);
		String resp[] = new String[10];
		resp = str.split("\n");
		for (int i = 0 ; i < resp.length ; i++){
			Matcher m = FETCHING_JSON_PATTERN.matcher(resp[i]);
			if (m.find()){
				FETCHINGLIST.add((i+1)+"<>"+m.group(2)+"<>"+m.group(1)+"<>"+m.group(3));
			}
		}
		if(!reflag && FETCHINGLIST.size()==0){
			getFetchingJSON(requestHeader,true);
		}
	}
	private void getLiveCount(String tab,String str){
		Pattern pattern = Pattern.compile("<[^>]+total_count>([^<]+)</[^>]+total_count>");
		Matcher m = pattern.matcher(str);
		if (m.find()){
			if(LiveCount.containsKey(tab)){
				LiveCount.remove(tab);
			}
			LiveCount.put(tab,m.group(1));
		}
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private String getCommentContentSocket(HttpRequestHeader requestHeader, String url,String port,String postdata)throws IOException {
		return "";
	}
	//---------------------------------------------------------------------------------------------
	private byte[] getCommentContent(HttpRequestHeader requestHeader, String url, String postData)throws IOException {
		logwindow(url+" @"+postData);//log
		if (url == null) return null;
		byte[] postBin = postData.getBytes("ISO-8859-1");
		HttpRequestHeader header = new HttpRequestHeader(HttpHeader.POST+" "+url+" HTTP/1.1\r\n\r\n");
		header.setMessageHeader("Accept", "*/*");
		header.setMessageHeader("Accept-Encoding", "gzip");
		header.setMessageHeader("Referer", " http://www.nicovideo.jp/swf/nicoplayer.swf?ts=1217587209");
		header.setMessageHeader("x-flash-version", "9,0,124,0");
		header.setMessageHeader("Content-Type", "application/x-www-form-urlencoded");
		header.setMessageHeader("Content-Length", ""+postBin.length);
		header.setMessageHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727; .NET CLR 3.0.04506.30; .NET CLR 1.1.4322)");
		header.setMessageHeader("Connection", "Keep-Alive");
		header.setMessageHeader("Pragma", "no-cache");
		header.setMessageHeader("Cookie", requestHeader.getMessageHeader("Cookie"));
		return postServer(header, postBin);
	}
	private byte[] postServer(HttpRequestHeader requestHeader, byte[] postBin)throws IOException {
		//T[o[ւPOST
		// 𓀂łȂEncoding͍폜
		String acceptEncoding = requestHeader.getMessageHeader("Accept-Encoding");
		if (acceptEncoding != null) {
			acceptEncoding = acceptEncoding.toLowerCase().replaceAll("( *,)?(bzip2|sdch)", "");
			acceptEncoding = acceptEncoding.replaceFirst("^ *," ,"");
			requestHeader.setMessageHeader("Accept-Encoding", acceptEncoding);
		}
		URLResource r = new URLResource(requestHeader.getURI());
		ByteArrayInputStream bin = new ByteArrayInputStream(postBin);
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		r.transferTo(bin, bout, requestHeader, null);
		bin = new ByteArrayInputStream(bout.toByteArray());
		HttpResponseHeader responseHeader = new HttpResponseHeader(bin);
		byte[] bcontent = new byte[bin.available()];
		bin.read(bcontent, 0, bin.available());
		if (responseHeader.getStatusCode() != 200) {
			return null;
		}
		// kĂ
		String contentEncoding = responseHeader.getMessageHeader("Content-Encoding");
		if (contentEncoding != null) {
			contentEncoding = contentEncoding.toLowerCase();
			if (contentEncoding.equals("gzip") ||
					contentEncoding.equals("deflate")) {
				bcontent = decodeGzip(bcontent, contentEncoding);
			} else if (!contentEncoding.equals("identity")) {
				Logger.info("Unknown compress format. save comment failed.");
				return null;
			}
		}
		return bcontent;
	}
	private byte[] decodeGzip(byte[] bcontent, String format) {
		//k𓀂
		BufferedInputStream in = null;
 		ByteArrayOutputStream out = new ByteArrayOutputStream();
		int len;
		byte[] buf = new byte[GZIP_BUF_SIZE];
		try {
			if (format.equals("gzip")) {
				in = new BufferedInputStream(
						new GZIPInputStream(
							new ByteArrayInputStream(bcontent)));
			} else if (format.equals("deflate")) {
				in = new BufferedInputStream(
						new InflaterInputStream(
							new ByteArrayInputStream(bcontent)));
			}
			while ( (len = in.read(buf, 0, GZIP_BUF_SIZE)) != -1) {
				out.write(buf, 0, len);
			}
		} catch (IOException e) {
			return null;
		} finally {
			CloseUtil.close(in);
		}
		return out.toByteArray();
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private String getHttpRespons(HttpRequestHeader requestHeader,String url,Boolean nlflag)throws IOException {
		URLResource r = new URLResource(url);
		r.setFollowRedirects(true);// _CNgǐՂ
		HttpRequestHeader header = new HttpRequestHeader(HttpHeader.GET+" "+url+" HTTP/1.0\r\n\r\n");
		header.setMessageHeader("Accept", "*/*");
		header.setMessageHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727; .NET CLR 3.0.04506.30; .NET CLR 1.1.4322)");
		header.setMessageHeader("Connection", "Keep-Alive");
		header.setMessageHeader("Pragma", "no-cache");
		header.setMessageHeader("Cookie", requestHeader.getMessageHeader("Cookie"));
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		if(nlflag){
			try {
				r.setProxyMyself(); // swfConvert07bȍ~
			} catch (NoSuchMethodError e) {
				r.setProxy("localhost", Integer.getInteger("listenPort"));
			}
		}
		r.transferTo(null, bout, header, null);
		ByteArrayInputStream bin = new ByteArrayInputStream(bout.toByteArray());
		HttpResponseHeader responseHeader = new HttpResponseHeader(bin);
		byte[] bcontent = new byte[bin.available()];
		bin.read(bcontent, 0, bin.available());
		if (responseHeader.getStatusCode() == 404) {
			logwindow(url+" [404] @"+nlflag);return "404";
		}else if (responseHeader.getStatusCode() != 200) {
			logwindow(url+" [NG] @"+nlflag);return "NG";
		}
		if(!url.startsWith(URL_API_LIVE_STREAMINFO))
			logwindow(url+" @"+nlflag);//log
		return new String(bcontent, "utf-8");
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private void loadAllConfig(){
		long lastmod = ConfigFileProp.lastModified();
		//if(ConfigFlagMakeLog2)loginfo1("'config.properties'Mod: "+lastmod+".");
		if (lastmod <= lastModifiedCofigProp){//if(ConfigFlagMakeLog2)loginfo1("unReLoad./'config.properties'.");
		}else{
			if(ConfigFlagMakeLog2)loginfo1("ReLoad./'config.properties'.");
			loadFlag();
			lastModifiedCofigProp = lastmod;
		}
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private void loadConfigFile(){
		long lastmod1 = ConfigFileNI.lastModified();
		long lastmod2 = ConfigFileNT.lastModified();
		long lastmod10 = ConfigFileFa.lastModified();
		long lastmod11 = ConfigFileInfi.lastModified();
//		long lastmod12 = ConfigFileFJ.lastModified();
		if(!ConfigFlagFaMylist)lastmod10=0;
		if(!ConfigFlagInfiMylist)lastmod11=0;
		//---------------------------------------------------------------------------------------------
		if (lastmod1 == 0){//if(ConfigFlagMakeLog2)loginfo1("No ConfigFileNI.");
		}else if (lastmod1 <= lastModifiedCofigNI){//if(ConfigFlagMakeLog2)loginfo1("unReLoad./ConfigFileNI.");
		}else{
			if(ConfigFlagMakeLog2)loginfo1("ReLoad./FileNGID.");
			loadConfigFileNI();
			lastModifiedCofigNI = lastmod1;
		}
		//---------------------------------------------------------------------------------------------
		if (lastmod2 == 0){//if(ConfigFlagMakeLog2)loginfo1("No ConfigFileNT.");
		}else if (lastmod2 <= lastModifiedCofigNT){//if(ConfigFlagMakeLog2)loginfo1("unReLoad./ConfigFileNT.");
		}else{
			if(ConfigFlagMakeLog2)loginfo1("ReLoad./FileNGTITLE.");
			loadConfigFileNT();
			lastModifiedCofigNT = lastmod2;
		}
		//---------------------------------------------------------------------------------------------
		if (lastmod10 == 0){//if(ConfigFlagMakeLog2)loginfo1("No ConfigFileFa.");
		}else if (lastmod10 <= lastModifiedCofigFa){//if(ConfigFlagMakeLog2)loginfo1("unReLoad./ConfigFileFa.");
		}else{
			if(ConfigFlagMakeLog2)loginfo1("ReLoad./FileFaMyList.");
			loadConfigFileFa();
			lastModifiedCofigFa = lastmod10;
		}
		//---------------------------------------------------------------------------------------------
		if (lastmod11 == 0){//if(ConfigFlagMakeLog2)loginfo1("No ConfigFileInfi.");
		}else if (lastmod11 <= lastModifiedCofigInfi){//if(ConfigFlagMakeLog2)loginfo1("unReLoad./ConfigFileInfi.");
		}else{
			if(ConfigFlagMakeLog2)loginfo1("ReLoad./FileInfiMyList.");
			loadConfigFileInfi();
			lastModifiedCofigInfi = lastmod11;
		}
		//---------------------------------------------------------------------------------------------
//		if (lastmod12 == 0){//if(ConfigFlagMakeLog2)loginfo1("No ConfigFileFJ.");
//		}else if (lastmod12 <= lastModifiedCofigFJ){//if(ConfigFlagMakeLog2)loginfo1("unReLoad./ConfigFileFJ.");
//		}else{
//			//if(ConfigFlagMakeLog2)loginfo1("ReLoad./FileFetched.json.");
//			loadConfigFileFJ();
//			lastModifiedCofigFJ = lastmod12;
//		}
		//---------------------------------------------------------------------------------------------
	}
	private void loadConfigFileNI(){
		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(ConfigFileNI), "UTF-8"));
			NGIDLIST.clear();
			String line;
			while ((line = br.readLine()) != null) {
				if (line.length() == 0 || line.startsWith("/") ||
					line.startsWith("#") || line.startsWith(";")) {
					continue;
				} else {
					try {
						Pattern pat = Pattern.compile(line);
						NGIDLIST.add(pat);
					} catch (PatternSyntaxException e) {
					}
				}
			}
		} catch (IOException e) {
		} catch (Exception e) {//loginfo1("???");
		} finally {
			CloseUtil.close(br);
		}
	}
	private void loadConfigFileNT(){
		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(ConfigFileNT), "UTF-8"));
			NGTITLELIST.clear();
			String line;
			while ((line = br.readLine()) != null) {
				if (line.length() == 0 || line.startsWith("/") ||
					line.startsWith("#") || line.startsWith(";")) {
					continue;
				} else {
					try {
						Pattern pat = Pattern.compile(line);
						NGTITLELIST.add(pat);
					} catch (PatternSyntaxException e) {
					}
				}
			}
		} catch (IOException e) {
		} catch (Exception e) {//loginfo1("???");
		} finally {
			CloseUtil.close(br);
		}
	}
	private void loadConfigFileFa(){
		if(!ConfigFlagFaMylist)return;
		BufferedReader br = null;
		int count=1;
		FALIST_MY_PAT.clear();
		String Slist[] = new String[10];
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(ConfigFileFa), "UTF-8"));
			FAMYLISTLIST.clear();
			String line;
			while ((line = br.readLine()) != null) {
				if (line.length() == 0 || line.startsWith("/") ||
					line.startsWith("}") || line.startsWith("{")) {
					continue;
				} else {
					if(count<90000){
						Slist=line.split("<>");
						try {
							Pattern pat = Pattern.compile("^"+Slist[0]+"$");
							FALIST_MY_PAT.add(pat);
						} catch (PatternSyntaxException e) {
						}
						FAMYLISTLIST.add(count+"<>"+line+"<> <> <>");
					}
					count+=1;
				}
			}
		} catch (IOException e) {
		} catch (Exception e) {//loginfo1("???");
		} finally {
			CloseUtil.close(br);
		}
	}
/*	private void loadConfigFileFJ(){
		BufferedReader br = null;
		fetchNum=0;
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(ConfigFileFJ), "UTF-8"));
			String line;
			while ((line = br.readLine()) != null) {
				if (line.length() == 0 || line.startsWith("/") ||
					line.startsWith("}") || line.startsWith("{")) {
					continue;
				} else {
					fetchNum+=1;
				}
			}
		} catch (IOException e) {
		} catch (Exception e) {//loginfo1("???");
		} finally {
			CloseUtil.close(br);
		}
	}
*/	private void loadConfigFileInfi(){
		if(!ConfigFlagInfiMylist)return;
		BufferedReader br = null;
		int count=1;
		INFILIST_SM_PAT.clear();
		String Slist[] = new String[10];
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(ConfigFileInfi), "UTF-8"));
			INFIMYLISTLIST.clear();
			String line;
			while ((line = br.readLine()) != null) {
				if (line.length() == 0 || line.startsWith("/") ||
					line.startsWith("}") || line.startsWith("{")) {
					continue;
				} else {
					line=line.replaceAll("^\\s*<>","");
					Slist=line.split("<>");
					try {
						Pattern pat = Pattern.compile("^"+Slist[0]+"$");
						INFILIST_SM_PAT.add(pat);
					} catch (PatternSyntaxException e) {
					}
					INFIMYLISTLIST.add(count+"<> <>"+line+"<> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <>");
					count+=1;
				}
			}
		} catch (IOException e) {
		} catch (Exception e) {//loginfo1("???");
		} finally {
			CloseUtil.close(br);
		}
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private void dup_infi(HttpRequestHeader requestHeader,String smid) throws IOException {
		String line="";
		if(INFIMYLISTLIST == null || INFIMYLISTLIST.size()<0){
		}else{
			int numline = IndexInfiList(smid);
			if(numline != -1 && numline < INFIMYLISTLIST.size()){
				line=INFIMYLISTLIST.get(numline);
				INFIMYLISTLIST.remove(numline);
				String newline=wsConfigFileInfi(requestHeader,smid);
				if(newline!=null){
					INFIMYLISTLIST.add(smid+"<>"+newline);
				}else{
					Matcher m = INFI_DELNOT_PAT.matcher(line);
					if (m.find()){
						INFIMYLISTLIST.add(m.group(1)+"[DEL]"+m.group(2)+"<>"+m.group(3));
					}else{
						INFIMYLISTLIST.add(line);
					}
				}
				allWriteInfi();
				return;
			}
		}
	}
	private StringResource saveConfigFileInfi(HttpRequestHeader requestHeader,String smid) throws IOException {
		if(!ConfigFlagInfiMylist)return setResponseText("NG");
		if(matchPattern(INFILIST_SM_PAT,smid)){
			dup_infi(requestHeader,smid);
			return setResponseText("DUPOK");
		}
		OutputStreamWriter fw =null;
		String data=wsConfigFileInfi(requestHeader,smid);
		if(data!=null){
			try {
				fw = new OutputStreamWriter(new FileOutputStream(ConfigFileInfi,true), "UTF8");
				fw.write(data);
			} catch (IOException e) {
			} finally {
				fw.close();
			}
			return setResponseText("OK");
		}else{
			return setResponseText("NG");
		}
	}
	private StringResource saveConfigFileFa(HttpRequestHeader requestHeader,String myid) throws IOException {
		if(!ConfigFlagFaMylist)return setResponseText("NG");
		if(matchPattern(FALIST_MY_PAT,myid)) return setResponseText("DUP");
		OutputStreamWriter fw =null;
		String data=wsConfigFileFa(requestHeader,myid);
		if(data!=null){
			try {
				fw = new OutputStreamWriter(new FileOutputStream(ConfigFileFa,true), "UTF8");
				fw.write(data);
			} catch (IOException e) {
			} finally {
				CloseUtil.close(fw);
			}
			return setResponseText("OK");
		}else{
			return setResponseText("NG");
		}
	}
	private StringResource getthinfo(HttpRequestHeader requestHeader,String videoid) throws IOException {
		ConcurrentHashMap<String, String> mapInfo = getInfoData(requestHeader, videoid);
		return setResponseText(htmlRegexpString(mapInfo.get("description")));
	}
	private String wsConfigFileInfi(HttpRequestHeader requestHeader,String smid) throws IOException {
		if(!ConfigFlagInfiMylist)return null;
		String data="";
		String ftime="";
		String surl="";
		StringBuffer sb = new StringBuffer();
		ConcurrentHashMap<String, String> mapInfo = getInfoData(requestHeader, smid);
		if (mapInfo.containsKey("title")){
			ftime=mapInfo.get("first_retrieve");
			ftime=ftime.replaceAll("\\+09:00","");
			ftime=ftime.replaceAll("T"," ");
			ftime=ftime.replaceAll("\\-","/");
			surl=mapInfo.get("watch_url");
			surl=surl.replaceAll("http://(ext|www).nicovideo.jp/watch/","");
			sb.append(smid);
			sb.append("<>"+mapInfo.get("title"));
			sb.append("<>"+mapInfo.get("thumbnail_url"));
			sb.append("<>"+ftime);
			sb.append("<>"+mapInfo.get("view_counter"));
			sb.append("<>"+mapInfo.get("comment_num"));
			sb.append("<>"+mapInfo.get("mylist_counter"));
			sb.append("<>"+mapInfo.get("length"));
			sb.append("<>"+mapInfo.get("description"));
			sb.append("<>\n");
			return new String(sb);
		}else{
			return null;
		}
	}
	private String wsConfigFileFa(HttpRequestHeader requestHeader,String myid) throws IOException {
		if(!ConfigFlagFaMylist)return null;
		String ret = getMylistTitle(requestHeader,myid);
		if(ret!=null){
			return myid+"<>"+ret+"<><>\n";
		}else{
			return null;
		}
	}
	private StringResource removeConfigFileInfi(String smid){
		if(!ConfigFlagInfiMylist)return setResponseText("NG");
		Boolean data=rsConfigFileInfi(smid);
		if(!data){
			return setResponseText("NG");
		}else{
			allWriteInfi();
			return setResponseText("OK");
		}
	}
	private StringResource removeConfigFileFa(String myid){
		if(!ConfigFlagFaMylist)return setResponseText("NG");
		Boolean data=rsConfigFileFa(myid);
		if(!data){
			return setResponseText("NG");
		}else{
			allWriteFa();
			return setResponseText("OK");
		}
	}
	private Boolean rsConfigFileInfi(String smid){
		if(!ConfigFlagInfiMylist)return false;
		if(INFIMYLISTLIST == null || INFIMYLISTLIST.size()<0){
		}else{
			int line = IndexInfiList(smid);
			if(line != -1 && line < INFIMYLISTLIST.size()){
				INFIMYLISTLIST.remove(line);
				return true;
			}else{
			}
			return false;
		}
		return false;
	}
	private Boolean rsConfigFileFa(String myid){
		if(!ConfigFlagFaMylist)return false;
		if(FAMYLISTLIST == null || FAMYLISTLIST.size()<0){
		}else{
			int line = IndexFaList(myid);
			if(line != -1 && line < FAMYLISTLIST.size()){
				FAMYLISTLIST.remove(line);
				return true;
			}else{
			}
			return false;
		}
		return false;
	}
	private int lastIndexInfiList(String smid){
		Pattern data=null;
		Matcher m = null;
		for(int i=INFIMYLISTLIST.size()-1;i>=0;i--){
			data = Pattern.compile("<>"+smid+"<>");
			m = data.matcher(INFIMYLISTLIST.get(i));
			if (m.find()) {
				return i;
			}
		}
		return -1;
	}
	private int lastIndexFaList(String myid){
		Pattern data=null;
		Matcher m = null;
		for(int i=FAMYLISTLIST.size()-1;i>=0;i--){
			data = Pattern.compile("<>"+myid+"<>");
			m = data.matcher(FAMYLISTLIST.get(i));
			if (m.find()) {
				return i;
			}
		}
		return -1;
	}
	private int IndexInfiList(String smid){
		Pattern data=null;
		Matcher m = null;
		for(int i=0;i<INFIMYLISTLIST.size();i++){
			data = Pattern.compile("<>"+smid+"<>");
			m = data.matcher(INFIMYLISTLIST.get(i));
			if (m.find()) {
				return i;
			}
		}
		return -1;
	}
	private int IndexFaList(String myid){
		Pattern data=null;
		Matcher m = null;
		for(int i=0;i<FAMYLISTLIST.size();i++){
			data = Pattern.compile("<>"+myid+"<>");
			m = data.matcher(FAMYLISTLIST.get(i));
			if (m.find()) {
				return i;
			}
		}
		return -1;
	}
	private void allWriteFa(){
		OutputStreamWriter fw =null;
		StringBuffer sb = new StringBuffer();
		sb.append("//id<>title<>memo<>\n");
		for (String line : FAMYLISTLIST) {
			line=line.replaceAll("^[^<]+<>","");
			line=line.replaceAll("<>( <>)+$","");
			sb.append(line+"\n");
		}
		try {
			fw = new OutputStreamWriter(new FileOutputStream(ConfigFileFa), "UTF8");
			fw.write(new String(sb));
		} catch (IOException e) {
		} finally {
			CloseUtil.close(fw);
			sb=null;
		}
	}
	private void allWriteInfi(){
		OutputStreamWriter fw =null;
		StringBuffer sb = new StringBuffer();
		sb.append("//title<>smid<>img<>time<>view<>com<>mylis<>len<>desc<>\n");
		for (String line : INFIMYLISTLIST) {
			line=line.replaceAll("^[^<]+<>","");
			line=line.replaceAll("<>( <>)+$","");
			line=line.replaceAll("^\\s*<>","");
			sb.append(line+"\n");
		}
		try {
			fw = new OutputStreamWriter(new FileOutputStream(ConfigFileInfi), "UTF8");
			fw.write(new String(sb));
		} catch (IOException e) {
		} finally {
			CloseUtil.close(fw);
			sb=null;
		}
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private ConcurrentHashMap<String,Integer> setAmiVposData(HttpRequestHeader requestHeader,String videoid) throws IOException {
		String commentString="";
		ArrayList<String> commentStringSplit=null;
		String line[] = new String[10];
		ConcurrentHashMap<String,Integer> vpc = new ConcurrentHashMap<String,Integer>();
		ConcurrentHashMap<String, String> mapFlv  = new ConcurrentHashMap<String, String>();
		int vpcmax=1;
		int vpos=0;
		String lda="";
		String oo="";
		mapFlv  = getFlvData(requestHeader,videoid);
		if(mapFlv == null)return null;
		commentString=getApiDataCommentN(requestHeader,mapFlv,videoid);
		if(commentString.startsWith("No "))return null;
		commentStringSplit=getApiDataCommentNSplit(commentString);
		for (int i = 0 ; i < commentStringSplit.size() ; i++){
			lda = commentStringSplit.get(i);
			line = lda.split("<>");
			vpos=parStringInteger(line[3]);
			vpos=vpos/100;
			if(vpcmax<vpos)vpcmax=vpos;
			if(vpos<10){
				oo="0000";
			}else if(vpos<100&&vpos>=10){
				oo="000";
			}else if(vpos<1000&&vpos>=100){
				oo="00";
			}else if(vpos<10000&&vpos>=1000){
				oo="0";
			}else{
				oo="";
			}
			if(vpc.containsKey(oo+vpos)){
				vpc.replace(oo+vpos,vpc.get(oo+vpos)+1);
			}else{
				vpc.put(oo+vpos,1);
			}
		}
		return vpc;
	}
	private void setAmiGData(ConcurrentHashMap<String,Integer> vpc,int lvp){
		String vps=vpc.toString();
		String line[] = new String[10];
		String line2[] = new String[10];
		String vkey="";
		String vval="";
		String vtemp="";
		int vtime=0;
		int vcou=0;
		int vct=0;
		vps=vps.replaceAll("\\{|\\}|\\s","");
		line=vps.split(",");
		Arrays.sort(line);
		AMI_GDATA.clear();
		try{
			int vposdata[] = new int[lvp+5];
			for(int i=0;i<=lvp+4;i++)vposdata[i]=0;
			try{
				for(int i=0;i<line.length;i++){
					line2=line[i].split("=");
					vtemp=line2[0].replaceAll("^0{1,4}","");
					vtime=parStringInteger(vtemp);
					vcou=parStringInteger(line2[1]);
					try{
						vposdata[vtime]=vcou;
					} catch (ArrayIndexOutOfBoundsException e) {
					//	loginfo1("Erroe...-1");
					}
				}
				int chen=100;
				if(lvp<600){
					chen=3;
				}else if(lvp<1200){
					chen=5;
				}else if(lvp<1800){
					chen=8;
				}else if(lvp<2400){
					chen=12;
				}else if(lvp<3000){
					chen=15;
				}else if(lvp<4000){
					chen=20;
				}else if(lvp<5000){
					chen=25;
				}else if(lvp<6000){
					chen=30;
				}else if(lvp<7000){
					chen=40;
				}else if(lvp<10000){
					chen=50;
				}else{
					chen=100;
				}
				try{
					for(int i=0;i<=lvp+3;i++){
						vct+=vposdata[i];
						if(i%chen==0){
							AMI_GDATA.put("t"+i,vct+"");
							vct=0;
						}
					}
				} catch (ArrayIndexOutOfBoundsException e) {
				}
			} catch (ArrayIndexOutOfBoundsException e) {
			}
		} catch (ArrayIndexOutOfBoundsException e) {
		}
	}
	private String saveAmiXMLString(int lvp){
		int chen=100;
		if(lvp<600){
			chen=3;
		}else if(lvp<1200){
			chen=5;
		}else if(lvp<1800){
			chen=8;
		}else if(lvp<2400){
			chen=12;
		}else if(lvp<3000){
			chen=15;
		}else if(lvp<4000){
			chen=20;
		}else if(lvp<5000){
			chen=25;
		}else if(lvp<6000){
			chen=30;
		}else if(lvp<7000){
			chen=40;
		}else if(lvp<10000){
			chen=50;
		}else{
			chen=100;
		}
		StringBuffer sb = new StringBuffer();
		sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
		sb.append("<chart>\n");
		sb.append("\t<series>\n");
		int cc=0;
		for(int i=0;i<=lvp;i++){
			if(i%chen==0){
				sb.append("\t\t<value xid=\""+cc+"\">"+((i/60<10) ? "0" : "")+(i/60)+":"+((i%60<10) ? "0" : "")+(i%60)+"</value>\n");
				cc+=1;
			}
		}
		sb.append("\t</series>\n");
		sb.append("\t<graphs>\n");
		sb.append("\t\t<graph gid=\"1\">\n");
		cc=0;
		for(int i=0;i<=lvp;i++){
			if(i%chen==0){
				if(AMI_GDATA.containsKey("t"+i)){
					sb.append("\t\t\t<value xid=\""+cc+"\">"+AMI_GDATA.get("t"+i)+"</value>\n");
				}else{
					sb.append("\t\t\t<value xid=\""+cc+"\">0</value>\n");
				}
				cc+=1;
			}
		}
		sb.append("\t\t</graph>\n");
		sb.append("\t</graphs>\n");
		sb.append("</chart>\n");
		return new String(sb);
	}
	private String saveAmiSetString(){
		StringBuffer sb = new StringBuffer();
		sb.append("<settings>\n<data_type>xml</data_type>\n<redraw>true</redraw>\n<legend>\n<enabled>false</enabled>\n</legend>\n<plot_area>\n");
		sb.append("<margins>\n<left>30</left>\n<top>10</top>\n<right>10</right>\n<bottom>25</bottom>\n</margins>\n</plot_area>\n<help>\n");
		sb.append("<button>\n<text_color>#000000</text_color>\n<alpha>0</alpha>\n</button>\n<balloon>\n<alpha>80</alpha>\n<width>350</width>\n");
		sb.append("<text_size>11</text_size>\n<text></text>\n</balloon>\n</help>\n<values>\n<y_left>\n<skip_first>true</skip_first>\n");
		sb.append("<min>0</min>\n<max></max>\n</y_left>\n</values>\n<axes>\n<x>\n<tick_length>0</tick_length>\n</x>\n<y_left>\n");
		sb.append("<tick_length>4</tick_length>\n</y_left>\n</axes>\n<graphs>\n<graph>\n<color>#FF0000</color>\n<fill_alpha></fill_alpha>\n");
		sb.append("<balloon_alpha></balloon_alpha>\n</graph>\n<graph>\n<color>#FF0000</color>\n<fill_alpha>30</fill_alpha>\n<balloon_alpha>75</balloon_alpha>\n");
		sb.append("</graph>\n<balloon_text></balloon_text>\n</graphs>\n<guides>\n<guide>\n<start_value></start_value>\n");
		sb.append("<end_value></end_value>\n<color>#FF0000</color>\n<width>1</width>\n<dashed>true</dashed>\n</guide>\n</guides>\n</settings>\n");
		return new String(sb);
	}
	private void saveAmiXML(int lvp){
		OutputStreamWriter fw =null;
		try {
			fw = new OutputStreamWriter(new FileOutputStream(FILEAMIXML), "UTF8");
			fw.write(saveAmiXMLString(lvp));
		} catch (IOException e) {
		} finally {
			CloseUtil.close(fw);
		}
		if(!FILEAMISET.exists()){
			saveAmiSet();
		}
		return;
	}
	private void saveAmiSet(){
		OutputStreamWriter fw =null;
		try {
			fw = new OutputStreamWriter(new FileOutputStream(FILEAMISET), "UTF8");
			fw.write(saveAmiSetString());
		} catch (IOException e) {
		} finally {
			CloseUtil.close(fw);
		}
		return;
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private String convUnixtime(String time,Integer yflag){
		return convUnixtime(parStringLong(time),yflag);
	}
	private String convUnixtime(Long time){
		return convUnixtime(time,1);
	}
	private String convUnixtime(Long time,Integer type){
		SimpleDateFormat sdf1 = null;
		if(type==null || type==0){
			sdf1 = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		}else if(type ==1){
			sdf1 = new SimpleDateFormat("yy/MM/dd HH:mm:ss");
		}else{
			sdf1 = new SimpleDateFormat("HH:mm:ss");
		}
		Date date = new Date();
		if(time !=null && time > 0){
			date = new Date(time*1000);
		}
		return sdf1.format(date);
	}
	private void logwindow2(String mes){
		logcount+=1;
		String keta="";
		if(logcount<10){keta="000";}
		else if(logcount>=10 && logcount<100){keta="00";}
		else if(logcount>=100 && logcount<1000){keta="0";}
		else{}
		logBuffer.append(keta+logcount+" ["+convUnixtime(-1l,2)+"] "+mes+"\n");
		if(logcount>500){
			logBuffer.delete(0,logBuffer.indexOf("\n")+1);
		}
	}
	private void logthwindow2(String mes){
		thlogcount+=1;
		String keta="";
		if(thlogcount<10){keta="000";}
		else if(thlogcount>=10 && thlogcount<100){keta="00";}
		else if(thlogcount>=100 && thlogcount<1000){keta="0";}
		else{}
		thlogBuffer.append(keta+thlogcount+" ["+convUnixtime(-1l,2)+"] "+mes+"\n");
		if(thlogcount>500){
//		if(thlogcount>38){
			thlogBuffer.delete(0,thlogBuffer.indexOf("\n")+1);
		}
	}
	private int parStringInt(String word) {
		try{
			return Integer.parseInt(word);
		} catch (NumberFormatException e) {
			return 0;
		}
	}
	private Integer parStringInteger(String word) {
		try{
			return Integer.parseInt(word);
		} catch (NumberFormatException e) {
			return 0;
		}
	}
	private Long parStringLong(String word) {
		try{
			return Long.parseLong(word);
		} catch (NumberFormatException e) {
			return 0l;
		}
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	// ȉ͕ʃXbh@\
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	public void run(){
		switch(thtype){
			case 1:
				threadAlert1();
				break;
			case 2:
				break;
			default:
				break;
		}
	}
	private void threadAlert1(){
		logwindow("<font Color=\""+thcolor+"\">one second thread start.</font>");
		threadSleepSec(2);
		startAlert();
		logwindow("<font Color=\""+thcolor+"\">one second thread finished.</font>");
		thflag1=false;
	}
	private void startAlert(){
		logthwindow("Alert start!<br>");
		ArrayList<String> list = getAlertAddrPort();
		if(list == null)return;
		logthwindow("addr => "+list.get(0)+"<br>");
		logthwindow("port => "+list.get(1)+"<br>");
		logthwindow("Thread => "+list.get(2)+"<br>");
		logthwindow("-------------------------<br>");
		Socket socket = null;
		InputStreamReader isp = null;
		LVLIST_PAT.clear();
		try{
			socket = new Socket(list.get(0),parStringInt(list.get(1)));
			PrintStream ps = new PrintStream(socket.getOutputStream());
			ps.print("<thread thread=\""+list.get(2)+"\" version=\"20061206\" res_from=\"-200\"/>\0");
			ps.flush();
			String alword="";
			String[] alArray = new String[3];
			String idno ="";
			String idlv ="";
			String idco ="";
			String idus ="";
			String line ="";
			while(true){
				isp = new InputStreamReader(socket.getInputStream());
				BufferedReader br = new BufferedReader(isp);
				StringBuilder sb = new StringBuilder();
				for(int word = 0; (word = br.read()) != 0;) sb.append((char)word);
				alword = sb.toString();
				if(alword.startsWith("<chat")){
					Pattern pno = Pattern.compile("no=\"(\\d+)\"");
					Matcher m = pno.matcher(alword);
					if(m.find()){idno=m.group(1);}else{idno="1";}
					alword = alword.replaceAll("<[^>]+>","");
					alArray = alword.split(",");
					try{idlv = alArray[0];}catch(ArrayIndexOutOfBoundsException e){idlv="lv1";}
					try{idco = alArray[1];}catch(ArrayIndexOutOfBoundsException e){idco="co1";}
					try{idus = alArray[2];}catch(ArrayIndexOutOfBoundsException e){idus="1";}
					line = checkAlert(idno,idlv,idco,idus);
					if(line==null){
						//logthwindow("DEL @"+idlv+"/"+idno+"<br>");
					}else{
						logthwindow(line+"<br>");
					}
				}else if(alword.startsWith("<thread")){
				}else{
				}
			}
		}catch(Exception e){
		}finally{
			try{
				if(isp != null)isp.close();
				if(socket != null)socket.close();
			}catch(Exception ee){}
			logthwindow("A[g~܂B@by"+thtype+"<br>");
			logthwindow("-------------------------<br>");
			return;
		}
	}
	private String checkAlert(String no,String lv,String co,String id){
		StringBuffer seet_no = new StringBuffer();
		StringBuffer sb = new StringBuffer();
//		if(COLIST_PAT.size()<1){
//			return "co list error.../"+COLIST_PAT.size();
//		}
		if(matchPattern(COLIST_PAT,co)){
			seet_no.append(getAlertFlvInfo(lv));
			if(matchPattern(LVLIST_PAT,lv)){
				return null;//d폜
			}else{
				Pattern pat = Pattern.compile("^"+lv+"$");
				LVLIST_PAT.add(pat);
				if(LVLIST_PAT.size()>30)LVLIST_PAT.remove(0);
			}
			sb.append(no+" ");
			if(lv.startsWith("jk")){
				sb.append("jk: <a href=\""+URL_LIVE_WATCH+lv+"\">"+lv+"</a> / ");
			}else{
				lv = "lv"+lv;
				sb.append("lv: <a href=\""+URL_LIVE_WATCH+lv+"\">"+lv+"</a> / ");
			}
			sb.append("co: <a href=\""+URL_COMYU+co+"\">"+co+"</a> ");
			sb.append("<font class=\"TableSortZero\">");
				for(int i=0;9>i+co.length();i++)sb.append("/");
			sb.append("</font>");
			sb.append(" / ");
			sb.append("id: <a href=\""+URL_USER+id+"\">"+id+"</a>");
			sb.append("<font class=\"TableSortZero\">");
				for(int i=0;9>i+id.length();i++)sb.append("/");
			sb.append("</font>");
			sb.append(" / ");
			sb.append("seetono: "+seet_no);
			sb.append("<font class=\"TableSortZero\">");
				for(int i=0;3>i+seet_no.length();i++)sb.append("/");
			sb.append("</font>");
			sb.append(" / ");
			sb.append(getAlertStreamInfo(lv));
			if(false){
				openBrowser(URL_LIVE_WATCH+lv);
			}
		}else{
			return null;
		}
		return new String(sb);
	}
	private StringBuffer getAlertFlvInfo(String lv){
		StringBuffer sb = new StringBuffer();
		String str = "none";
		try{
			str = getHttpRespons(threq,URL_API_LIVE_INFO+"lv"+lv,false);
		}catch(Exception e){
			return (new StringBuffer()).append("???");
		}
		Pattern p_seet = Pattern.compile("<room_seetno>([^<]+?)</room_seetno>");
		Matcher m = p_seet.matcher(str);
		if(m.find()){
			sb.append(m.group(1));
		}else{
			sb.append("??");
		}
		return sb;
	}
	private StringBuffer getAlertStreamInfo(String lv){
		StringBuffer sb = new StringBuffer();
		sb.append("");
		String str = "none";
		try{
			str = getHttpRespons(threq,URL_API_LIVE_STREAMINFO+lv,false);
		}catch(Exception e){
			return sb;
		}
		Pattern p_name = Pattern.compile("<name>([^<]+?)</name>");
		Pattern p_titl = Pattern.compile("<title>(.+?)</title>");
		Pattern p_desc = Pattern.compile("<description>(.+?)</description>");
		Matcher m = p_name.matcher(str);
		if(m.find()){sb.append(m.group(1));}//+" / ");}
//		m = p_titl.matcher(str);if(m.find()){sb.append(m.group(1));}
//		m = p_desc.matcher(str);if(m.find()){sb.append(m.group(1)+"-->");}
		return sb;
	}
	private ArrayList<String> getAlertAddrPort(){
		String str = "none";
		try{
			str = getHttpRespons(threq,URL_API_LIVE_ALERTINFO,false);
		}catch(Exception e){
			logthwindow("Alert Error....<br>");
		}
		if(str.startsWith("none"))return null;
		ArrayList<String> newList = new ArrayList<String>();
		Pattern p_addr   = Pattern.compile("<addr>([^<]+)</addr>");
		Pattern p_port   = Pattern.compile("<port>([^<]+)</port>");
		Pattern p_thread = Pattern.compile("<thread>([^<]+)</thread>");
		Matcher m = p_addr.matcher(str);
		if(m.find()){newList.add(m.group(1));}
		m = p_port.matcher(str);
		if(m.find()){newList.add(m.group(1));}
		m = p_thread.matcher(str);
		if(m.find()){newList.add(m.group(1));}
		newList.add("");newList.add("");newList.add("");
		return newList;
	}
	private void threadSleepSec(int sec){
		logwindow("<font Color=\""+thcolor+"\">one second Thread waits for "+sec+" seconds.</font>");
		try {
			Thread.sleep(sec*1000);
		} catch(InterruptedException e) {
		} catch(Exception e) {
		}
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	private Boolean matchPattern(ArrayList<Pattern> patlist,String comm) {
		for (Pattern pat : patlist) {
			Matcher m = pat.matcher(comm);
			if (m.find()) {
				return true;
			}
		}
		return false;
	}
	private Boolean matchPattern(HashSet<Pattern> patlist,String comm) {
		for (Pattern pat : patlist) {
			Matcher m = pat.matcher(comm);
			if (m.find()) {
				return true;
			}
		}
		return false;
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
	public boolean openBrowser(String url) {
		Desktop desk = Desktop.getDesktop();
		try {
			desk.browse(new URL(url).toURI());
		} catch (Exception ex) {
			return false;
		}
		return true;
	}
	private boolean openDirectory(File file) {
		Desktop desk = Desktop.getDesktop();
		try {
			if (file.isDirectory()) {
				desk.open(file);
			}
		} catch (Exception ex) {
			return false;
		}
		return true;
	}
	//---------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------
}